 /*
	entry.S		- First Level Interrupt Handler and Dispatcher

  Date: $Id: entry.S,v 1.1.2.1 1999/09/28 18:25:42 ptr Exp $ (preliminary)
  ***************************************************************************

  ***************************************************************************
  
  Description:
  Top Level Functions:
  Data Types:
  Special Variables:	
entry_psa_initializer	to initialise the PSA 
entry_virgin_controls   to initialise the Control Registers     
	
  Major Functions:
  Minor Functions:
TraceTableInterrupt	
UnknownInterrupt	
	  Known Bugs:
  Changes:
  1999-09-25 (0.3) Edits to fit into the rest of it.	  	
  1999-07-13 (0.2) Minor edits. ptr	  

  This file is part of Linux/390.

  Written by Peter Schulte-Stracke <Peter.Schulte-Stracke@t-online.de>
  
  Copyright 1999 by Peter Schulte-Stracke. This is free software. Use
  is permitted under the obligations of the GNU General Public License.
  See file COPYRIGHT for details. There is NO warranty.

 */ 

//#include "hw.h"
	.text
	.org 0
	.psize 0
        .global entry_psa_initializer
	.global entry_virgin_controls                
entry_base:
        .using entry_base,r1
        
//#include "asmoffsets.h"		 control blocks --folgt SCHROTT--
        
#define AOF_psa_rst_new_psw  0x0
#define AOFF_psa_mchk_aregs  0x180
#define AOFF_psa_mchk_fpregs  0x160
#define AOFF_psa_ext_sav 2100
#define AOFF_psa_super_1 0x0204
#define AVAL_psa_super_any 0xff
#define AOFF_psa_istack 0x208        
#define AMSK_psa_super_ext 0x02
#define AOFF_psa_ext_code 0x86
#define HW_INTR_TOD_SYNC 0x1203
#define HW_INTR_MFA 0x1000
#define AOFF_psa_tca 0x700
#define AOFF_psa_io_sav 0x07f
#define AMSK_psa_super_io 0x07f
#define AMSK_psa_super_mchk 0x07f
#define AMSK_psa_super_disp 0x07f
#define AOFF_psa_current 0x07f
#define AOFF_task_tss_psw 0x07f
#define ASIZ_task_tss_psw 8
#define AOFF_psa_mchk_old_psw 0x07f
#define AOFF_task_tss_regs 0x07f
#define AOFF_psa_mchk_regs 0x07f
#define AOFF_psa_pgm_sav 0x07f
#define AMSK_psa_super_pgm 0x07f
#define AOFF_psa_pgm_code 0x07f
#define AOFF_psa_pgm_flags 0x07f
#define AMSK_psa_pgm_flags_PER 0x07f
#define AOFF_psa_crwork_devnull 0x07f
#define AOFF_psa_pgm_old_psw 0x07f
#define AOFF_task_tss_regs1 0x07f
#define AOFF_task_tss_regs2 0x07f
#define ASIZ_psa_pgm_sav 0x07f
#define AOFF_psa_rst_sav 0x07f
#define AOFF_psa_rst_flag 0x07f
#define AMSK_psa_super_rst 0x07f
#define AOFF_psa_rst_old_psw 0x08f
#define ASIZ_psa_rst_sav 0x20
#define AOFF_psa_svc_sav 0x07f
#define AMSK_psa_super_svc 0x07f
#define AOFF_psa_super_2 0x07f
#define AMSK_psa_super_ts 0x07f
#define AOFF_psa_rst_new_psw 0x07f
#define AOFF_psa_ext_new_psw 0x07f    
#define ASIZ_hw_psw 8
#define ASIZ_hw_regs 64        
//#include "ptrace.h"			Saved registers--also Linkage Stack
//#include "stack.h"			Stackframe layout, from C compiler

//#include "asm.S"
        
 /*	  -- N O T E S --
  .	The following uses a separate stack for the interrupt handling,
  .	pointed to by `psa.istack' and complemented by `psa.tca'. Registers 
  .	are saved into specific save areas in the PSA, `psa_xxx_sav',if not,
  .	inevitably, by the standard c-prelude onto the stack. Thus I 
  .	refrain from saving the interrupt state into the thread-state
  .	until (i) the IS is unwound again and (ii) it is at least 
  .	probable, that the thread will be pre-empted, i.e. whenever we
  .	are about to enter the Dispatcher. As this state is separately 
  .	saved for each class of interruptions, every FLIH has to either
  .	return from the interrupt or move the interrupt registers into
  .	the thread structure. I see no reason not to save the registers
  .	directly in the thread structure, where they are easily available,
  .	instead of somewhere on the stack. This simplifies the
  .	code, I feel, so the decision to save the registers on the 
  .	kernel-stacks, as well as the use of the kernel-stack in the 
  .	first place, should be re-considered.
  .	That leaves however, the question of service routines, signal 
  .	handlers, and generally all those `exits' which run on the
  .	kernel-stack of their thread. For these alone, state must be 
  .	saved on the kernel-stack. (Much more state, perhaps. I recall that
  .	MVS saves about 1.5K for a suspended SRB.)
  .	I use per-interrupt-class bit-flags in `psa.super' to serialise
  .	use of the interupt-stack. That appears to be simpler than using 
  .	a counter. I use `psa.current' to store the address of the
  .	task_struct for the interrupted process. Incidentally, that's 
  .	precisely the same as PSATOLD in MVS. There are some dark 
  .	allusions to CURRENT in the book by Rubini, thus be it mentioned.
  .	I propose a configure option CONFIG_AFP to account for the 
  .	additional floating point registers on newer processors. The 
  .	AFP bit in CR 0 should be set accordingly.
  .	For pgm and io interrupts I use an internal stack, so as to
  .	(i) allow prioritised io interrupts , and 
  .	(ii) allow for simpler handling of program interrupts, which
  .	represent so manyfold causes, and which are not easily masked. 
  .	Elementary consideration is given to VM external interrupts.
  .	See individual entries for further thoughts(?)
  .	Registers 2-10 are generally not available in the interrupt code.
  .   Known Bugs:       
  .     Generally only simple return from interrupt explicated.
  .     Transfer of control to kernel-stack not yet done.
  .     
  .     Storage Layouts not finalized, viz. ptrace, psa, stack.	
 */
        

 /*     Some useful macros (to use as models)
        The codes for the interrupt classes are:        
        ext, io, mchk, pgm, rst, and svc.
 */     

                           
#define interrupt_prelude(typ)						\
	stm	r11,r1,AOFF_psa_ ## typ ## _sav(0);			\
	basr	r15,0;							\
	using	.,r15;							\
	tm	AOFF_psa_super_1(0),AVAL_psa_super_any;			\
	bo	1f ; /*  nested interrupt, r13 points to a save area */	\
	l	r13,AOFF_psa_istack(0);					\
1:	oi	AOFF_psa_super_1(0),AMSK_psa_super_ ## typ;
	
#define stacking_interrupt_prelude(typ)					\
	stm	r11,r1,AOFF_psa_ ## typ ## _sav(0);			\
	basr	r15,0;							\
	using	.,r15;							\
	tm	AOFF_psa_super_1(0),AVAL_psa_super_any;			\
	bo	1f ; /*  nested interrupt, r13 points to a save area */	\
	l	r13,AOFF_psa_istack(0);					\
1:	oi	AOFF_psa_super_1(0),AMSK_psa_super_ ## typ;
	
		
	
#define setup_interrupt_stack
	
	 /* N.B. as we do not save the interrupt state on the stack,
	 there is presumably little to do here. Once initialized(!),
	 it can be used w/o maintenance. Hopefully I'm correct! */

        
#define second_level_interrupt_handler(address)				\
	sr	r1,r1; 							\
	sr	r11,r11;						\
	la	r12,AOFF_psa_tca(,0);					\
	l	r15,=V(address);					\
	basr	r14,r15; 

        
#define call_dispatcher(typ)                                            \
        ni      AOFF_psa_super_1(0),255-AMSK_psa_super_ ## typ;         \
        l       r10,=V(entry_base);					\
        .using  entry_base,r10;                                         \
        b	Dispatcher; 


	
	/* only the stuff needed to resume eventually the thread and which 
	is saved by the FLIH is considered in the following. 
        Note that save area layout in ptrace.h may change.             */
#define  exit_from_stacking_interrupt(typ)	        
#define exit_from_interrupt(typ)					\
	using	.,r14;							\
	tm	AOFF_psa_super_1(0),255-AMSK_psa_super_ ## typ;		\
	bnz	9f;                                                     \
	stnsm	AOFF_psa_devnull(0),0;					\
	/* the following must be atomic, therefore disabled: */		\
	tm	AOFF_psa_super_1(0),AMSK_psa_super_disp;		\
	bz	9f;							\
	/* the following handles only a standard type: use as a model */\
	l	r1,AOFF_psa_current(,0);				\
	mvc	AOFF_task_tss_psw(ASIZ_hw_psw,r1),AOFF_psa_ ## typ ## _old_psw(0);	\
	stm	r2,r11,AOFF_task_tss_regs+8(r1);			\
	mvc	AOFF_task_tss_regs(16,r1),AOFF_psa_ ## typ ## _sav+20(0); \
	mvc	AOFF_task_tss_regs+44(40,r1),AOFF_psa_ ## typ ## _sav(0);\
	call_dispatcher(typ);                                           \
9:	ni	AOFF_psa_super_1(0),255-AMSK_psa_super_ ## typ;		\
	lm	r11,r1,AOFF_psa_ ## typ ## _sav(0);                     \
	lpsw	AOFF_psa_  ## typ ## _old_psw(0);                        \


	
 /*	First Level Interrupt Handlers
 ---------------------------------------------------------------------------*/ 


	
 /*	External FLIH

	I choose to directly subclass this interrupt.  
 */
	//	XXXX add vm conditions XXXX
entry_external:
	interrupt_prelude(ext)
	setup_interrupt_stack
        /* select handler :                     */
        la      r15,ext_branch_vector	// Timer 
        cli     AOFF_psa_ext_code(0),(HW_INTR_TOD_SYNC >> 8)
        be      1f
        la      r15,4(,r15)		// SIGP and Malfunction Alert
        cli     AOFF_psa_ext_code(0),(HW_INTR_MFA >> 8)
        be      1f
        la      r15,4(,r15)     // classical causes:     interrupt key
        bl      1f
        la      r15,4(,r15)     // modern causes:        service processor
1:      slr     r1,r1
        slr     r11,r11
        l       r12,AOFF_psa_tca(,0)
        l       r15,0(,r15)
        basr    r14,r15
	exit_from_interrupt(ext)


	
 /*	Input / Output First Level Interrupt Handler
	save the channel mask then set it according to priority of iorb
	save interrupt state into ucb.req->iorb (pointed to by io_iparm)
	reenable interruts of higher priority
	cycle through pending interrupts
	pop interrupt, restore old priority
 */	
	
entry_io:
	stacking_interrupt_prelude(io)
	stctl	6,6,8(r1)		/* save the channel mask	*/
	l	r1,AOFF_psa_io_ssid(,0)	/* subchannel to test		*/
	icm	r11,15,AOFF_psa_io_iparm(0)	/* -> ucb		*/
	bz	1f			/* zero: take default iorb	*/
	icm	r14,15,AOFF_ucb_req(r11)	/* current iorb		*/
	bnz	2f			/* unsollicited : default iorb	*/
1:	l	r14,AOFF_psa_io_iorb(,0)
	la	r11,AOFF_psa_io_iorb(,0)
	slr	r0,r0
	st	r0,AOFF_iorb_drv(,r14)	/* indicate this is an unsol-	*/
	st	r0,AOFF_iorb_flags(,r14)/* licited interrupt,		*/
	st	r1,AOFF_iorb_ssid(,14)	/* unsollicited : iorb empty	*/
2:	mvc	AOFF_psa_io_ctl6(1,0),AOFF_iorb_prio(r14)	/* prio */
	la	r11,4(,r11)		/* param for SLIH	*/
	la	r12,AOFF_psa_tca(,0)
	lctl	6,6,AOFF_psa_io_ctl6(0)
3:	tsch	AOFF_iorb_irb(r14)	/* interrupt data		*/
	stosm	AOFF_psa_devnull(0),HW_PSW_IO	/* re-enable		*/
	l	r15,=V(_io_interrupt)	/* goto SLIH			*/
	basr	r14,r15 
	tpi	AOFF_io_cod2(0)		/* more to do ?			*/
	bz	4f			
	la	r11,AOFF_psa_io_ipar2(,0)	/* do not use		*/
	l	r14,AOFF_psa_io_ipar2(,0)	/* psa.io_code , as it	*/
	l	r1,AOFF_psa_io_ssid2(,0)	/* could be destroyed	*/
	b	1b				/* by an interrupt	*/
4:	l	r1,AOFF_psa_io_savpt(,0)
	lctl	6,6,8(r1)		/* old channel mask	*/
	exit_from_stacking_interrupt(io)

	
	 	
 /*	Machine Check First Level Interrupt Handler
 
	Called upon Machine Check Interrupt. See POP.

	Note that we do not need to save registers, as the hardware 
	did this, however, according to POP, we need to validate
	registers before using them.
	Timer-related validations are in  (clock.c).
	Environment:	 disabled	

 */

entry_machine_check:	
       	la	r0,0(0)
   .irp num,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
        lr      r\num,r0
   .endr
	basr	r15,0
	using	.,r15

// control registers:	
	lctl	0,15,virgin_controls
# floating point

#ifdef	CONFIG_AFP		/* using 16 floating point registers */
	ld	0,empty_doublewords
   .irp num,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
        ldr      \num,0
	ldfpc	empty_doublewords
   .endr
#else				// CONFIG_AFP
	ld	0,empty_doublewords
	ldr	2,0
	ldr	4,0
	ldr	6,0
#endif				// CONFIG_AFP
	
	
// access registers			is this the minimal space coding?
	lam	0,3,empty_doublewords	
	lam	4,7,empty_doublewords
	lam	8,11,empty_doublewords
	lam	12,15,empty_doublewords

// back on track
	tm	AOFF_psa_super_1(0),AVAL_psa_super_any
	bo	1f		/* nested interrupt, r13 points to a save area */
	l	r13,AOFF_psa_istack(0)
1:	oi	AOFF_psa_super_1(0),AMSK_psa_super_mchk
	
	setup_interrupt_stack
	second_level_interrupt_handler(_mchk_interrupt)
	
 /*	XXX we resume processing here, that is evidently only possible, 
 	if there has been not too much damage. If that be not the case,
	however, we simply assume, that some unknown helper has already
	unwound the stack for us lazy ones.
        Note that we are disabled anyway.
	       
 */	
	using	.,r14	
	tm	AOFF_psa_super_1(0),255-AMSK_psa_super_mchk
	bnz	9f
        
	tm	AOFF_psa_super_1(0),AMSK_psa_super_disp
	bz	9f

	l	r1,AOFF_psa_current(,0)
	mvc	AOFF_task_tss_psw(ASIZ_hw_psw,r1),AOFF_psa_mchk_old_psw(0)
	mvc	AOFF_task_tss_regs(ASIZ_hw_regs,r1),AOFF_psa_mchk_regs(0)

9:	ni	AOFF_psa_super_1(0),255-AMSK_psa_super_mchk
        lam     0,15,AOFF_psa_mchk_aregs(0)
#ifdef  CONFIG_AFP
        l       r1,AOFF_psa_mchk_extsa(,0)      // extended save area address
//        load_fpr (0(,r1))
#else                                           // CONFIG_AFP
//        load_fpr (AOFF_psa_mchk_fpregs(0))       
#endif                                          // CONFIG_AFP
       	lctl	0,15,AOFF_psa_mchk_cregs(0)
	lm	r0,r1,AOFF_psa_mchk_regs(0)
	lpsw	AOFF_psa_mchk_old_psw(0)
	


 /*	Program First Level Interrupt Handler
	Hmm, the following is so simple that it will work only for some
	exceptional exceptions, viz. trace, suppression-on-protection
	(i.e. copy-on-write conditions), PER, Monitor Call, but more is
	to follow.
 */
	
entry_program:
	interrupt_prelude(pgm)
	setup_interrupt_stack
	/* then branch */ 
        lh      r0,AOFF_psa_pgm_code+1(,0)
        srdl    r0,7
        o       r0,AOFF_psa_pgm_flags(0)   // NB:   bit31:  PER    
        srl     r1,32-7-2       // index into branch-table 
        slr     r1,r1
        slr     r11,r11
        l       r12,AOFF_psa_tca(,0)
        l       r15,pgm_branch_vector(r1)
	basr	r14,r15
        tm      AOFF_psa_pgm_flags+3(0),AMSK_psa_pgm_flags_PER
        bz      1f
        l       r15,pgm_permon_entry
        basr	r14,r15
        exit_from_interrupt(pgm)

	
	
 /*	Restart First Level Interrupt Handler
	What is this good for?
	(My guess:	- restart-able wait state
			- `crtl-alt-del' for mainframes ) 
	This code is *not* executed to start a secondary CPU
	(that's to come in head.S.)

 */	

entry_restart:	
	stm	r11,r1,AOFF_psa_rst_sav(0)
	basr	r15,0
	using	.,r15
	
	ts	AOFF_psa_rst_flag(0)  /* this is necessary, because there is */
	bo	9f		      /* no mask bit for restart	     */
	
	tm	AOFF_psa_super_1(0),AVAL_psa_super_any
	bo	1f
	
	l	r13,AOFF_psa_istack(0)
1:	oi	AOFF_psa_super_1(0),AMSK_psa_super_rst

	interrupt_prelude(rst)
	setup_interrupt_stack
	second_level_interrupt_handler(_external_restart_interrupt)
	mvi	AOFF_psa_rst_flag(0),0	/* completed restart processing	*/
	exit_from_interrupt(rst)
	


	

 /*	Supervisor Call First Level Interrupt Handler

	Much to be done here. 
	
 */	
entry_supervisor:
	interrupt_prelude(svc)
	setup_interrupt_stack
	second_level_interrupt_handler(_svc_interrupt)	
	exit_from_interrupt(svc)


	
		

 /*	DISPATCHER
 ------------------------------------------------------------------------

	The dispatcher is entered upon completion of interrupt processing
	if either a handler at reduced priority is requested (Bottom
	Half) or it has been already determined, that the current thread,
	psa.current, is (perhaps) to be preempted. Note the difference 
	between interruption and preemption.
	
	Environment:	key 0, disabled, real addressing
        Base Register r10:      entry_base
		      r5 :	task_struct(CURRENT)		
 */


Dispatcher:
        using   entry_base,r10

/*
 *	XXX Missing for the moment is the rest of saving, calling the BHs 
 *	and the scheduler, and the setting up of the new stack frames 
 */
Save_State:			// r5-> old task
//	save_fpr (AOFF_task_tss_fpregs(r5))
	stam	0,15,AOFF_task_tss_aregs(r5)
	stpt	AOFF_task_tss_ttr(r5)	

Load_State:			// and so on ..r6->new task.
	spt	AOFF_task_tss_ttr(r6)
	l	r7,AOFF_task_tss_mm(,r6)
	lm	r2,r3,AOFF_mm_cpus(r7)
3:	la	r0,1(,r2)
	lr	r1,r3
	o	r1,AOFF_psa_cpumask(,0)
	cds	r2,r0,AOFF_mm_cpus(r7)
	bne	3b
	stidp   AOFF_task_tss_cpu(r6)     /* CPU number */
	st	r6,AOFF_psa_current(,0)
	mvc	AOFF_psa_disp_psw(ASIZ_hw_psw,0),AOFF_task_tss_psw(r6)
	lam	0,15,AOFF_task_tss_aregs(r6)	/* even if not used	*/
	lctl	1,1,AOFF_task_tss_pstd		
	tm	AOFF_task_tss_DF_1(r1),ABIT_task_tss_PER
	bz	1f
	lctl	9,11,AOFF_task_tss_per_ctl
//1:	load_fpr (AOFF_task_tss_fpregs(r6))
	lm	r0,r15,AOFF_task_tss_regs(r1)
	mvi	AOFF_psa_super_1(0),0	/* definitely */		
	lpsw	AOFF_psa_disp_psw(0)

 /*	SUBROUTINES
 ----------------------------------------------------------------------*/
TraceTableInterrupt:	/* e.g. cyclically switch pages	*/
 	br	r14
UnusedInterrupt:	
	/* kprintf ("your cpoy of POP ist far too old:	 an interrupt occured of which it knows nothing") */
	br	r14
	
 /*	TABLES
 ----------------------------------------------------------------------*/
                                        
ext_branch_vector:       .balign 4      // cave:     sequence 
        .word   _clock_interrupt
        .word   _sigp_interrupt
        .word   _external_interrupt
        .word   _external_service_interrupt
	.word	_io_vm_interrupt
pgm_branch_vector:
	.word	UnusedInterrupt		/* UNUSED			*/
        .word   _pgm_interrupt       //       0001       Operation      
        .word   _pgm_interrupt       //       0002       Privileged oper
        .word   _pgm_interrupt       //       0003       Execute        
        .word   _pgm_interrupt       //       0004       Protection     
        .word   _pgm_interrupt       //       0005       Addressing     
        .word   _pgm_interrupt       //       0006       Specification  
        .word   _pgm_interrupt       //       0007       Data          
        				                                
        .word   _pgm_interrupt       // 8     0008 	 Fixed-pt overflow  
        .word   _pgm_interrupt       //       0009 	 Fixed-point divide
	.word   _pgm_interrupt       //       000A 	 Decimal overflow  
        .word   _pgm_interrupt       //       000B 	 Decimal divide       
        .word   _pgm_interrupt       //       000C 	 HFP exp. overflow
        .word   _pgm_interrupt       //       000D 	 HFP exp. underflow
        .word   _pgm_interrupt       //       000E 	 HFP significance
	.word   _pgm_interrupt       //       000F 	 HFP divide
        				      
        .word   _pgm_interrupt       // 10    0010 	 Segment transl  
        .word   _pgm_interrupt       //       0011 	 Page translation
        .word   _pgm_interrupt       //       0012 	 Translation spec 
        .word   _pgm_interrupt       //       0013 	 Special operation 
	.word	UnusedInterrupt		/* UNUSED  0014			*/
        .word   _pgm_interrupt       //       0015 	 Operand
        .word   TraceTableInterrupt  //       0016 	 Trace table
        .word   _pgm_interrupt       //       0017 	 ASN-transl spec 
        				      
	.word	UnusedInterrupt		/* UNUSED  0018			*/
        .word   _pgm_interrupt       //       0019 	 Vector operation
	.word	UnusedInterrupt		/* UNUSED  001A			*/
	.word	UnusedInterrupt		/* UNUSED  001B			*/
        .word   _pgm_interrupt       //       001C 	 Space-switch event 
        .word   _pgm_interrupt       //       001D 	 HFP square root    
        .word   _pgm_interrupt       //       001E 	 Unnormalized operand
        .word   _pgm_interrupt       //       001F 	 PC-transl spec  

        .word   _pgm_interrupt       // 20    0020 	 AFX translation    
        .word   _pgm_interrupt       //       0021 	 ASX translation    
        .word   _pgm_interrupt       //       0022 	 LX translation     
        .word   _pgm_interrupt       //       0023 	 EX translation
        .word   _pgm_interrupt       //       0024 	 Primary authority
        .word   _pgm_interrupt       //       0025 	 Secondary auth
	.word	UnusedInterrupt		/* UNUSED  0026			*/
	.word	UnusedInterrupt		/* UNUSED  0027			*/
        				      
        .word   _pgm_interrupt       // 28    0028 	 ALET specification 
        .word   _pgm_interrupt       //       0029 	 ALEN translation 
        .word   _pgm_interrupt       //       002A 	 ALE sequence 
        .word   _pgm_interrupt       //       002B 	 ASTE validity
        .word   _pgm_interrupt       //       002C 	 ASTE sequence  
        .word   _pgm_interrupt       //       002D 	 Extended authority 
	.word	UnusedInterrupt		/* UNUSED  002E			*/
	.word	UnusedInterrupt		/* UNUSED  002F			*/
        				      
        .word   _pgm_interrupt       // 30    0030 	 Stack full
        .word   _pgm_interrupt       //       0031       Stack empty        
        .word   _pgm_interrupt       //       0032       Stack specification
        .word   _pgm_interrupt       //       0033       Stack type
        .word   _pgm_interrupt       //       0034       Stack operation
	.word	UnusedInterrupt		/* UNUSED  0035			*/
	.word	UnusedInterrupt		/* UNUSED  0036			*/
	.word	UnusedInterrupt		/* UNUSED  0037			*/

	.word	UnusedInterrupt		/* UNUSED  0038			*/
	.word	UnusedInterrupt		/* UNUSED  0039			*/
	.word	UnusedInterrupt		/* UNUSED  003A			*/
	.word	UnusedInterrupt		/* UNUSED  003B			*/
	.word	UnusedInterrupt		/* UNUSED  003C			*/ 
	.word	UnusedInterrupt		/* UNUSED  003E			*/ 
	.word	UnusedInterrupt		/* UNUSED  003F			*/

pgm_permon_entry:		     // this must handle both conditions
        .word   _trace_permon        //       0040 	 Monitor event
#define PSW(flags,address)\
	.word	flags;\
	.word   address; 


#define SCATTERBLOCK(offset)\
9:	.word	9f;	\
	.word	9f-1f;	\
	.word	offset; \
1:	
#define SCATTERBLOCKEND \
9:	.word	0;\
	.word	0; 
entry_psa_initializer:        

//	SCATTERBLOCK(0)
	.word 1f,8,0
	PSW(0x00680000,entry_restart)        
//      SCATTERBLOCK(88)
1:	.word 2f,40,88
	PSW(0x00680000,entry_external)        
        PSW(0x00680000,entry_supervisor)        
        PSW(0x00680000,entry_program)        
        PSW(0x00680000,entry_machine_check)        
        PSW(0x00680000,entry_io)        
//      SCATTERBLOCK(512)
2:	.word 3f,8,512
	.ascii	"PSA "
	.long	0x01000000	// init flags
//	SCATTERBLOCK(576)
3:	.word	0,16,576
	.long	0x0		// super
	.long	init_task_union	// current
	.long	0		// local_irq_count
	.long	0
        SCATTERBLOCKEND
        /******************************/

entry_virgin_controls:		// most seem to be best left 0x0
	.word 0x00000000	// 0   Miscellaneous flags++
				// this CR should be set to something useful
	.word 0x00000000	// 1  *PSTD
	.word 0x00000000	// 2  *DUCT
	.word 0x00000000	// 3  *PKM,SASN
	.word 0x00000000	// 4  *AUTHX,PASN 
	.word 0x00000000	// 5  *LTD/PASTD
	.word 0xFF000000	// 6   I/O Mask
	.word 0x00000000	// 7  *SSTD
	.word 0x00000000	// 8  *EAX,Monitor mask
	.word 0x00000000	// 9  *PER
	.word 0x00000000	// 10 *PER
	.word 0x00000000	// 11 *PER
	.word 0x00000000	// 12  (*unused*) Trace: needs allocation
	.word 0x00000000	// 13 *HSTD
	.word 0x00000000	// 14  Mchk Mask, ASN-First table	??
	.word 0x00000000	// 15 *Linkage Stack
entry_base_p:   .word entry_base	
empty_doublewords:		// used for lam, too,  which needs this alignment
	.double 0
	.double 0
/* ad interim */

_clock_interrupt:
_pgm_interrupt:	
_trace_permon:			
_external_interrupt:	
_sigp_interrupt:			
_external_service_interrupt:		
_io_interrupt:		
_io_vm_interrupt:	
_mchk_interrupt:	
_external_restart_interrupt:	
_svc_interrupt:	
						
	.ltorg
//	.section .data.psa
//	.space 8096
	.end






















