
--- /tmp/00012128.PO081099.SI134937.X0000218.Y0000000	Fri Sep 10 13:49:37 1999
+++ ./arch/i370/kernel/head.S	Wed Sep  8 15:48:48 1999
@@ -125,48 +125,26 @@
  * sav+24  saved r15
  * sav+28  saved r0
  * sav+32  saved r1
  * sav+36  saved r2
  */

-/* these defines map the struct _i370_interrupt_state_s in <asm/ptrace.h> */
-#define IR_PSW          0x0
-#define IR_R11          0x8
-#define IR_R12          0xc
-#define IR_R13          0x10
-#define IR_R14          0x14
-#define IR_R15          0x18
-#define IR_R0           0x1c
-#define IR_R1           0x20
-#define IR_R2           0x24
-#define IR_R3           0x28    
-#define IR_R4           0x2c
-
-#define IR_R5           0x30
-#define IR_R6           0x34
-#define IR_R7           0x38
-#define IR_R8           0x3c
-#define IR_R9           0x40
-#define IR_R10          0x44
-
-#define IR_CR0          0x48
-#define IR_CR1          0x4c
-#define IR_OLDREGS      0x50
-
 /* -------------------------------------------------------- */
-
 /* stack related offsets; have nothing to do with the above */
+/* -------------------------------------------------------- */
 #define STACK_SIZE      0x94    /* stack size */
 #define ARGS_BASE       STACK_SIZE
 #define ARGS_SIZE       0x4     /* args size */
 #define FRAME_BASE      STACK_SIZE + ARGS_SIZE
 #define FRAME_SIZE      0x60    /* frame size */
 #define SF_SIZE         STACK_SIZE + ARGS_SIZE + FRAME_SIZE
 #define SF_SIZE_LIT     =XL4'000000F8'

+/* -------------------------------------------------------- */
 /* location of saved registers on stack */
+/* -------------------------------------------------------- */
 #define ARGP            ARGS_BASE
 #define SAVED_PSW       FRAME_BASE + IR_PSW
 #define SAVED_R11       FRAME_BASE + IR_R11
 #define SAVED_R12       FRAME_BASE + IR_R12
 #define SAVED_R13       FRAME_BASE + IR_R13
 #define SAVED_R14       FRAME_BASE + IR_R14
@@ -199,25 +177,25 @@
         /* interrupted from user space or kernel space ?             */ \
         L       r1,oldpsw(,0);          /* get old psw flags into r1 */ \
         N       r1,=X'00010000';        /* is in problem state?      */ \
         BZ      1f;                     /* sp is already ok if kern  */ \
         /* interrupted user proc, so need to find a kernel stack     */ \
         LA      sp,0(,r11);             /* addr of curr proc in r13  */ \
-        A       sp,sav-4(,0);           /* add offset to ksp         */ \
+        A       sp,OFFSET_KSP(,0);              /* add offset to ksp         */ \
         L       sp,0(,sp);              /* load kernel sp            */ \
 1:                                      /* branch here if kernel     */ \
         /* we have a valid stack pointer; build a stackframe         */ \
         SL      sp,SF_SIZE_LIT;         /* subtract stackframe size  */ \
         SLR     r3,r3;                  /* zero                      */ \
         ST      r3,4(,sp);              /* terminate stack backchain */ \
         /* move saved regs out of prefix page to stackframe          */ \
         MVC     SAVED_PSW(8,sp),oldpsw(0); /* save old psw on stack  */ \
         MVC     SAVED_R11(64,sp),sav+IR_R11(0); /* 16 regs=64 bytes  */ \
         /* chain the interrupt state pointer into thread_struct      */ \
         LA      r1,0(,r11);             /* addr of curr proc in r1   */ \
-        A       r1,sav-8(,0);           /* add offset to regs ptr    */ \
+        A       r1,OFFSET_KREGS(,0);            /* add offset to regs ptr    */ \
         L       r2,0(,r1);              /* load regs ptr             */ \
         ST      r2,SAVED_OLDREGS(,sp);  /* save regs ptr to stack    */ \
         LA      r2,SAVED_PSW(,sp);      /* put addr of newregs in r2 */ \
         ST      r2,0(,r1);              /* update regs ptr in proc   */ \
         

@@ -232,13 +210,13 @@


 #define EXCEPTION_UNCHAIN(sav)                                          \
         /* chain the interrupt state pointer into thread_struct      */ \
         L       r11,=V(current);        /* addr of current pointer   */ \
         L       r11,0(,r11);            /* addr of current process   */ \
-        A       r11,sav-8(,0);          /* add offset to regs ptr    */ \
+        A       r11,OFFSET_KREGS(,0);           /* add offset to regs ptr    */ \
         L       r2,SAVED_OLDREGS(,sp);  /* get old ptr from stack    */ \
         ST      r2,0(,r11);             /* restore regs ptr in proc  */


 #define EXCEPTION_RETURN(sav)                                           \
         /* get old PSW, restore registers, return from interrupt     */ \
--- /tmp/00012138.PO081099.SI134938.X0000245.Y0000000	Fri Sep 10 13:49:39 1999
+++ ./arch/i370/kernel/mm.c	Wed Sep  8 10:19:29 1999
@@ -155,12 +155,13 @@
 #endif /* CONFIG_BLK_DEV_INITRD */
 }

 __initfunc(void free_initmem(void))
 {
   printk ("do da free_initmem ding \n");
+  irq_init();
 } 

 void si_meminfo(struct sysinfo *val)
 { }

       
--- /tmp/00012148.PO081099.SI134939.X0000240.Y0000000	Fri Sep 10 13:49:39 1999
+++ ./arch/i370/kernel/traps.c	Wed Sep  8 11:01:55 1999
@@ -102,47 +102,43 @@
 }

 /*----------------------------------------------------------------*/
 /* Program Check Handling                                         */
 /*----------------------------------------------------------------*/
    
-static void ei_time_slice(i370_interrupt_state_t *, unsigned short);
-static void pc_reset_trace(i370_interrupt_state_t *,
-                           unsigned short,
-                           unsigned long);
-static void pc_monitor(i370_interrupt_state_t *,
-                       unsigned short,
-                       unsigned long);
-static void pc_unsupported(i370_interrupt_state_t *,
-                           unsigned short,
-                           unsigned long);
+static int pc_monitor(i370_interrupt_state_t *, unsigned long,
+                       unsigned short);
+static int pc_unsupported(i370_interrupt_state_t *,  unsigned long,
+                       unsigned short);
+int do_page_fault(i370_interrupt_state_t *,  unsigned long,
+                  unsigned short);
  
 static pc_handler pc_table[] = {
         {-1,                   pc_unsupported},
         {PIC_OPERATION,        pc_unsupported},
         {PIC_PRIVLEDGED,       pc_unsupported},
         {PIC_EXECUTE,          pc_unsupported},
-        {PIC_PROTECTION,       pc_unsupported},
+        {PIC_PROTECTION,       do_page_fault},
         {PIC_ADDRESSING,       pc_unsupported},
         {PIC_SPECIFICATION,    pc_unsupported},
         {PIC_DATA,             pc_unsupported},
         {PIC_FIXED_OVERFLOW,   pc_unsupported},
         {PIC_FIXED_DIVIDE,     pc_unsupported},
         {PIC_DECIMAL_OVERFLOW, pc_unsupported},
         {PIC_DECIMAL_DIVIDE,   pc_unsupported},
         {PIC_EXP_OVERFLOW,     pc_unsupported},
         {PIC_EXP_UNDERFLOW,    pc_unsupported},
         {PIC_SIGNIFICANCE,     pc_unsupported},
         {PIC_FP_DIVIDE,        pc_unsupported},
-        {PIC_SEGEMENT_TRANS,   pc_unsupported},
-        {PIC_PAGE_TRANS,       pc_unsupported},
+        {PIC_SEGEMENT_TRANS,   do_page_fault},
+        {PIC_PAGE_TRANS,       do_page_fault},
         {PIC_TRANSLATION,      pc_unsupported},
         {PIC_SPECIAL_OP,       pc_unsupported},
         {PIC_PAGEX,            pc_unsupported},
         {PIC_OPERAND,          pc_unsupported},
-        {PIC_TRACE_TABLE,      pc_reset_trace},
+        {PIC_TRACE_TABLE,      pc_unsupported}, /* Handled in head.S */
         {PIC_ASN_TRANS,        pc_unsupported},
         {-1,                   pc_unsupported},
         {PIC_VECTOR_OP,        pc_unsupported},
         {-1,                   pc_unsupported},
         {-1,                   pc_unsupported},
         {PIC_SPACE_SWITCH,     pc_unsupported},
@@ -198,49 +194,35 @@
         pic_code  = pfx_prg_code & 0x00ff;
         per_event = pic_code & 0x0080;
         pic_code  &= 0x007f;
         if (per_event) {
                 printk("PER event triggered\n");
         }
-        pc_table[pic_code].pc_flih(saved_regs, pic_code, pfx_prg_trans);
-}
-
-extern trc_page_t       *trace_base;
-
-static void
-pc_reset_trace(i370_interrupt_state_t *saved_regs,
-               unsigned short code,
-               unsigned long  trans)
-{
-        unsigned long cr12;
- 
-        trace_base = (trc_page_t *) trace_base->trc_next;
-        cr12 = (unsigned long) trace_base;
-        cr12 |= 0x1;
-        _lctl_r12 (cr12);
-        printk ("Trace table reset\n");
+        pc_table[pic_code].pc_flih(saved_regs, pfx_prg_trans, pic_code);
 }

-static void
+static int
 pc_monitor(i370_interrupt_state_t *saved_regs,
-           unsigned short code,
-           unsigned long  trans)
+           unsigned long  trans,
+           unsigned short code)
 {
         printk ("Monitor Event Triggered\n");
+        return(0);
 }
  
-static void
+static int
 pc_unsupported(i370_interrupt_state_t *saved_regs,
-               unsigned short code,
-               unsigned long  trans)
+           unsigned long  trans,
+           unsigned short code)
 {
         printk ("Program Check Unsupported code=0x%x trans=0x%lx\n",
                 code, trans);
         show_regs (saved_regs);
         print_backtrace (saved_regs->irregs.r13);
         i370_halt(); 
+        return(1);
 }

 /*----------------------------------------------------------------*/
 /* System Restart Handling                                        */
 /*----------------------------------------------------------------*/
 void
@@ -251,12 +233,13 @@
 }

 /*----------------------------------------------------------------*/
 /* Input and Output Interrupt Handling                            */
 /*----------------------------------------------------------------*/

+void do_IRQ(int, struct pt_regs *, unitblk_t *);

 void
 InputOutputException(i370_interrupt_state_t *saved_regs)
 {
         schib_t schib;
         int     rc, irq;
@@ -276,24 +259,25 @@
 }

 /*----------------------------------------------------------------*/
 /* External Interrupt Handling                                    */
 /*----------------------------------------------------------------*/
 static void ei_time_slice(i370_interrupt_state_t *, unsigned short);
+static void ei_iucv(i370_interrupt_state_t *, unsigned short);
 static void ei_unsupported(i370_interrupt_state_t *, unsigned short);
  
 static ei_handler ei_table[] = {
  {EI_INTERRUPT_KEY,  ei_unsupported},
  {EI_TOD_CLOCK_SYNC, ei_unsupported},
  {EI_CLOCK_COMP,     ei_time_slice},
  {EI_CPU_TIMER,      ei_unsupported},
  {EI_MALFUNCTION,    ei_unsupported},
  {EI_EMERGENCY,      ei_unsupported},
  {EI_CALL,           ei_unsupported},
  {EI_SERVICE,        ei_unsupported},
- {EI_IUCV,           ei_unsupported},
+ {EI_IUCV,           ei_iucv},
  {0,                 ei_unsupported},
 };
  
 void
 ExternalException (i370_interrupt_state_t *saved_regs)
 {
@@ -308,12 +292,20 @@
                 if (code == ei_table[i_ei].ei_code) break;
         }
         ei_table[i_ei].ei_flih(saved_regs, code);
 }
  
 static void
+ei_iucv(i370_interrupt_state_t *saved_regs,
+        unsigned short code)
+{
+        printk ("IUCV external exception code=0x%x\n", code);
+        return;
+}
+ 
+static void
 ei_unsupported(i370_interrupt_state_t *saved_regs,
                unsigned short code)
 {
         printk ("unexpected external exception code=0x%x\n", code);
         i370_halt();
 }
--- /tmp/00012153.PO081099.SI134940.X0000249.Y0000000	Fri Sep 10 13:49:40 1999
+++ ./include/asm-i370/processor.h	Wed Sep  8 15:48:46 1999
@@ -35,16 +35,50 @@
 #define PFX_MCH_CODE_LO 0xe8    /* Machine Check Interrrupt Code low word */
 #define PFX_MCH_CODE_HI 0xec    /* Machine Check Interrrupt Code high word */

 #define PFX_SUBSYS_ID   0xb8    /* Subsystem id word (subchannel) */
 #define PFX_IO_PARM     0xbc    /* IO interruption paramter */

-/* the rest of this scratch area is defined in head.S but should be
- * probably be moved here */
+/*-----------------------------------------------------------------*/
+/* Interrupt Scratch Areas...                                      */
+/*-----------------------------------------------------------------*/
+#define PRG_SAVE_CTX_REGS       0xe00   /* PC Context Save Area */
+#define PRG_SAVE_CTX_PSW        0xe40
+#define PRG_SAVE_CTX_CODE       0xe48
+#define PRG_SAVE_CTX_TRANS      0xe4c
+#define PRG_SAVE_CTX_C12        0xe50
+ 
+#define OFFSET_KREGS    0xef8   /* Offset to kernel register pointer */
+#define OFFSET_KSP      0xefc   /* Offset to kernel stack pointer */
 #define INTERRUPT_BASE  0xf00   /* Interrupt scratch area */
-#define PC_INTERRUPT_BASE       0xf80   /* PC scratch area */
+ 
+#define PC_INTERRUPT_BASE       0xf80   /* PC Interrupt scratch area */
+ 
+/* these defines map the struct _i370_interrupt_state_s in <asm/ptrace.h> */
+#define IR_PSW          0x0
+#define IR_R11          0x8
+#define IR_R12          0xc
+#define IR_R13          0x10
+#define IR_R14          0x14
+#define IR_R15          0x18
+#define IR_R0           0x1c
+#define IR_R1           0x20
+#define IR_R2           0x24
+#define IR_R3           0x28    
+#define IR_R4           0x2c
+ 
+#define IR_R5           0x30
+#define IR_R6           0x34
+#define IR_R7           0x38
+#define IR_R8           0x3c
+#define IR_R9           0x40
+#define IR_R10          0x44
+ 
+#define IR_CR0          0x48
+#define IR_CR1          0x4c
+#define IR_OLDREGS      0x50

 /*------------------------------------------------------------*/
 /* External Interruption Codes */
 /*------------------------------------------------------------*/
 #define EI_INTERRUPT_KEY        0x0040  /* Interrupt Key */
 #define EI_TOD_CLOCK_SYNC       0x1003  /* TOD clock sync check */
@@ -135,12 +169,15 @@
 #define PIC_STACK_SPEC          0x32
 #define PIC_STACK_TYPE          0x33
 #define PIC_STACKOP             0x34
 #define PIC_MONITOR             0x40
 #define PIC_PER                 0x80

+#define MASK_TRXADDR  0x7ffff000
+#define MASK_TRXVALID 0x00000004
+ 
 #ifndef __ASSEMBLY__

 /*------------------------------------------------------------*/
 /* External interrupt structures                              */
 /*------------------------------------------------------------*/

@@ -161,13 +198,13 @@
 /* Program check interrupt structures                         */
 /*------------------------------------------------------------*/
  
 typedef struct
 {
  short int pc_code;
- void (*pc_flih)(i370_interrupt_state_t *, unsigned short, unsigned long);
+ void (*pc_flih)(i370_interrupt_state_t *, unsigned long, unsigned short);
 } pc_handler;
  
 /*------------------------------------------------------------*/
 /* CPU Details structure                                      */
 /*------------------------------------------------------------*/

--- /tmp/00012158.PO081099.SI134940.X0000241.Y0000000	Fri Sep 10 13:49:41 1999
+++ ./include/asm-i370/unitblk.h	Wed Sep  8 10:50:59 1999
@@ -4,36 +4,40 @@

 #ifndef I370_UNITB_H_
 #define I370_UNITB_H_

 #include <linux/fs.h>
 #include <linux/major.h>
-
 #include <asm/iorb.h>

 /*
  *      Define Unit Control Block
  */

 typedef struct _unitblk {
         long            unitlock;       /* Structure Lock word */
         void            *unitque;       /* last queuing element */
         long            unitsid;        /* Subchannel Identifier */
         irb_t           unitirb;        /* Interrupt Request Block */
         void           *unitaction;     /* Pointer to irq action element */
+    struct wait_queue *unitinq;    /* Input wait queue */
+    struct wait_queue *unitoutq;   /* Output wait queue */
+    struct wait_queue *unitexpq;   /* Exception wait queue */
+    struct fasync_struct *unitasyq;/* Asynchronous reader queue */
+    unsigned  long   unitnread;    /* Number of readers */
+    unsigned  long   unitnwrit;    /* Number of writers */
         unsigned  int   unitmajor;      /* Major device number */
         unsigned  int   unitminor;      /* Minor device number */
         int             unitisc;        /* Device interrupt subclass */
         void           *unitirqh;       /* Interrupt handler     */
         unsigned  char  unitname[8];    /* Device name */
-
         unsigned char   unitflg1;       /* flag byte */
         unsigned char   unitflg2;       /* Flag byte */
         unsigned char   unitid;         /* Unit ID */
         unsigned char   unitstat;       /* Device Status */
-        unsigned        unitdtyp:16;    /* Device type from RDC */
+    u16          unitdtyp;      /* Device type from RDC */
         unsigned short  unitdev;        /* Device Number */
         unsigned char   unitmodl;       /* Device Model from RDC */
         unsigned char   unitclas;       /* Device Class code from RDC */
         unsigned char   unittycd;       /* Device Type code from RDC */
         unsigned char   unitcuid;       /* CUID from RDC */
         unsigned char   unitvol[6];     /* volume Id */
@@ -47,49 +51,46 @@
  *      Sense ID Structure
  */

 typedef struct _idchar
 {
         unsigned char   idctrl; /* Function control byte */
-        unsigned        idcuid:16;      /* Control unit ID */
+    u16            idcuid;      /* Control unit ID */
         unsigned char   idcumdl;        /* Control unit model */
-        unsigned        iddevid:16;     /* Device ID */
+    u16            iddevid;     /* Device ID */
         unsigned char   iddevmdl;       /* Device Model */
         unsigned char   idxxxx;         /* Unused */
         unsigned char   idextid;        /* Extended ID entry type */
         unsigned char   idrcdc;         /* Read Config Data command code */
         unsigned short  idrcd;          /*  Bytes of data returned by RCD */
         unsigned char   idrsv[244];     /* Reserved */

         /*---------------------------------------------------------*/
         /* Device Type Information...                              */
         /*---------------------------------------------------------*/

-#define t3270 0x04
-#define t3210 0x00
-
-} idchar_t;
+} idchar_t __attribute__ ((packed));

 /*
  *      Read Device Characteristics Structure
  */

 typedef struct _devchar {
         unsigned short  devcutyp;       /* Control Unit Type */
         unsigned char   devcumod;       /* Control Unit Model */
-        unsigned        devtype:16;     /* Device type */
+    u16          devtype;       /* Device type */
         unsigned char   devmodel;       /* Device Model */
         unsigned char   devfeat[3];     /* Reserved */
         unsigned char   devsubfe;       /* Subsystem Features */
         unsigned char   devclcd;        /* Device Class code */
         unsigned char   devtycod;       /* Device Type Code */
         short           devcyl;         /* number of primary cylinders */
         short           devtrk;         /* number of tracks/cylinder */
         unsigned char   devsect;        /* number of sectors */
         unsigned char   devtrkln[3];    /* Total usable track length */
-        unsigned        devhar0:16;     /* Length for HA and R0 */
+    u16          devhar0;       /* Length for HA and R0 */
         unsigned char   devmode;        /* Track Capacity Mode */
         unsigned char   devmodr;        /* Track Capacity Mode changed */
         short           devnkey;        /* Non-Keyed Record Overhead */
         short           devkey;         /* Keyed Record Overhead */
         short           devaltc;        /* Address of first Alternate cylinder */       
         short           devaltr;        /* Number of Alternate track */
@@ -106,15 +107,15 @@
 } devchar_t;

 /*------------------------------------------------------------*/
 /* Maps the device info. returned by Sense ID to a major no.  */
 /*------------------------------------------------------------*/
 typedef struct {
-        unsigned short  cuid;           /* Control unit ID (idcuid)     */
+    unsigned short int cuid;   /* Control unit ID (idcuid)    */
         unsigned char   model;          /* Control unit model           */
-        unsigned        dev:16;         /* Device ID (iddevid)          */
+    u16           dev;         /* Device ID (iddevid)         */
         int             i_s390dev;      /* Index into s390dev table     */
 } S390map_t;

 /*------------------------------------------------------------*/
 /* Maps the major number to device driver information         */
 /*------------------------------------------------------------*/
@@ -160,9 +161,7 @@
 #define D3590 "tss"
 #define D3172 "nbd"
 #define DCTCA "ctca"

 #define MOSAD 0xe0
 #define MCTCA 0x66
-
-
 #endif /* I370_UNITB_H_ */
--- /dev/null	Thu Jun 24 06:14:50 1999
+++ arch/i370/kernel/fault.c	Fri Sep  3 14:51:55 1999
@@ -0,0 +1,228 @@
+/************************************************************/
+/*                                                          */
+/* Module ID  - fault.c                                     */
+/*                                                          */
+/* Function   - Handle page fault conditions for S/390 port */
+/*              of Linux.                                   */
+/*                                                          */
+/*                                                          */
+/* Parameters - (1) Parmname.                               */
+/*                  Description - ......................... */
+/*                  ....................................... */
+/*                  Access - Read/Write/Update.             */
+/*                                                          */
+/*              (2) Parmname.                               */
+/*                  Description - ......................... */
+/*                  ....................................... */
+/*                  Access - Read/Write/Update.             */
+/*                                                          */
+/*                                                          */
+/* Called By  - Kernel.                                     */
+/*                                                          */
+/*                                                          */
+/* Notes      - (1) ....................................... */
+/*                                                          */
+/*              (2) ....................................... */
+/*                                                          */
+/*                                                          */
+/* Name       - Neale Ferguson.                             */
+/* Date       - September, 1999.                            */
+/*                                                          */
+/*                                                          */
+/* Associated    - (1) Refer To ........................... */
+/* Documentation                                            */
+/*                 (2) Refer To ........................... */
+/*                                                          */
+/************************************************************/
+/************************************************************/
+/*                                                          */
+/*                       DEFINES                            */
+/*                       -------                            */
+/*                                                          */
+/************************************************************/
+ 
+/*=============== End of Defines ===========================*/
+ 
+/************************************************************/
+/*                                                          */
+/*                INCLUDE STATEMENTS                        */
+/*                ------------------                        */
+/*                                                          */
+/************************************************************/
+ 
+#include <linux/mman.h>
+#include <linux/mm.h>
+#include <linux/kernel.h>
+#include <linux/ptrace.h>
+#include <linux/interrupt.h>
+#include <linux/sched.h>
+#include <asm/asm.h>
+#include <asm/system.h>
+#include <asm/uaccess.h>
+#include <asm/pgtable.h>
+#include <asm/siginfo.h>
+#include <asm/semaphore.h>
+ 
+/*================== End of Include Statements =============*/
+ 
+/************************************************************/
+/*                                                          */
+/*                TYPE DEFINITIONS                          */
+/*                ----------------                          */
+/*                                                          */
+/************************************************************/
+ 
+/*================== End of Type Definitions ===============*/
+ 
+/************************************************************/
+/*                                                          */
+/*               FUNCTION PROTOTYPES                        */
+/*               -------------------                        */
+/*                                                          */
+/************************************************************/
+ 
+/*================== End of Prototypes =====================*/
+ 
+/************************************************************/
+/*                                                          */
+/*             GLOBAL VARIABLE DECLARATIONS                 */
+/*             ----------------------------                 */
+/*                                                          */
+/************************************************************/
+ 
+ 
+/*============== End of Variable Declarations ==============*/
+ 
+/************************************************************/
+/*                                                          */
+/*                     M A I N L I N E                      */
+/*                     ---------------                      */
+/*                                                          */
+/* This routine handles page faults.  It determines the     */
+/* problem and then passes it off to one of the appropriate */
+/* routines.                                                */
+/*                                                          */
+/* pic_code:                                                */
+/* - 0x0010 = Segment translation exception (no page)       */
+/* - 0x0011 = Page translation exception (no page)          */
+/* - 0x0004 = Protection exception (write into r/o)         */
+/*                                                          */
+/* If this routine detects a bad access, it returns 1,      */
+/* otherwise it returns 0.                                  */
+/************************************************************/
+ 
+int
+do_page_fault(struct pt_regs *regs, unsigned long address,
+              unsigned pic_code)
+{
+ struct mm_struct *mm = current->mm;
+ struct vm_area_struct * vma;
+ unsigned long fixup, valid_addr;
+ int write;
+ 
+  /*------------------------------------------------------------*/
+  /* If we're in an interrupt or have no user                   */
+  /* context, we must not take the fault..                      */
+  /*------------------------------------------------------------*/
+  if (in_interrupt() || mm == &init_mm)
+       goto no_context;
+  down(&mm->mmap_sem);
+  valid_addr = address & MASK_TRXVALID;
+  address &= MASK_TRXADDR;
+  vma = find_vma(mm, address);
+  if (!vma)
+       goto bad_area;
+  if (vma->vm_flags & VM_IO)
+       goto bad_area;
+  if (vma->vm_start <= address)
+       goto good_area;
+  if (!(vma->vm_flags & VM_GROWSDOWN))
+       goto bad_area;
+  if (user_mode(regs)) {
+       /*-----------------------------------------------------*/
+       /* Accessing the stack below usp is always a bug.      */
+       /*-----------------------------------------------------*/
+       if (address < regs->irregs.r13)
+               goto bad_area;
+  }
+  if (expand_stack(vma, address))
+       goto bad_area;
+ 
+  /*----------------------------------------------------------*/
+  /* Ok, we have a good vm_area for this memory access, so    */
+  /* we can handle it..                                       */
+  /*----------------------------------------------------------*/
+good_area:
+  write = 0;
+  if (pic_code == PIC_PROTECTION) {
+     if (!(vma->vm_flags & VM_WRITE))
+        goto bad_area;
+     if (!valid_addr)
+        goto bad_area;
+     write++;
+  }
+  /*----------------------------------------------------------*/
+  /* If for any reason at all we couldn't handle the fault,   */
+  /* make sure we exit gracefully rather than endlessly redo  */
+  /* the fault.                                               */
+  /*----------------------------------------------------------*/
+  if (!handle_mm_fault(current, vma, address, write))
+       goto do_sigbus;
+  up(&mm->mmap_sem);
+  return 0;
+ 
+/*------------------------------------------------------------*/
+/* Something tried to access memory that isn't in our memory  */
+/* map. Fix it, but check if it's kernel or user first. User  */
+/* mode accesses just cause a SIGSEGV.                        */
+/*------------------------------------------------------------*/
+bad_area:
+  up(&mm->mmap_sem);
+  if (user_mode(regs)) {
+       siginfo_t info;
+ 
+       info.si_signo = SIGSEGV;
+       info.si_code  = SEGV_MAPERR;
+       info.si_addr  = (void *) address;
+       force_sig_info(SIGSEGV, &info, current);
+       return 1;
+  }
+ 
+no_context:
+  /*----------------------------------------------------------*/
+  /* Are we prepared to handle this kernel fault?   (not yet!)*/
+  /*----------------------------------------------------------*/
+/*if ((fixup = search_exception_table(regs->psw.addr)) != 0) {
+       regs->psw.addr = fixup | 0x80000000;
+       return -1;
+  }
+*//*----------------------------------------------------------*/
+  /* Oops. The kernel tried to access some bad page. We'll    */
+  /* have to terminate things "with extreme prejudice".       */
+  /*----------------------------------------------------------*/
+  if ((unsigned long) address < PAGE_SIZE) {
+       printk(KERN_ALERT "Unable to handle kernel NULL pointer dereference");
+  }
+  else
+       printk(KERN_ALERT "Unable to handle kernel access");
+  printk(" at virtual address %08lx\n",address);
+  i370_halt();
+ 
+/*-------------------------------------------------------------*/
+/* We ran out of memory, or some other thing happened to us    */
+/* that made us unable to handle the page fault gracefully.    */
+/*-------------------------------------------------------------*/
+do_sigbus:
+  up(&mm->mmap_sem);
+  /*
+   * Send a sigbus, regardless of whether we were in kernel
+   * or user mode.
+   */
+  force_sig(SIGBUS, current);
+  /* Kernel mode? Handle exceptions or die */
+  if (!(user_mode(regs)))
+       goto no_context;
+  return 1;
+}
+ 
+/*===================== End of Mainline ====================*/

--------------F72A342536CC62C0EF1A1043
Content-Type: text/x-vcard; charset=us-ascii;
 name="neale.vcf"
Content-Transfer-Encoding: 7bit
Content-Description: Card for  Neale Ferguson
Content-Disposition: attachment;
 filename="neale.vcf"

begin:vcard 
n:Ferguson;Neale
x-mozilla-html:FALSE
org:TAB Limited
adr:;;;Sydney;NSW;2001;Australia
version:2.1
email;internet:neale@mailbox.tabnsw.com.au
title:Manager, System Services
tel;fax:+61-2-92181160
tel;work:+61-2-92181309
x-mozilla-cpt:;0
fn:Neale Ferguson
end:vcard

--------------F72A342536CC62C0EF1A1043--

