--- /tmp/00004995.PO082199.SI143155.X0000164.Y0000000	Tue Sep 21 14:31:56 1999
+++ ./arch/i370/io/device.c	Mon Sep 20 03:47:04 1999
@@ -1,7 +1,6 @@
-
 /************************************************************/
 /*                                                       */
 /* Module ID  - device.                                     */
 /*                                                       */
 /* Function   - Initialize device support for the system.   */
 /*                                                       */
@@ -479,13 +478,14 @@
 			break; /* lost subchannel - tell caller */
 		}
 
 		if (irb.scsw.status & 0x7) {
 			if ((irb.scsw.devstat == 0x0c) &&
 				 (irb.scsw.schstat == 0)) {
-				memcpy(&rdc->devvol[0],&label[4],6);
+				memcpy(&rdc->devvol[0],&label[4],sizeof(&rdc->devvol));
+				memcpy(&rdc->devvtype[0],&label[0],sizeof(&rdc->devtype));
 				rc = 0;
 				break;
 			}
 			else {
 			 	rc = 1000;
 				break;
@@ -569,27 +569,27 @@
 		/* We flag the first 3270 device as our console. This */
 		/* can be overridden by specification in the IPL load */
 		/* parameters.					*/
 		/*----------------------------------------------------*/
 		if ((dev_id->idcuid == T3274) &&
 		    (dev_cons == NULL)) 
-		{
+			dev_cons = devices;
+ 
 			rc = i370_getrdc(sid,&schib,&rdc);	
-			if (!rc)
-			{
+			if (!rc) {
 				devices->unitmodl = rdc.devcumod;
 				devices->unitclas = rdc.devclcd;
 				devices->unittycd = rdc.devtycod;
 				devices->unitdtyp = rdc.devtype;
 
 				if (rdc.devcutyp == 0x3990) {
 				  	 devices->unitstat = UNIT_READY;
 					 rc = i370_getvol_eckd(sid,&schib,&rdc);
 					 memcpy(&devices->unitvol,rdc.devvol,6);
 				}	
-			} else {
+			else {
 				devices->unitmodl = dev_id->idcuid;
 				devices->unitmodl = dev_id->idcumdl;
 				devices->unitdtyp = dev_id->iddevid;
 				devices->unitstat = UNIT_READY;
 			}
 		}
--- /tmp/00004998.PO082199.SI143156.X0000161.Y0000000	Tue Sep 21 14:31:56 1999
+++ ./arch/i370/kernel/fault.c	Mon Sep 20 13:01:00 1999
@@ -116,12 +116,13 @@
               unsigned short pic_code)
 {
  struct mm_struct *mm = current->mm;
  struct vm_area_struct * vma;
  unsigned long fixup, valid_addr;
  int write;
+ unsigned short *ilc;
  
 printk ("do_page_fault addr=0x%x, pic=%x\n", address, pic_code);
   /*------------------------------------------------------------*/
   /* If we're in an interrupt or have no user                   */
   /* context, we must not take the fault..                      */
   /*------------------------------------------------------------*/
@@ -169,14 +170,23 @@
   write = 0;
   if (pic_code == PIC_PROTECTION) {
      if (!(vma->vm_flags & VM_WRITE))
         goto bad_area;
      if (!valid_addr)
         goto bad_area;
-     write++;
+     write = 1;
+     ilc   = PFX_PRG_CODE;
+     regs->psw.addr -= *ilc;  /* Adjust the instruction ptr    */
+  } else {
+     /*-------------------------------------------------------*/
+     /* Check if this page is allowed to be written to        */
+     /*-------------------------------------------------------*/
+     if (vma->vm_flags & VM_WRITE)
+        write = 1;
   }
+ 
   /*----------------------------------------------------------*/
   /* If for any reason at all we couldn't handle the fault,   */
   /* make sure we exit gracefully rather than endlessly redo  */
   /* the fault.                                               */
   /*----------------------------------------------------------*/
   if (!handle_mm_fault(current, vma, address, write))
@@ -193,13 +203,13 @@
   up(&mm->mmap_sem);
   if (user_mode(regs)) {
        siginfo_t info;
  
 printk(" sending SEGV to user proc: here's the reg dump & backtrace:\n");
 show_regs(regs);
-print_backtrace (regs->irregs.r13);
+print_backtrace (regs->irregs.r13, user_mode(regs));
 
        info.si_signo = SIGSEGV;
        info.si_code  = SEGV_MAPERR;
        info.si_addr  = (void *) address;
        force_sig_info(SIGSEGV, &info, current);
        return 1;
--- /tmp/00005007.PO082199.SI143158.X0000170.Y0000000	Tue Sep 21 14:31:58 1999
+++ ./arch/i370/kernel/setup.c	Mon Sep 20 04:53:08 1999
@@ -116,14 +117,14 @@
 
 	/* Save unparsed command line copy for /proc/cmdline */
 	strcpy(saved_command_line, cmd_line);
 	*cmdline_p = cmd_line;
 
 	*memory_start_p = (unsigned long) _end;
-	/* We'll get a cpu id only if running under VM, in which
-	 * case we can DIAGNOSE the amount of available memory */
+	/* If we're running under VM the first byte of the CPUID will be 0xff
+	 * in which case we can DIAGNOSE the amount of available memory */
 	if (CPUID[0] == 0xff) {
 	        *memory_end_p = VM_Diagnose_Code_60();
 	} else {
 		/* hardcode the memory size */
 		*memory_end_p = 0x2000000;  // 32M
 	}
--- /tmp/00005010.PO082199.SI143158.X0000167.Y0000000	Tue Sep 21 14:31:58 1999
+++ ./arch/i370/kernel/traps.c	Mon Sep 20 12:08:16 1999
@@ -52,12 +52,15 @@
 int (*debugger_sstep)(struct pt_regs *regs);
 int (*debugger_iabr_match)(struct pt_regs *regs);
 int (*debugger_dabr_match)(struct pt_regs *regs);
 void (*debugger_fault_handler)(struct pt_regs *regs);
 #endif
 #endif
+#ifdef LATER
+void ret_from_syscall(void);
+#endif
 
 void instruction_dump (unsigned short *pc)
 {
    int i;
 
    printk("Instruction DUMP:");
--- /tmp/00005013.PO082199.SI143159.X0000174.Y0000000	Tue Sep 21 14:31:59 1999
+++ ./include/asm-i370/asm.h	Mon Sep 20 11:55:52 1999
@@ -255,9 +255,25 @@
 	"	LPSW	%0;			\n"
 	"1:	NOPR	r0;			\n"
 	: "+m" (*psw) : : "r1", "memory");
 }
 
 /* -------------------------------------------------------- */
+/* Load Real Address...                                     */
+/* -------------------------------------------------------- */
+ 
+extern inline void * _lra(void *va)
+{
+ void *ra;
+ 
+	asm volatile ("
+		LRA     %0,%1;"
+		: "=r" (ra)
+		: "m" (*va) );
+	return(ra);
+}
+ 
+ 
+/* -------------------------------------------------------- */
 
 #endif /* __ASSEMBLY__ */
 #endif /* __I370_ASM_H__ */
--- /tmp/00005019.PO082199.SI143217.X0000192.Y0000000	Tue Sep 21 14:32:17 1999
+++ ./include/asm-i370/processor.h	Mon Sep 20 14:30:55 1999
@@ -193,13 +193,13 @@
 } ei_handler;
 
 typedef struct
 {
 	short int iucv_path;        /* IUCV path identifier          */
 	unsigned long iucv_uword;   /* User word                     */
-	void  *iucv_buffer;         /* Pointer to the IUCV DCLBFR    */
+	void  *iucv_buffer;         /* Pointer to the IUCV IPARML    */
 } iucv_path;
 
 /*------------------------------------------------------------*/
 /* Program check interrupt structures                         */
 /*------------------------------------------------------------*/
  
--- /tmp/00005025.PO082199.SI143217.X0000182.Y0000000	Tue Sep 21 14:32:17 1999
+++ ./include/asm-i370/unitblk.h	Mon Sep 20 04:41:37 1999
@@ -5,12 +5,13 @@
 #ifndef I370_UNITB_H_
 #define I370_UNITB_H_
 
 #include <linux/fs.h>
 #include <linux/major.h>
 #include <asm/iorb.h>
+#define  _PACK __attribute__ ((packed))
 
 /*
  *	Define Unit Control Block
  */
 
 typedef struct _unitblk {
@@ -31,13 +32,13 @@
 	void           *unitirqh;	/* Interrupt handler     */
 	unsigned  char  unitname[8];	/* Device name */
 	unsigned char   unitflg1;	/* flag byte */
 	unsigned char   unitflg2;	/* Flag byte */
 	unsigned char   unitid;		/* Unit ID */
 	unsigned char   unitstat;	/* Device Status */
-    u16          unitdtyp;      /* Device type from RDC */
+	unsigned short  unitdtyp _PACK;	/* Device type from RDC */
 	unsigned short  unitdev;	/* Device Number */
 	unsigned char   unitmodl;	/* Device Model from RDC */
 	unsigned char   unitclas;	/* Device Class code from RDC */
 	unsigned char   unittycd;	/* Device Type code from RDC */
 	unsigned char   unitcuid;	/* CUID from RDC */
 	unsigned char   unitvol[6];	/* volume Id */
@@ -51,15 +52,15 @@
  *	Sense ID Structure
  */
 
 typedef	struct _idchar
 {
 	unsigned char	idctrl;	/* Function control byte */
-    u16            idcuid;      /* Control unit ID */
+	unsigned short	idcuid _PACK;	/* Control unit ID */
 	unsigned char	idcumdl;	/* Control unit model */
-    u16            iddevid;     /* Device ID */
+	unsigned short	iddevid _PACK;	/* Device ID */
 	unsigned char	iddevmdl;	/* Device Model */
 	unsigned char	idxxxx;		/* Unused */
 	unsigned char	idextid;	/* Extended ID entry type */
 	unsigned char	idrcdc;		/* Read Config Data command code */
 	unsigned short	idrcd;		/*  Bytes of data returned by RCD */
 	unsigned char	idrsv[244];	/* Reserved */
@@ -74,23 +75,23 @@
  *	Read Device Characteristics Structure
  */
 
 typedef	struct _devchar {
 	unsigned short	devcutyp;	/* Control Unit Type */
 	unsigned char   devcumod;	/* Control Unit Model */
-    u16          devtype;       /* Device type */
+	unsigned short	devtype _PACK;	/* Device type */
 	unsigned char	devmodel;	/* Device Model */
 	unsigned char	devfeat[3];	/* Reserved */
 	unsigned char   devsubfe;	/* Subsystem Features */
 	unsigned char   devclcd;	/* Device Class code */
 	unsigned char   devtycod;	/* Device Type Code */
 	short		devcyl;		/* number of primary cylinders */
 	short 		devtrk;		/* number of tracks/cylinder */
 	unsigned char	devsect;        /* number of sectors */
 	unsigned char	devtrkln[3];	/* Total usable track length */
-    u16          devhar0;       /* Length for HA and R0 */
+	unsigned short	devhar0 _PACK;	/* Length for HA and R0 */
 	unsigned char	devmode;	/* Track Capacity Mode */
 	unsigned char	devmodr;	/* Track Capacity Mode changed */
 	short		devnkey;	/* Non-Keyed Record Overhead */
 	short		devkey;		/* Keyed Record Overhead */
 	short		devaltc;	/* Address of first Alternate cylinder */	
 	short		devaltr;	/* Number of Alternate track */
@@ -100,22 +101,23 @@
 	short		devdvsup;	/* Number of Device Support Tracks */
 	unsigned char	devmdr;		/* MDR Record id */
 	unsigned char	devobr;		/* OBR Record id */
 	unsigned char	devcuid;	/* Control Unit Id */
 	unsigned char	fill[21];	/* Rest of RDC block */
 	unsigned char   devvol[6];      /* add volume id */
+	unsigned char   devvtype[4];    /* Volume type */
 	unsigned char   fill1[2];       /* fill to boundary */
 } devchar_t;
 
 /*------------------------------------------------------------*/
 /* Maps the device info. returned by Sense ID to a major no.  */
 /*------------------------------------------------------------*/
 typedef struct {
     unsigned short int cuid;   /* Control unit ID (idcuid)    */
 	unsigned char	model;		/* Control unit model		*/
-    u16           dev;         /* Device ID (iddevid)         */
+	unsigned short	dev _PACK;     /* Device ID (iddevid)         */
 	int      	i_s390dev;	/* Index into s390dev table	*/
 } S390map_t;
 
 /*------------------------------------------------------------*/
 /* Maps the major number to device driver information         */
 /*------------------------------------------------------------*/
@@ -161,7 +163,8 @@
 #define D3590 "tss"
 #define D3172 "nbd"
 #define DCTCA "ctca"
 
 #define MOSAD 0xe0
 #define MCTCA 0x66
+#undef  _PACK
 #endif /* I370_UNITB_H_ */
--- /tmp/00005028.PO082199.SI143218.X0000186.Y0000000	Tue Sep 21 14:32:18 1999
+++ ./include/asm-i370/vmdiag.h	Mon Sep 20 05:07:27 1999
@@ -218,14 +218,15 @@
   } else {
     aaddr1 = (long) &hcpsxibk.namei;
   }
     __asm__ __volatile__(
            " .set _i370_implied_op,%5;
              .set _i370_implied_op,%6;
-             MVC  %O1(8,%R1),%2;
-             TR   %O1(8,%R1),%3;
+             L    %0,%2;
+             MVC  %O1(8,%R1),0(%0);
+             TR   %O1(8,%R1),0(%3);
              .short 0x8310;.short 0x0064
              IPM  %0;
              SRL  %0,26;
              N    %0,=F'12';
              BNP  1f;
              LR   %0,r0;
--- /dev/null	Tue Sep 14 09:07:27 1999
+++ include/asm-i370/iucv.h	Mon Sep 20 03:31:23 1999
@@ -0,0 +1,415 @@
+/* ACCEPT parameter list... */
+ 
+typedef struct accept_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    short int   ipmsglim;       /* 0x04: message limit */
+    char        filler1[10];    /* 0x06: unused */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } accept_pl;
+ 
+/* CONNECT parameter list... */
+ 
+typedef struct connect_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    short int   ipmsglim;       /* 0x04: message limit */
+    char        filler1[2];     /* 0x06: unused */
+    char        ipvmid[8];      /* 0x08: target VM userid */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } connect_pl;
+ 
+/* DECLARE BUFFER parameter list... */
+ 
+typedef struct dclbfr_pl
+  {
+    char        filler1[3];     /* 0x00: unused */
+    char        iprcode;        /* 0x03: return code */
+    char        filler2[8];     /* 0x04: unused */
+    void        *ipbfadr1;      /* 0x0c: &xtrn int buffer */
+    char        filler3[24];    /* 0x10: unused */
+  } dclbfr_pl;
+ 
+/* DESCRIBE parameter list... */
+ 
+typedef struct describe_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    int         iptrgcls;       /* 0x08: target class */
+    int         iprmmsg1;       /* 0x0c: message data */
+    int         ipbfln1f;       /* 0x10: message 1 length */
+    char        filler1[12];    /* 0x14: unused */
+    int         ipbfln2f;       /* 0x20: message 2 length */
+    char        filler2[4];     /* 0x24: unused */
+  } describe_pl;
+ 
+/* PURGE parameter list... */
+ 
+typedef struct purge_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    short int   ipaudit;        /* 0x08: message audit trail */
+    char        filler1[10];    /* 0x0a: unused */
+    int         ipsrccls;       /* 0x14: message class */
+    int         ipmsgtag;       /* 0x18: message tag */
+    char        filler2[12];    /* 0x1c: unused */
+  } purge_pl;
+ 
+/* QUIESCE parameter list... */
+ 
+typedef struct quiesce_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    char        filler1[12];    /* 0x04: unused */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } quiesce_pl;
+ 
+/* RECEIVE parameter list... */
+ 
+typedef struct receive_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    int         iptrgcls;       /* 0x08: target class */
+    void        *ipbfadr1;      /* 0x0c: &message text buffer */
+    int         ipbfln1f;       /* 0x10: message length */
+    char        filler1[12];    /* 0x14: unused */
+    int         ipbfln2f;       /* 0x20: message length */
+    char        filler2[4];     /* 0x24: unused */
+  } receive_pl;
+ 
+/* REJECT parameter list... */
+ 
+typedef struct reject_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    int         iptrgcls;       /* 0x08: target class */
+    char        filler1[28];    /* 0x0c: unused */
+  } reject_pl;
+ 
+/* REPLY parameter list... */
+ 
+typedef struct reply_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    int         iptrgcls;       /* 0x08: target class */
+    int         iprmmsg1;       /* 0x0c: message data */
+    int         iprmmsg2;       /* 0x10: message data */
+    char        filler1[8];     /* 0x14: unused */
+    void        *ipbfadr2;      /* 0x1c: &message text buffer */
+    int         ipbfln2f;       /* 0x20: message length */
+    char        filler2[4];     /* 0x24: unused */
+  } reply_pl;
+ 
+/* RESUME parameter list... */
+ 
+typedef struct resume_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    char        filler1[12];    /* 0x04: unused */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } resume_pl;
+ 
+/* SEND parameter list... */
+ 
+typedef struct send_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    int         iptrgcls;       /* 0x08: target class */
+    void        *ipbfadr1;      /* 0x0c: &input buffer */
+    int         ipbfln1f;       /* 0x10: buffer length */
+    int         ipsrccls;       /* 0x14: message class */
+    int         ipmsgtag;       /* 0x18: message tag */
+    void        *ipbfadr2;      /* 0x1c: &reply buffer */
+    int         ipbfln2f;       /* 0x20: buffer length */
+    char        filler1[4];     /* 0x24: unused */
+  } send_pl;
+ 
+/* SETCMASK parameter list... */
+ 
+typedef struct setcmask_pl
+  {
+    char        ipcmask;        /* 0x00: xtrn int mask byte */
+    char        filler1[39];    /* 0x01: unused */
+  } setcmask_pl;
+ 
+/* SETMASK parameter list... */
+ 
+typedef struct setmask_pl
+  {
+    char        ipmask;         /* 0x00: xtrn int mask byte */
+    char        filler1[39];    /* 0x01: unused */
+  } setmask_pl;
+ 
+/* SEVER parameter list... */
+ 
+typedef struct sever_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    char        filler1[12];    /* 0x04: unused */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } sever_pl;
+ 
+/* TESTCMPL parameter list... */
+ 
+typedef struct testcmpl_pl
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iprcode;        /* 0x03: return code */
+    int         ipmsgid;        /* 0x04: message identification */
+    short int   ipaudit;        /* 0x08: message audit trail */
+    char        filler1[2];     /* 0x0a: unused */
+    int         iprmmsg1;       /* 0x0c: message data */
+    int         iprmmsg2;       /* 0x10: message data */
+    int         ipsrccls;       /* 0x14: message class */
+    int         ipmsgtag;       /* 0x18: message tag */
+    char        filler2[4];     /* 0x1c: unused */
+    int         ipbfln2f;       /* 0x20: message length */
+    char        filler3[4];     /* 0x24: unused */
+  } testcmpl_pl;
+ 
+/* pending connection external interrupt buffer... */
+ 
+typedef struct pending_connection_xib
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iptype;         /* 0x03: interrupt code */
+    char        ipmsglim;       /* 0x04: message limit */
+    char        filler1[3];     /* 0x05: unused */
+    char        ipvmid[8];      /* 0x08: target VM userid */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } pending_connection_xib;
+ 
+/* connection complete external interrupt buffer... */
+ 
+typedef struct connection_complete_xib
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iptype;         /* 0x03: interrupt code */
+    char        ipmsglim;       /* 0x04: message limit */
+    char        filler1[11];    /* 0x05: unused */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler2[8];     /* 0x20: unused */
+  } connection_complete_xib;
+ 
+/* sever, quiesce and resume external interrupt buffer... */
+ 
+typedef struct sever_xib
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        filler1;        /* 0x02: unused */
+    char        iptype;         /* 0x03: interrupt code */
+    char        filler2[12];    /* 0x04: unused */
+    char        ipuser[16];     /* 0x10: user data */
+    char        filler3[8];     /* 0x20: unused */
+  } sever_xib;
+ 
+#define quiesce_xib sever_xib
+#define resume_xib sever_xib
+ 
+/* message complete external interrupt buffer... */
+ 
+typedef struct message_complete_xib
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iptype;         /* 0x03: interrupt code */
+    int         ipmsgid;        /* 0x04: message identification */
+    short int   ipaudit;        /* 0x08: message audit trail */
+    char        filler1[2];     /* 0x0a: unused */
+    int         iprmmsg1;       /* 0x0c: message data */
+    int         iprmmsg2;       /* 0x10: message data */
+    int         ipsrccls;       /* 0x14: message class */
+    int         ipmsgtag;       /* 0x18: message tag */
+    char        filler2[4];     /* 0x1c: unused */
+    int         ipbfln2f;       /* 0x20: message length */
+    char        filler3[4];     /* 0x24: unused */
+  } message_complete_xib;
+ 
+/* pending message external interrupt buffer... */
+ 
+typedef struct pending_message_xib
+  {
+    short int   ippathid;       /* 0x00: path id */
+    char        ipflags1;       /* 0x02: flags */
+    char        iptype;         /* 0x03: interrupt code */
+    int         ipmsgid;        /* 0x04: message identification */
+    int         iptrgcls;       /* 0x08: target class */
+    int         iprmmsg1;       /* 0x0c: message data */
+    short int   ipbfln1;        /* 0x10: message length */
+    short int   iprmmsg2;       /* 0x12: message data */
+    char        filler1[12];    /* 0x14: unused */
+    int         ipbfln2f;       /* 0x20: message length */
+    char        filler2[4];     /* 0x24: unused */
+  } pending_message_xib;
+ 
+typedef union iparml
+  {
+    double                      align_pl;
+    accept_pl                   ipl_ac; /* ACCEPT */
+    connect_pl                  ipl_co; /* CONNECT */
+    dclbfr_pl                   ipl_db; /* DECLARE BUFFER  */
+    describe_pl                 ipl_de; /* DESCRIBE */
+    purge_pl                    ipl_pu; /* PURGE */
+    quiesce_pl                  ipl_qu; /* QUIESCE */
+    receive_pl                  ipl_re; /* RECEIVE */
+    reject_pl                   ipl_rj; /* REJECT */
+    reply_pl                    ipl_rp; /* REPLY */
+    resume_pl                   ipl_rs; /* RESUME */
+    send_pl                     ipl_se; /* SEND */
+    setcmask_pl                 ipl_sc; /* SETCMASK */
+    setmask_pl                  ipl_sm; /* SETMASK */
+    sever_pl                    ipl_sv; /* SEVER */
+    testcmpl_pl                 ipl_tc; /* TESTCMPL */
+    pending_connection_xib      ipl_pc; /* pending connection */
+    connection_complete_xib     ipl_cc; /* connection complete */
+    sever_xib                   ipl_sr; /* sever */
+    message_complete_xib        ipl_mc; /* message complete */
+    pending_message_xib         ipl_pm; /* pending message */
+  } iparml;
+ 
+/* mask values for ipflags1... */
+#define IPF1_ALL        0x80    /* quiesce, resume, sever all */
+#define IPF1_PARMDATA   0x80    /* message is in plist */
+#define IPF1_QUIESCE    0x40    /* connect in quiesce mode */
+#define IPF1_BUFLST     0x40    /* buffer list option */
+#define IPF1_PRIORITY   0x20    /* priority message/reply */
+#define IPF1_NOREPLY    0x10    /* one-way protocol */
+#define IPF1_ANSLST     0x08    /* answer list option */
+#define IPF1_MSGID      0x04    /* message id specified */
+#define IPF1_PATHID     0x02    /* pathid specified */
+#define IPF1_MSGCLASS   0x01    /* message class specified */
+ 
+/* mask values for ipmask... */
+#define IPM_SEND_NONPR  0x80    /* enable non-priority messages */
+#define IPM_SEND_PR     0x40    /* ... priority messages */
+#define IPM_REPLY_NONPR 0x20    /* ... non-priority replies */
+#define IPM_REPLY_PR    0x10    /* ... priority replies */
+#define IPM_CTRL        0x08    /* ... IUCV control interrupts */
+ 
+/* mask values for ipcmask... */
+#define IPCM_PENDINGCON 0x80    /* enable pending connection */
+#define IPCM_COMPLETECON 0x40   /* ... complete connection */
+#define IPCM_SEVER      0x20    /* ... sever */
+#define IPCM_QUIESCE    0x10    /* ... quiesce */
+#define IPCM_RESUME     0x08    /* ... resume */
+ 
+/* mask values for ipaudit... */
+#define IPAD_REPLY_LEN  0x8000  /* reply too long for buffer */
+#define IPAD_SEND_PROTX 0x4000  /* send buffer protection exception */
+#define IPAD_SEND_ADDRX 0x2000  /* send buffer addressing exception */
+#define IPAD_ANS_PROTX  0x1000  /* answer buffer protection exception */
+#define IPAD_ANS_ADDRX  0x0800  /* answer buffer addressing exception */
+#define IPAD_REJECT     0x0400  /* message was rejected */
+#define IPAD_PLDATA     0x0200  /* reply sent in parameter list */
+ 
+#define IPAD_RECV_PROTX 0x0080  /* receive buffer protection except'n */
+#define IPAD_RECV_ADDRX 0x0040  /* receive buffer addressing except'n */
+#define IPAD_REPLY_PROTX 0x0020 /* reply buffer protection exception */
+#define IPAD_REPLY_ADDRX 0x0010 /* reply buffer addressing exception */
+#define IPAD_SEVERED    0x0008  /* path was severed */
+#define IPAD_INVRLIST   0x0004  /* invalid receive/reply list */
+ 
+/* values for iptype... */
+#define IPTYP_PENDING_CON       1
+#define IPTYP_CON_COMPLETE      2
+#define IPTYP_SEVERED           3
+#define IPTYP_QUIESCED          4
+#define IPTYP_RESUMED           5
+#define IPTYP_INPRIOR_REPLY     6
+#define IPTYP_INREPLY           7
+#define IPTYP_INPRIOR_MSG       8
+#define IPTYP_INMSG             9
+ 
+/* values for iucv_fncode... */
+#define IUCVFC_ACCEPT   10
+#define IUCVFC_CONNECT  11
+#define IUCVFC_DCLBFR   12
+#define IUCVFC_DESCRIBE 3
+#define IUCVFC_PURGE    9
+#define IUCVFC_QUIESCE  13
+#define IUCVFC_RECEIVE  5
+#define IUCVFC_REJECT   8
+#define IUCVFC_REPLY    6
+#define IUCVFC_RESUME   14
+#define IUCVFC_SEND     4
+#define IUCVFC_SETCMASK 17
+#define IUCVFC_SETMASK  16
+#define IUCVFC_SEVER    15
+#define IUCVFC_TESTCMPL 7
+#define IUCVFC_QUERY    0
+#define IUCVFC_RTRVBFR  2
+#define IUCVFC_TESTMSG  1
+ 
+#define iaccept(iucvpl)  iucv(IUCVFC_ACCEPT,(iucvpl))
+#define iconnect(iucvpl) iucv(IUCVFC_CONNECT,(iucvpl))
+#define idclbfr(iucvpl)  iucv(IUCVFC_DCLBFR,(iucvpl))
+#define idescribe(iucvpl) iucv(IUCVFC_DESCRIBE,(iucvpl))
+#define ipurge(iucvpl)   iucv(IUCVFC_PURGE,(iucvpl))
+#define iquiesce(iucvpl) iucv(IUCVFC_QUIESCE,(iucvpl))
+#define ireceive(iucvpl) iucv(IUCVFC_RECEIVE,(iucvpl))
+#define ireply(iucvpl)   iucv(IUCVFC_REPLY,(iucvpl))
+#define ireject(iucvpl)  iucv(IUCVFC_REJECT,(iucvpl))
+#define iresume(iucvpl)  iucv(IUCVFC_RESUME,(iucvpl))
+#define isend(iucvpl)    iucv(IUCVFC_SEND,(iucvpl))
+#define isetcmask(iucvpl) iucv(IUCVFC_SETCMASK,(iucvpl))
+#define isetmask(iucvpl) iucv(IUCVFC_SETMASK,(iucvpl))
+#define isever(iucvpl)   iucv(IUCVFC_SEVER,(iucvpl))
+#define itestcmpl(iucvpl) iucv(IUCVFC_TESTCMPL,(iucvpl))
+#define iquery()         iucv(IUCVFC_QUERY,0)
+#define irtrvbfr()       iucv(IUCVFC_RTRVBFR,0)
+#define itestmsg()       iucv(IUCVFC_TESTMSG,0)
+ 
+static inline int iucv (int iucv_fncode, void *iucvpl)
+{
+ int rc;
+ 
+	asm volatile (
+		"L	r0,%1;\n"
+		"LA	r1,%2;\n"
+		"EX	r0,=X'B2F01000';\n"
+		"IPM	r1;\n"
+		"SRL	r1,28;n"
+		"LR	%0,r1;\n"
+		:"=r" (rc)
+		:"=m" (iucv_fncode), "m" (*iucvpl)
+		:"r0", "r1", "memory");
+	return (rc);
+}
+#endif
