# 1 "fs/binfmt_elf.c"
 










# 1 "/home/linas/src/linux/include/linux/module.h" 1
 








# 1 "/home/linas/src/linux/include/linux/config.h" 1



# 1 "/home/linas/src/linux/include/linux/autoconf.h" 1
 



 






 













 







 







 




















 








# 4 "/home/linas/src/linux/include/linux/config.h" 2



# 10 "/home/linas/src/linux/include/linux/module.h" 2













# 1 "/home/linas/src/linux/include/asm/atomic.h" 1
 







 






typedef struct { int counter; } atomic_t;








 






extern __inline__
void *xchg_u32(void *ptr, unsigned long newval) 
{
	unsigned long oldval;
	unsigned long *v = (unsigned long *) ptr;

	__asm__ __volatile__("
1:	L	%0,%2;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	:
	: "memory");

	return (void *) oldval;
}


extern __inline__ int atomic_add_return(int inc, atomic_t *v)
{
	int oldval, newval;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	AR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	: "r" (inc)
	: "memory");

	return newval;
}

extern __inline__ void atomic_add(int inc, atomic_t *v)
{
	atomic_add_return (inc,v);
}

extern __inline__ int atomic_sub_return(int inc, atomic_t *v)
{
	int oldval, newval;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	SR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	: "r" (inc)
	: "memory");

	return newval;
}
extern __inline__ void atomic_sub(int inc, atomic_t *v)
{
	atomic_sub_return (inc,v);
}

extern __inline__ int atomic_sub_and_test(int inc, atomic_t *v)
{
	int oldval, newval;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	SR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	: "r" (inc)
	: "memory");

	return 0 == newval;
}

extern __inline__ int atomic_inc_return(atomic_t *v)
{
	int oldval, newval;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	LA	%1,1(,%1);
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	: 
	: "memory");

	return newval;
}
extern __inline__ void atomic_inc(atomic_t *v)
{
	atomic_inc_return (v);
}

extern __inline__ int atomic_dec_return(atomic_t *v)
{
	int oldval, newval;
	int inc = 1;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	SR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	: "r" (inc)
	: "memory");

	return newval;
}
extern __inline__ void atomic_dec(atomic_t *v)
{
	atomic_dec_return (v);
}

extern __inline__ int atomic_dec_and_test(atomic_t *v)
{
	int oldval, newval;
	int inc = 1;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	SR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*v)
	: "r" (inc)
	: "memory");

	return 0 == newval;
}

extern __inline__ void atomic_set_mask (unsigned long mask, unsigned long *addr)
{
	unsigned long oldval, newval;

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	OR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*addr)
	: "r" (mask)
	: "memory");
}

extern __inline__ void atomic_clear_mask (unsigned long mask, unsigned long *addr)
{
	unsigned long oldval, newval;

	mask = ~mask;	 

	__asm__ __volatile__("
1:	L	%0,%2;
	L	%1,%2;
	NR	%1,%3;
	CS	%0,%1,%2;
	BNE	1b"
	: "+r" (oldval), "+r" (newval), "+m" (*addr)
	: "r" (mask)
	: "memory");
}

 




extern __inline__
unsigned long compare_and_swap (void *memloc, 
                                unsigned long *old, 
                                unsigned long newval)
{
	unsigned long *memptr = (unsigned long *) memloc;
	unsigned long rc = 0;

	__asm__ __volatile__("
	CS	%0,%1,%2;
	BZ	1f;
	LA	%3,1(,0);
	ST	%0,%4;
1:	;	"

	: "+r" (*old), "+r" (newval), "+m" (*memptr), "+r" (rc), "=m" (*old)
	: 
	: "memory");

	return rc;
}


# 23 "/home/linas/src/linux/include/linux/module.h" 2


 
struct exception_table_entry;

 
struct kernel_sym
{
	unsigned long value;
	char name[60];		 
};

struct module_symbol
{
	unsigned long value;
	const char *name;
};

struct module_ref
{
	struct module *dep;	 
	struct module *ref;	 
	struct module_ref *next_ref;
};

 
struct module_persist;

struct module
{
	unsigned long size_of_struct;	 
	struct module *next;
	const char *name;
	unsigned long size;

	union
	{
		atomic_t usecount;
		long pad;
	} uc;				 

	unsigned long flags;		 

	unsigned nsyms;
	unsigned ndeps;

	struct module_symbol *syms;
	struct module_ref *deps;
	struct module_ref *refs;
	int (*init)(void);
	void (*cleanup)(void);
	const struct exception_table_entry *ex_table_start;
	const struct exception_table_entry *ex_table_end;



	 


	const struct module_persist *persist_start;
	const struct module_persist *persist_end;
	int (*can_unload)(void);
};

struct module_info
{
	unsigned long addr;
	unsigned long size;
	unsigned long flags;
	long usecount;
};

 









 







 







 



 









 




 
extern unsigned long get_module_symbol(char *, char *);

# 208 "/home/linas/src/linux/include/linux/module.h"














extern struct module *module_list;





 








# 247 "/home/linas/src/linux/include/linux/module.h"






# 278 "/home/linas/src/linux/include/linux/module.h"










# 12 "fs/binfmt_elf.c" 2


# 1 "/home/linas/src/linux/include/linux/fs.h" 1



 





# 1 "/home/linas/src/linux/include/linux/linkage.h" 1









































# 52 "/home/linas/src/linux/include/linux/linkage.h"



# 10 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/limits.h" 1



















# 11 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/wait.h" 1










# 1 "/home/linas/src/linux/include/asm/page.h" 1





 




 


 




 














 


typedef struct { unsigned long pte; } pte_t;
typedef struct { unsigned long pmd; } pmd_t;
typedef struct { unsigned long pgd; } pgd_t;
typedef struct { unsigned long pgprot; } pgprot_t;











# 71 "/home/linas/src/linux/include/asm/page.h"



 


 






 






extern unsigned long get_zero_page_fast(void);



# 11 "/home/linas/src/linux/include/linux/wait.h" 2


struct wait_queue {
	struct task_struct * task;
	struct wait_queue * next;
};



static inline void init_waitqueue(struct wait_queue **q)
{
	*q = ((struct wait_queue *)(( q )-1)) ;
}

static inline int waitqueue_active(struct wait_queue **q)
{
	struct wait_queue *head = *q;
	return head && head != ((struct wait_queue *)(( q )-1)) ;
}




# 12 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/types.h" 1



# 1 "/home/linas/src/linux/include/linux/posix_types.h" 1



 









 










 


















typedef struct {
	unsigned long fds_bits [(1024 / (8 * sizeof(unsigned long)) ) ];
} __kernel_fd_set;

 
typedef void (*__kernel_sighandler_t)(int);

 
typedef int __kernel_key_t;

# 1 "/home/linas/src/linux/include/asm/posix_types.h" 1



 





typedef unsigned int	__kernel_dev_t;
typedef unsigned int	__kernel_ino_t;
typedef unsigned int	__kernel_mode_t;
typedef unsigned short	__kernel_nlink_t;
typedef long		__kernel_off_t;
typedef int		__kernel_pid_t;
typedef unsigned int	__kernel_uid_t;
typedef unsigned int	__kernel_gid_t;
typedef unsigned long	__kernel_size_t;
typedef long		__kernel_ssize_t;
typedef long		__kernel_ptrdiff_t;
typedef long		__kernel_time_t;
typedef long		__kernel_suseconds_t;
typedef long		__kernel_clock_t;
typedef int		__kernel_daddr_t;
typedef char *		__kernel_caddr_t;
typedef short             __kernel_ipc_pid_t;


typedef long long	__kernel_loff_t;


typedef struct {
	int	val[2];
} __kernel_fsid_t;

# 44 "/home/linas/src/linux/include/asm/posix_types.h"



 


static __inline__ void __FD_SET(unsigned long fd, __kernel_fd_set *fdsetp)
{
	unsigned long _tmp = fd / (8 * sizeof(unsigned long)) ;
	unsigned long _rem = fd % (8 * sizeof(unsigned long)) ;
	fdsetp->fds_bits[_tmp] |= (1UL<<_rem);
}


static __inline__ void __FD_CLR(unsigned long fd, __kernel_fd_set *fdsetp)
{
	unsigned long _tmp = fd / (8 * sizeof(unsigned long)) ;
	unsigned long _rem = fd % (8 * sizeof(unsigned long)) ;
	fdsetp->fds_bits[_tmp] &= ~(1UL<<_rem);
}


static __inline__ int __FD_ISSET(unsigned long fd, __kernel_fd_set *p)
{ 
	unsigned long _tmp = fd / (8 * sizeof(unsigned long)) ;
	unsigned long _rem = fd % (8 * sizeof(unsigned long)) ;
	return (p->fds_bits[_tmp] & (1UL<<_rem)) != 0;
}

 




static __inline__ void __FD_ZERO(__kernel_fd_set *p)
{
	unsigned int *tmp = (unsigned int *)p->fds_bits;
	int i;

	if (__builtin_constant_p((1024 / (8 * sizeof(unsigned long)) ) )) {
		switch ((1024 / (8 * sizeof(unsigned long)) ) ) {
			case 8:
				tmp[0] = 0; tmp[1] = 0; tmp[2] = 0; tmp[3] = 0;
				tmp[4] = 0; tmp[5] = 0; tmp[6] = 0; tmp[7] = 0;
				return;
		}
	}
	i = (1024 / (8 * sizeof(unsigned long)) ) ;
	while (i) {
		i--;
		*tmp = 0;
		tmp++;
	}
}




# 54 "/home/linas/src/linux/include/linux/posix_types.h" 2



# 4 "/home/linas/src/linux/include/linux/types.h" 2

# 1 "/home/linas/src/linux/include/asm/types.h" 1



 




typedef __signed__ char __s8;
typedef unsigned char __u8;

typedef __signed__ short __s16;
typedef unsigned short __u16;

typedef __signed__ int __s32;
typedef unsigned int __u32;


typedef __signed__ long long __s64;
typedef unsigned long long __u64;


 




typedef unsigned short umode_t;

typedef signed char s8;
typedef unsigned char u8;

typedef signed short s16;
typedef unsigned short u16;

typedef signed int s32;
typedef unsigned int u32;

typedef signed long long s64;
typedef unsigned long long u64;






# 5 "/home/linas/src/linux/include/linux/types.h" 2




typedef __kernel_fd_set		fd_set;
typedef __kernel_dev_t		dev_t;
typedef __kernel_ino_t		ino_t;
typedef __kernel_mode_t		mode_t;
typedef __kernel_nlink_t	nlink_t;
typedef __kernel_off_t		off_t;
typedef __kernel_pid_t		pid_t;
typedef __kernel_uid_t		uid_t;
typedef __kernel_gid_t		gid_t;
typedef __kernel_daddr_t	daddr_t;
typedef __kernel_key_t		key_t;
typedef __kernel_suseconds_t	suseconds_t;


typedef __kernel_loff_t		loff_t;


 





typedef __kernel_size_t		size_t;




typedef __kernel_ssize_t	ssize_t;




typedef __kernel_ptrdiff_t	ptrdiff_t;




typedef __kernel_time_t		time_t;




typedef __kernel_clock_t	clock_t;




typedef __kernel_caddr_t	caddr_t;


 
typedef unsigned char		u_char;
typedef unsigned short		u_short;
typedef unsigned int		u_int;
typedef unsigned long		u_long;

 
typedef unsigned char		unchar;
typedef unsigned short		ushort;
typedef unsigned int		uint;
typedef unsigned long		ulong;




typedef		__u8		u_int8_t;
typedef		__s8		int8_t;
typedef		__u16		u_int16_t;
typedef		__s16		int16_t;
typedef		__u32		u_int32_t;
typedef		__s32		int32_t;



typedef		__u8		uint8_t;
typedef		__u16		uint16_t;
typedef		__u32		uint32_t;


typedef		__u64		uint64_t;
typedef		__u64		u_int64_t;
typedef		__s64		int64_t;




 




struct ustat {
	__kernel_daddr_t	f_tfree;
	__kernel_ino_t		f_tinode;
	char			f_fname[6];
	char			f_fpack[6];
};


# 13 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/vfs.h" 1



# 1 "/home/linas/src/linux/include/asm/statfs.h" 1







typedef __kernel_fsid_t	fsid_t;



struct statfs {
	long f_type;
	long f_bsize;
	long f_blocks;
	long f_bfree;
	long f_bavail;
	long f_files;
	long f_ffree;
	__kernel_fsid_t f_fsid;
	long f_namelen;
	long f_spare[6];
};





# 4 "/home/linas/src/linux/include/linux/vfs.h" 2



# 14 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/net.h" 1
 



















# 1 "/home/linas/src/linux/include/linux/socket.h" 1





# 1 "/home/linas/src/linux/include/asm/socket.h" 1



 







 
















 







 






 




# 6 "/home/linas/src/linux/include/linux/socket.h" 2

# 1 "/home/linas/src/linux/include/linux/sockios.h" 1
 



















# 1 "/home/linas/src/linux/include/asm/sockios.h" 1



# 15 "/home/linas/src/linux/include/asm/sockios.h"



# 21 "/home/linas/src/linux/include/linux/sockios.h" 2


 




 











































 
		     




 




 




 




 

 





 


 


 


# 7 "/home/linas/src/linux/include/linux/socket.h" 2

# 1 "/home/linas/src/linux/include/linux/uio.h" 1





 









 


struct iovec
{
	void *iov_base;		 
	__kernel_size_t iov_len;  
};

 


 









# 8 "/home/linas/src/linux/include/linux/socket.h" 2



typedef unsigned short	sa_family_t;

 


 
struct sockaddr {
	sa_family_t	sa_family;	 
	char		sa_data[14];	 
};

struct linger {
	int		l_onoff;	 
	int		l_linger;	 
};

 




 
struct msghdr {
	void	*	msg_name;	 
	int		msg_namelen;	 
	struct iovec *	msg_iov;	 
	__kernel_size_t	msg_iovlen;	 
	void 	*	msg_control;	 
	__kernel_size_t	msg_controllen;	 
	unsigned	msg_flags;
};

 





struct cmsghdr {
	__kernel_size_t	cmsg_len;	 
        int		cmsg_level;	 
        int		cmsg_type;	 
};

 


















 


 











 











 
extern __inline__  struct cmsghdr * __cmsg_nxthdr(void *__ctl, __kernel_size_t __size,
					       struct cmsghdr *__cmsg)
{
	struct cmsghdr * __ptr;

	__ptr = (struct cmsghdr*)(((unsigned char *) __cmsg) +  ( (( __cmsg->cmsg_len )+sizeof(long)-1) & ~(sizeof(long)-1) ) );
	if ((unsigned long)((char*)(__ptr+1) - (char *) __ctl) > __size)
		return ((void *) 0) ;

	return __ptr;
}

extern __inline__  struct cmsghdr * cmsg_nxthdr (struct msghdr *__msg, struct cmsghdr *__cmsg)
{
	return __cmsg_nxthdr(__msg->msg_control, __msg->msg_controllen, __cmsg);
}

 





struct ucred {
	__u32	pid;
	__u32	uid;
	__u32	gid;
};

 







					 
					 
					 
					 

 



























 




























 


 


 























 

 
















 


 





extern int memcpy_fromiovec(unsigned char *kdata, struct iovec *iov, int len);
extern int memcpy_fromiovecend(unsigned char *kdata, struct iovec *iov, 
				int offset, int len);
extern int csum_partial_copy_fromiovecend(unsigned char *kdata, 
					  struct iovec *iov, 
					  int offset, 
					  unsigned int len, int *csump);

extern int verify_iovec(struct msghdr *m, struct iovec *iov, char *address, int mode);
extern int memcpy_toiovec(struct iovec *v, unsigned char *kdata, int len);
extern void memcpy_tokerneliovec(struct iovec *iov, unsigned char *kdata, int len);
extern int move_addr_to_user(void *kaddr, int klen, void *uaddr, int *ulen);
extern int move_addr_to_kernel(void *uaddr, int ulen, void *kaddr);
extern int put_cmsg(struct msghdr*, int level, int type, int len, void *data);



# 21 "/home/linas/src/linux/include/linux/net.h" 2


struct poll_table_struct;























typedef enum {
  SS_FREE = 0,				 
  SS_UNCONNECTED,			 
  SS_CONNECTING,			 
  SS_CONNECTED,				 
  SS_DISCONNECTING			 
} socket_state;







struct socket
{
	socket_state		state;

	unsigned long		flags;
	struct proto_ops	*ops;
	struct inode		*inode;
	struct fasync_struct	*fasync_list;	 
	struct file		*file;		 
	struct sock		*sk;
	struct wait_queue	*wait;

	short			type;
	unsigned char		passcred;
	unsigned char		tli;
};



struct scm_cookie;

struct proto_ops {
  int	family;

  int	(*dup)		(struct socket *newsock, struct socket *oldsock);
  int	(*release)	(struct socket *sock, struct socket *peer);
  int	(*bind)		(struct socket *sock, struct sockaddr *umyaddr,
			 int sockaddr_len);
  int	(*connect)	(struct socket *sock, struct sockaddr *uservaddr,
			 int sockaddr_len, int flags);
  int	(*socketpair)	(struct socket *sock1, struct socket *sock2);
  int	(*accept)	(struct socket *sock, struct socket *newsock,
			 int flags);
  int	(*getname)	(struct socket *sock, struct sockaddr *uaddr,
			 int *usockaddr_len, int peer);
  unsigned int (*poll)	(struct file *file, struct socket *sock, struct poll_table_struct *wait);
  int	(*ioctl)	(struct socket *sock, unsigned int cmd,
			 unsigned long arg);
  int	(*listen)	(struct socket *sock, int len);
  int	(*shutdown)	(struct socket *sock, int flags);
  int	(*setsockopt)	(struct socket *sock, int level, int optname,
			 char *optval, int optlen);
  int	(*getsockopt)	(struct socket *sock, int level, int optname,
			 char *optval, int *optlen);
  int	(*fcntl)	(struct socket *sock, unsigned int cmd,
			 unsigned long arg);	
  int   (*sendmsg)	(struct socket *sock, struct msghdr *m, int total_len, struct scm_cookie *scm);
  int   (*recvmsg)	(struct socket *sock, struct msghdr *m, int total_len, int flags, struct scm_cookie *scm);
};

struct net_proto_family 
{
	int	family;
	int	(*create)(struct socket *sock, int protocol);
	 

	short	authentication;
	short	encryption;
	short	encrypt_net;
};

struct net_proto 
{
	const char *name;		 
	void (*init_func)(struct net_proto *);	 
};

extern struct net_proto_family *net_families[];
extern int	sock_wake_async(struct socket *sk, int how);
extern int	sock_register(struct net_proto_family *fam);
extern int	sock_unregister(int family);
extern struct socket *sock_alloc(void);
extern int	sock_create(int family, int type, int proto, struct socket **);
extern void	sock_release(struct socket *);
extern int   	sock_sendmsg(struct socket *, struct msghdr *m, int len);
extern int	sock_recvmsg(struct socket *, struct msghdr *m, int len, int flags);
extern int	sock_readv_writev(int type, struct inode * inode, struct file * file,
				  const struct iovec * iov, long count, long size);

extern int	net_ratelimit(void);
extern unsigned long net_random(void);
extern void net_srandom(unsigned long);



# 15 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/kdev_t.h" 1



 























































 






typedef unsigned short kdev_t;








extern char * kdevname(kdev_t);	 

 




static inline unsigned int kdev_t_to_nr(kdev_t dev) {
	return (((unsigned int) (( dev ) >> 8 )) <<8) | ((unsigned int) (( dev ) & ((1U << 8 ) - 1) )) ;
}

static inline kdev_t to_kdev_t(int dev)
{
	int major, minor;








	major = (dev >> 8);
	minor = (dev & 0xff);

	return ((( major ) << 8 ) | (  minor )) ;
}

# 113 "/home/linas/src/linux/include/linux/kdev_t.h"


# 16 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ioctl.h" 1



# 1 "/home/linas/src/linux/include/asm/ioctl.h" 1




 



















 














 





 





 







# 4 "/home/linas/src/linux/include/linux/ioctl.h" 2




# 17 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/list.h" 1





 









struct list_head {
	struct list_head *next, *prev;
};








 





static __inline__ void __list_add(struct list_head * new,
	struct list_head * prev,
	struct list_head * next)
{
	next->prev = new;
	new->next = next;
	new->prev = prev;
	prev->next = new;
}

 


static __inline__ void list_add(struct list_head *new, struct list_head *head)
{
	__list_add(new, head, head->next);
}

 






static __inline__ void __list_del(struct list_head * prev,
				  struct list_head * next)
{
	next->prev = prev;
	prev->next = next;
}

static __inline__ void list_del(struct list_head *entry)
{
	__list_del(entry->prev, entry->next);
}

static __inline__ int list_empty(struct list_head *head)
{
	return head->next == head;
}

 


static __inline__ void list_splice(struct list_head *list, struct list_head *head)
{
	struct list_head *first = list->next;

	if (first != list) {
		struct list_head *last = list->prev;
		struct list_head *at = head->next;

		first->prev = head;
		head->next = first;

		last->next = at;
		at->prev = last;
	}
}







# 18 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/dcache.h" 1





 









 



struct qstr {
	const unsigned char * name;
	unsigned int len;
	unsigned int hash;
};

 


 
static __inline__ unsigned long partial_name_hash(unsigned long c, unsigned long prevhash)
{
	prevhash = (prevhash << 4) | (prevhash >> (8*sizeof(unsigned long)-4));
	return prevhash ^ c;
}

 
static __inline__ unsigned long end_name_hash(unsigned long hash)
{
	if (sizeof(hash) > sizeof(unsigned int))
		hash += hash >> 4*sizeof(hash);
	return (unsigned int) hash;
}

 
static __inline__ unsigned int full_name_hash(const unsigned char * name, unsigned int len)
{
	unsigned long hash = 0 ;
	while (len--)
		hash = partial_name_hash(*name++, hash);
	return end_name_hash(hash);
}



struct dentry {
	int d_count;
	unsigned int d_flags;
	struct inode  * d_inode;	 
	struct dentry * d_parent;	 
	struct dentry * d_mounts;	 
	struct dentry * d_covers;
	struct list_head d_hash;	 
	struct list_head d_lru;		 
	struct list_head d_child;	 
	struct list_head d_subdirs;	 
	struct list_head d_alias;	 
	struct qstr d_name;
	unsigned long d_time;		 
	struct dentry_operations  *d_op;
	struct super_block * d_sb;	 
	unsigned long d_reftime;	 
	void * d_fsdata;		 
	unsigned char d_iname[16 ];  
};

struct dentry_operations {
	int (*d_revalidate)(struct dentry *);
	int (*d_hash) (struct dentry *, struct qstr *);
	int (*d_compare) (struct dentry *, struct qstr *, struct qstr *);
	void (*d_delete)(struct dentry *);
	void (*d_release)(struct dentry *);
	void (*d_iput)(struct dentry *, struct inode *);
};

 








 






 












static __inline__ void d_drop(struct dentry * dentry)
{
	list_del(&dentry->d_hash);
	do { ( &dentry->d_hash )->next = ( &dentry->d_hash ); ( &dentry->d_hash )->prev = ( &dentry->d_hash ); } while (0) ;
}

static __inline__ int dname_external(struct dentry *d)
{
	return d->d_name.name != d->d_iname; 
}

 


extern void d_instantiate(struct dentry *, struct inode *);
extern void d_delete(struct dentry *);

 
extern struct dentry * d_alloc(struct dentry * parent, const struct qstr *name);
extern void prune_dcache(int);
extern void shrink_dcache_sb(struct super_block *);
extern void shrink_dcache_parent(struct dentry *);
extern int d_invalidate(struct dentry *);



 
extern int  select_dcache(int, int);
extern void shrink_dcache_memory(int, unsigned int);
extern void check_dcache_memory(void);
extern void free_inode_memory(int);	 

 
extern struct dentry * d_alloc_root(struct inode * root_inode, struct dentry * old_root);

 
extern int is_root_busy(struct dentry *);

 


extern void d_rehash(struct dentry * entry);
 



static __inline__ void d_add(struct dentry * entry, struct inode * inode)
{
	d_rehash(entry);
	d_instantiate(entry, inode);
}

 
extern void d_move(struct dentry * entry, struct dentry * newdentry);

 
extern struct dentry * d_lookup(struct dentry * dir, struct qstr * name);

 
extern int d_validate(struct dentry *dentry, struct dentry *dparent,
		      unsigned int hash, unsigned int len);

 
extern char * d_path(struct dentry * entry, char * buf, int buflen);

 
static __inline__ struct dentry * dget(struct dentry *dentry)
{
	if (dentry)
		dentry->d_count++;
	return dentry;
}

extern void dput(struct dentry *);




# 19 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/stat.h" 1





# 1 "/home/linas/src/linux/include/asm/stat.h" 1





struct __old_kernel_stat {
	unsigned short st_dev;
	unsigned short st_ino;
	unsigned short st_mode;
	unsigned short st_nlink;
	unsigned short st_uid;
	unsigned short st_gid;
	unsigned short st_rdev;
	unsigned long  st_size;
	unsigned long  st_atime;
	unsigned long  st_mtime;
	unsigned long  st_ctime;
};
struct stat {
	dev_t		st_dev;
	ino_t		st_ino;
	mode_t		st_mode;
	nlink_t		st_nlink;
	uid_t 		st_uid;
	gid_t 		st_gid;
	dev_t		st_rdev;
	off_t		st_size;
	unsigned long  	st_blksize;
	unsigned long  	st_blocks;
	unsigned long  	st_atime;
	unsigned long  	__unused1;
	unsigned long  	st_mtime;
	unsigned long  	__unused2;
	unsigned long  	st_ctime;
	unsigned long  	__unused3;
	unsigned long  	__unused4;
	unsigned long  	__unused5;
};


# 6 "/home/linas/src/linux/include/linux/stat.h" 2




















































# 20 "/home/linas/src/linux/include/linux/fs.h" 2



# 1 "/home/linas/src/linux/include/asm/bitops.h" 1
 








# 1 "/home/linas/src/linux/include/asm/system.h" 1




# 1 "/home/linas/src/linux/include/asm/processor.h" 1





# 1 "/home/linas/src/linux/include/asm/asm.h" 1

 










 
 
 
extern inline unsigned long _get_SP(void)
{
        unsigned long rc;
        asm volatile ("LR	%0,sp" : "=r" (rc) : );
        return rc;
}

 
 
extern inline void _set_SP (unsigned long newsp)
{
        asm volatile ("LR	sp,%0" : : "r" (newsp) : "memory");
}

 
 
extern inline void _store_fpregs (double *memy)
{
        asm volatile (
		"STD	f0,%0;		\n"
		"STD	f2,%1;		\n"
		"STD	f4,%2;		\n"
		"STD	f6,%3;		\n"
		: "=m" (memy[0]), 
		  "=m" (memy[1]),
		  "=m" (memy[2]),
		  "=m" (memy[3]) );
}

 
extern inline void _load_fpregs (double *memy)
{
        asm volatile (
		"LD	f0,%0;		\n"
		"LD	f2,%1;		\n"
		"LD	f4,%2;		\n"
		"LD	f6,%3;		\n"
		: : "m" (memy[0]), 
		    "m" (memy[1]),
		    "m" (memy[2]),
		    "m" (memy[3]) );
}

 
 



 
extern inline unsigned long long _stck (void)
{
    
   char area[12];
   unsigned long ptr = (unsigned long ) area;
   unsigned long long *tockee;
   ptr = ((ptr+4) >> 3) << 3;
   tockee = (unsigned long long *) ptr;
   asm volatile ("STCK	%0" : "=m" (*tockee) );
   return *tockee;
}

 
extern inline unsigned long long _stckc (void)
{
    
   char area[12];
   unsigned long ptr = (unsigned long ) area;
   unsigned long long *tockee;
   ptr = ((ptr+4) / 8) * 8;
   tockee = (unsigned long long *) ptr;
   asm volatile ("STCKC	%0" : "=m" (*tockee) );
   return *tockee;
}

 
extern inline void _sckc (unsigned long long tickee)
{
   char area[12];
   unsigned long ptr = (unsigned long ) area;
   unsigned long long *tockee;
   ptr = ((ptr+4) >> 3) << 3;
   tockee = (unsigned long long *) ptr;
   *tockee = tickee;
   asm volatile ("SCKC	%0" : : "m" (*tockee) );
}

 
 
extern inline void _sske (unsigned int key, unsigned int realaddr)
{
    
   asm volatile ("SSKE	%0,%1" : : "r" (key), "r" (realaddr) : "memory");
}

 
extern inline unsigned int _iske (unsigned int realaddr)
{
   unsigned int key;
   asm volatile ("ISKE	%0,%1" : "=r" (key) : "r" (realaddr) );
   return key;
}

 
extern inline void _spka (unsigned int key)
{
   asm volatile ("SPKA	0(%0)" : : "r" (key));
}

 

extern inline void _lpsw (unsigned long long psw)
{
   asm volatile ("LPSW	%0" : : "m" (psw) : "memory");
}

 
 











extern inline void _lctl_r0  (unsigned int value)	{	asm volatile ("LCTL  " "0" "," "0" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r1  (unsigned int value)	{	asm volatile ("LCTL  " "1" "," "1" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r2  (unsigned int value)	{	asm volatile ("LCTL  " "2" "," "2" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r3  (unsigned int value)	{	asm volatile ("LCTL  " "3" "," "3" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r4  (unsigned int value)	{	asm volatile ("LCTL  " "4" "," "4" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r5  (unsigned int value)	{	asm volatile ("LCTL  " "5" "," "5" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r6  (unsigned int value)	{	asm volatile ("LCTL  " "6" "," "6" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r7  (unsigned int value)	{	asm volatile ("LCTL  " "7" "," "7" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r8  (unsigned int value)	{	asm volatile ("LCTL  " "8" "," "8" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r9  (unsigned int value)	{	asm volatile ("LCTL  " "9" "," "9" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r10  (unsigned int value)	{	asm volatile ("LCTL  " "10" "," "10" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r11  (unsigned int value)	{	asm volatile ("LCTL  " "11" "," "11" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r12  (unsigned int value)	{	asm volatile ("LCTL  " "12" "," "12" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r13  (unsigned int value)	{	asm volatile ("LCTL  " "13" "," "13" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r14  (unsigned int value)	{	asm volatile ("LCTL  " "14" "," "14" ",%0" : : "m" (value) : "memory");	} 
extern inline void _lctl_r15  (unsigned int value)	{	asm volatile ("LCTL  " "15" "," "15" ",%0" : : "m" (value) : "memory");	} 

 
 
 

 

# 175 "/home/linas/src/linux/include/asm/asm.h"
 
extern inline unsigned long _stctl_r0  (void)	{	unsigned long area;	asm volatile ("STCTL  " "0" "," "0" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r1  (void)	{	unsigned long area;	asm volatile ("STCTL  " "1" "," "1" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r2  (void)	{	unsigned long area;	asm volatile ("STCTL  " "2" "," "2" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r3  (void)	{	unsigned long area;	asm volatile ("STCTL  " "3" "," "3" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r4  (void)	{	unsigned long area;	asm volatile ("STCTL  " "4" "," "4" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r5  (void)	{	unsigned long area;	asm volatile ("STCTL  " "5" "," "5" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r6  (void)	{	unsigned long area;	asm volatile ("STCTL  " "6" "," "6" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r7  (void)	{	unsigned long area;	asm volatile ("STCTL  " "7" "," "7" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r8  (void)	{	unsigned long area;	asm volatile ("STCTL  " "8" "," "8" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r9  (void)	{	unsigned long area;	asm volatile ("STCTL  " "9" "," "9" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r10  (void)	{	unsigned long area;	asm volatile ("STCTL  " "10" "," "10" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r11  (void)	{	unsigned long area;	asm volatile ("STCTL  " "11" "," "11" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r12  (void)	{	unsigned long area;	asm volatile ("STCTL  " "12" "," "12" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r13  (void)	{	unsigned long area;	asm volatile ("STCTL  " "13" "," "13" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r14  (void)	{	unsigned long area;	asm volatile ("STCTL  " "14" "," "14" ",%0" : "=m" (area) );	return(area);	} 
extern inline unsigned long _stctl_r15  (void)	{	unsigned long area;	asm volatile ("STCTL  " "15" "," "15" ",%0" : "=m" (area) );	return(area);	} 
 
 
 
extern inline unsigned long _stap (void)
{
	unsigned short cpuid;
	asm volatile ("STAP	%0" : "=m" (cpuid) );
	return ((unsigned long) cpuid);
}

 
 
extern inline long _sigp (unsigned long addr,
                         unsigned long code)
{
	long rc;

	asm volatile (
		"SIGP   %1,%2(0);       \n"
		"IPM    r1;     \n"
		"SRL    r1,28;  \n"
		"LR     %0,r1;  \n"
		: "=r" (rc)
		: "r" (addr), "m" (code)
		: "r1", "memory");
	return (rc);
}

 
 
extern inline void _ptlb (void)
{
	asm volatile ("PTLB" : : : "memory");
}

 
extern inline void _ipte (void *sto, void *pfx)
{
	asm volatile (
		"IPTE %0,%1\n"
		:
		: "r" (sto), "r" (pfx)
		: "memory");
}

 
 

extern inline void i370_halt (void)
{
	 
	 
	char area[12];
	unsigned long ptr = (unsigned long ) area;
	unsigned long long *psw;
	ptr = ((ptr+4) / 8) * 8;
	psw = (unsigned long long *) ptr;
	asm volatile (
	"	L	r1,=X'000a0000';	\n"
	"	ST	r1,%0;			\n"
	"	L	r1,=A(1f);		\n"
	"	O	r1,=X'80000000';	\n"
	"	ST	r1,4+%0;		\n"
	"	LPSW	%0;			\n"
	"1:	NOPR	r0;			\n"
	: "+m" (*psw) : : "r1", "memory");
}

 



# 6 "/home/linas/src/linux/include/asm/processor.h" 2

# 1 "/home/linas/src/linux/include/asm/ptrace.h" 1



 











 
struct _i370_psw_s {
	unsigned long flags;
	unsigned long addr;
} __attribute__ ((aligned (8)));
typedef struct _i370_psw_s psw_t __attribute__ ((aligned (8)));

 
 
struct _i370_cr0_s {
	 
	unsigned long :1;	 
	unsigned long ssmc:1;	 
	unsigned long todc:1;	 
	unsigned long lapc:1;	 
	unsigned long eac:1;	 
	unsigned long ssc:1;	 
	unsigned long fpoc:1;	 
	unsigned long spoc:1;	 
	unsigned long tf:5;	 
	unsigned long :1;	 
	unsigned long vc:1;	 
	unsigned long asfc:1;	 
	unsigned long masm:1;	 
	unsigned long essm:1;	 
	unsigned long ecsm:1;	 
	unsigned long todsm:1;	 
	unsigned long clksm:1;	 
	unsigned long cpusm:1;	 
	unsigned long sssm:1;	 
	unsigned long :2;	 
	unsigned long iksm:1;	 
	unsigned long :6;	 
	 
};
typedef struct _i370_cr0_s i370_cr0_t;

union _i370_cr0_u {
	i370_cr0_t    bits;
	unsigned long raw;
};
typedef union _i370_cr0_u cr0_t;

 
 
struct _i370_cr1_s {
	 
	unsigned long pssec:1;	 
	unsigned long psto:19;	 
	unsigned long :2;	 
	unsigned long psgc:1;	 
	unsigned long ppsc:1;	 
	unsigned long psaec:1;	 
	unsigned long pstl:7;	 
	 
};
typedef struct _i370_cr1_s i370_cr1_t;

union _i370_cr1_u {
	i370_cr1_t    bits;
	unsigned long raw;
};
typedef union _i370_cr1_u cr1_t;

 
 
struct _i370_cr6_s {
	 
	unsigned long iosm:8;	 
	unsigned long :24;	 
	 
};
typedef struct _i370_cr6_s i370_cr6_t;

union _i370_cr6_u {
	i370_cr6_t    bits;
	unsigned long raw;
};
typedef union _i370_cr6_u cr6_t;

 
 






















struct _i370_elf_stack_s {
	unsigned long	eyecatcher;		 
	unsigned long	caller_sp;		 
	unsigned long	callee_sp;		 
	unsigned long	caller_r14;		 
	unsigned long	caller_r15;		 
	unsigned long	caller_r0;		 
	unsigned long	caller_r1;		 
	unsigned long	caller_r2;		 
	unsigned long	caller_r3;		 
	unsigned long	caller_r4;		 
	unsigned long	caller_r5;		 
	unsigned long	caller_r6;		 
	unsigned long	caller_r7;		 
	unsigned long	caller_r8;		 
	unsigned long	caller_r9;		 
	unsigned long	caller_r10;		 
	unsigned long	caller_r11;		 
	unsigned long	caller_r12;		 
	unsigned long	unused;		 	  
	unsigned long	x0;			 
	unsigned long	x1;			 
	unsigned long	x2;			 
	unsigned long	x3;			 
	unsigned long	x4;			 
	unsigned long	x5;			 
	unsigned long	x6;			 
	unsigned long	x7;			 
	unsigned long	x8;			 
	unsigned long	x9;			 
	unsigned long	x10;			 
	unsigned long	x11;			 
	unsigned long	x12;			 
	unsigned long	x13;			 
	unsigned long	x14;			 
	unsigned long	x15;			 
	unsigned long	x16;			 
	unsigned long	scratch;		 
};
typedef struct _i370_elf_stack_s i370_elf_stack_t;

 

struct _i370_irregs_s {
	unsigned long	r11;
	unsigned long	r12;
	unsigned long	r13;
	unsigned long	r14;
	unsigned long	r15;
	unsigned long	r0;
	unsigned long	r1;
	unsigned long	r2;
	unsigned long	r3;
	unsigned long	r4;
	unsigned long	r5;
	unsigned long	r6;
	unsigned long	r7;
	unsigned long	r8;
	unsigned long	r9;
	unsigned long	r10;
};
typedef struct _i370_irregs_s irregs_t;


 
 








typedef struct _i370_interrupt_state_s i370_interrupt_state_t;

struct _i370_interrupt_state_s {
	psw_t   	psw;	 
	irregs_t	irregs;	 
	cr0_t		cr0;	 
	cr1_t		cr1;	 
	i370_interrupt_state_t *oldregs;	 

 
 
 
 
};











 








# 7 "/home/linas/src/linux/include/asm/processor.h" 2


 
 
 
 
 



























 
 
 





 



 

 
 











 






 




 
 
 










 
 
 


















 
 
 
 
 
 

 
 






 
 
 


















































 


 
 
 

typedef struct
{
	short int ei_code;
	void (*ei_flih)(i370_interrupt_state_t *, unsigned short);
} ei_handler;

typedef struct
{
	short int iucv_path;         
	unsigned long iucv_uword;    
	void  *iucv_buffer;          
} iucv_path;

 
 
 
 
typedef struct
{
	short int pc_code;
	int (*pc_flih)(i370_interrupt_state_t *, unsigned long, unsigned short);
} pc_handler;
 
 
 
 

typedef struct
{
	unsigned long  CPU_address;   
	char  CPU_name[8];            
	unsigned long CPU_status;     
	char  xxx[4];                 
} CPU_t;

























 
 
 
 
 
 
 


 
 
 
 
void i370_start_thread(struct _i370_interrupt_state_s  *regs, unsigned long pswa, unsigned long sp);
struct task_struct;
void release_thread(struct task_struct *);


 
 
 
 


 
 
 
 
 
 
 
 
 
 
 
 
 
typedef struct {
	unsigned long seg;
} mm_segment_t;

struct thread_struct {
	unsigned long	ksp;		 
	struct _i370_interrupt_state_s  *regs;		 
	double		fpr[16];	 

	 
	unsigned long	*pg_tables;	 
	unsigned long	wchan;		 
	mm_segment_t	fs;		 
	signed long     last_syscall;
	unsigned long	smp_fork_ret;
};



 





# 320 "/home/linas/src/linux/include/asm/processor.h"

 







 


static inline unsigned long thread_saved_pc(struct thread_struct *t)
{
	return (t->regs) ? (t->regs->psw.addr &0x7fffffff) : 0;
}





 









  

# 5 "/home/linas/src/linux/include/asm/system.h" 2



 









 

extern __inline__ unsigned long __cli (void)
{
	unsigned char oldval;
	 
	asm volatile ("STNSM    %0,0xfc" : "=m" (oldval) : : "memory");
	return oldval;
}

extern __inline__ unsigned long __sti (void)
{
	unsigned char oldval;
	 
	asm volatile ("STOSM    %0,0x3" : "=m" (oldval) : : "memory");
	return oldval;
}

extern __inline__ unsigned long __get_save_flags (void)
{
	unsigned char oldval;
	 
	asm volatile ("STOSM    %0,0x0" : "=m" (oldval) : : "memory" );
	return oldval;
}




extern __inline__ void __restore_flags(unsigned long flags)
{
	unsigned char newval = flags;
	 
	asm volatile ("SSM	%0" : : "m" (newval) : "memory");
}









# 73 "/home/linas/src/linux/include/asm/system.h"




extern void *xchg_u64(void *ptr, unsigned long val);
extern void *xchg_u32(void *m, unsigned long val);

 







extern void __xchg_called_with_bad_pointer(void);




static inline unsigned long __xchg(unsigned long x, void * ptr, int size)
{
	switch (size) {
		case 4:
			return (unsigned long )xchg_u32(ptr, x);
		case 8:
			return (unsigned long )xchg_u64(ptr, x);
	}
	__xchg_called_with_bad_pointer();
	return x;


}

extern inline void * xchg_ptr(void * m, void * val)
{
	return (void *) xchg_u32(m, (unsigned long) val);
}

extern void print_backtrace(unsigned long stack_pointer);
extern void show_regs(struct _i370_interrupt_state_s  * regs);
extern void giveup_fpu(void);
extern void smp_giveup_fpu(struct task_struct *);

struct task_struct;
extern int i370_switch_to(struct task_struct *prev, struct task_struct *next);


extern void dump_regs(struct _i370_interrupt_state_s  *);


# 10 "/home/linas/src/linux/include/asm/bitops.h" 2

# 1 "/home/linas/src/linux/include/asm/byteorder.h" 1



 









# 1 "/home/linas/src/linux/include/linux/byteorder/big_endian.h" 1










# 1 "/home/linas/src/linux/include/linux/byteorder/swab.h" 1



 













 













# 41 "/home/linas/src/linux/include/linux/byteorder/swab.h"

 

































 






















extern __inline__ __const__ __u16 __fswab16(__u16 x)
{
	return ((__u16)( (((__u16)(  x  ) & (__u16)0x00ffU) << 8) | (((__u16)(  x  ) & (__u16)0xff00U) >> 8) ))  ;
}
extern __inline__ __u16 __swab16p(__u16 *x)
{
	return (__builtin_constant_p((__u16)( *( x ) )) ? ((__u16)( (((__u16)( ( *( x ) ) ) & (__u16)0x00ffU) << 8) | (((__u16)( ( *( x ) ) ) & (__u16)0xff00U) >> 8) ))  : __fswab16(( *( x ) )))  ;
}
extern __inline__ void __swab16s(__u16 *addr)
{
	do { *( addr ) = __swab16p(( addr )); } while (0) ;
}

extern __inline__ __const__ __u32 __fswab32(__u32 x)
{
	return ((__u32)( (((__u32)(  x  ) & (__u32)0x000000ffUL) << 24) | (((__u32)(  x  ) & (__u32)0x0000ff00UL) <<  8) | (((__u32)(  x  ) & (__u32)0x00ff0000UL) >>  8) | (((__u32)(  x  ) & (__u32)0xff000000UL) >> 24) ))  ;
}
extern __inline__ __u32 __swab32p(__u32 *x)
{
	return (__builtin_constant_p((__u32)( *( x ) )) ? ((__u32)( (((__u32)( ( *( x ) ) ) & (__u32)0x000000ffUL) << 24) | (((__u32)( ( *( x ) ) ) & (__u32)0x0000ff00UL) <<  8) | (((__u32)( ( *( x ) ) ) & (__u32)0x00ff0000UL) >>  8) | (((__u32)( ( *( x ) ) ) & (__u32)0xff000000UL) >> 24) ))  : __fswab32(( *( x ) )))  ;
}
extern __inline__ void __swab32s(__u32 *addr)
{
	do { *( addr ) = __swab32p(( addr )); } while (0) ;
}


extern __inline__ __const__ __u64 __fswab64(__u64 x)
{





	return ((__u64)( (__u64)(((__u64)(  x  ) & (__u64)0x00000000000000ffULL) << 56) | (__u64)(((__u64)(  x  ) & (__u64)0x000000000000ff00ULL) << 40) | (__u64)(((__u64)(  x  ) & (__u64)0x0000000000ff0000ULL) << 24) | (__u64)(((__u64)(  x  ) & (__u64)0x00000000ff000000ULL) <<  8) | (__u64)(((__u64)(  x  ) & (__u64)0x000000ff00000000ULL) >>  8) | (__u64)(((__u64)(  x  ) & (__u64)0x0000ff0000000000ULL) >> 24) | (__u64)(((__u64)(  x  ) & (__u64)0x00ff000000000000ULL) >> 40) | (__u64)(((__u64)(  x  ) & (__u64)0xff00000000000000ULL) >> 56) ))  ;

}
extern __inline__ __u64 __swab64p(__u64 *x)
{
	return (__builtin_constant_p((__u64)( *( x ) )) ? ((__u64)( (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x00000000000000ffULL) << 56) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x000000000000ff00ULL) << 40) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x0000000000ff0000ULL) << 24) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x00000000ff000000ULL) <<  8) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x000000ff00000000ULL) >>  8) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x0000ff0000000000ULL) >> 24) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0x00ff000000000000ULL) >> 40) | (__u64)(((__u64)( ( *( x ) ) ) & (__u64)0xff00000000000000ULL) >> 56) ))  : __fswab64(( *( x ) )))  ;
}
extern __inline__ void __swab64s(__u64 *addr)
{
	do { *( addr ) = __swab64p(( addr )); } while (0) ;
}















# 11 "/home/linas/src/linux/include/linux/byteorder/big_endian.h" 2











































# 1 "/home/linas/src/linux/include/linux/byteorder/generic.h" 1



 




































 









































 










































 


















 



extern unsigned long int	ntohl(unsigned long int);
extern unsigned short int	ntohs(unsigned short int);
extern unsigned long int	htonl(unsigned long int);
extern unsigned short int	htons(unsigned short int);


















# 54 "/home/linas/src/linux/include/linux/byteorder/big_endian.h" 2



# 14 "/home/linas/src/linux/include/asm/byteorder.h" 2



# 11 "/home/linas/src/linux/include/asm/bitops.h" 2


 




extern void set_bit(int nr, volatile void *addr);
extern void clear_bit(int nr, volatile void *addr);
extern void change_bit(int nr, volatile void *addr);
extern int test_and_set_bit(int nr, volatile void *addr);
extern int test_and_clear_bit(int nr, volatile void *addr);
extern int test_and_change_bit(int nr, volatile void *addr);


 


extern __inline__ unsigned long test_bit(int nr, __const__ volatile void *addr)
{
	__const__ unsigned int *p = (__const__ unsigned int *) addr;

	return (p[nr >> 5] >> (nr & 0x1f)) & 1UL;
}

 



extern __inline__ unsigned long ffz(unsigned long word)
{
        int k;

        word = ~word;
        k = 31;
        if (word & 0x0000ffff) { k -= 16; word <<= 16; }
        if (word & 0x00ff0000) { k -= 8;  word <<= 8;  }
        if (word & 0x0f000000) { k -= 4;  word <<= 4;  }
        if (word & 0x30000000) { k -= 2;  word <<= 2;  }
        if (word & 0x40000000) { k -= 1; }
        return k;
}




 







 










 






extern __inline__ unsigned long find_next_zero_bit(void * addr,
	unsigned long size, unsigned long offset)
{
	unsigned int * p = ((unsigned int *) addr) + (offset >> 5);
	unsigned int result = offset & ~31UL;
	unsigned int tmp;

	if (offset >= size)
		return size;
	size -= result;
	offset &= 31UL;
	if (offset) {
		tmp = *p++;
		tmp |= ~0UL >> (32-offset);
		if (size < 32)
			goto found_first;
		if (tmp != ~0U)
			goto found_middle;
		size -= 32;
		result += 32;
	}
	while (size >= 32) {
		if ((tmp = *p++) != ~0U)
			goto found_middle;
		result += 32;
		size -= 32;
	}
	if (!size)
		return result;
	tmp = *p;
found_first:
	tmp |= ~0UL << size;
found_middle:
	return result + ffz(tmp);
}





 






# 156 "/home/linas/src/linux/include/asm/bitops.h"


extern __inline__ int ext2_test_bit(int nr, __const__ void * addr)
{
	__const__ unsigned char	*ADDR = (__const__ unsigned char *) addr;

	return (ADDR[nr >> 3] >> (nr & 7)) & 1;
}

 







extern __inline__ unsigned long ext2_find_next_zero_bit(void *addr,
	unsigned long size, unsigned long offset)
{
	unsigned int *p = ((unsigned int *) addr) + (offset >> 5);
	unsigned int result = offset & ~31UL;
	unsigned int tmp;

	if (offset >= size)
		return size;
	size -= result;
	offset &= 31UL;
	if (offset) {
		tmp = __swab32p(( p++ )) ;
		tmp |= ~0UL >> (32-offset);
		if (size < 32)
			goto found_first;
		if (tmp != ~0U)
			goto found_middle;
		size -= 32;
		result += 32;
	}
	while (size >= 32) {
		if ((tmp = __swab32p(( p++ )) ) != ~0U)
			goto found_middle;
		result += 32;
		size -= 32;
	}
	if (!size)
		return result;
	tmp = __swab32p(( p )) ;
found_first:
	tmp |= ~0U << size;
found_middle:
	return result + ffz(tmp);
}

 






# 23 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/asm/cache.h" 1
 







 







 




# 24 "/home/linas/src/linux/include/linux/fs.h" 2


struct poll_table_struct;


 








 






 
extern int max_inodes;
extern int max_files, nr_files, nr_free_files;
extern int max_super_blocks, nr_super_blocks;


























 







 















 




 





 




























 




















# 1 "/home/linas/src/linux/include/asm/semaphore.h" 1



 






 


struct semaphore {
	atomic_t count;
	atomic_t waking;
	struct wait_queue * wait;
};




extern void __down(struct semaphore * sem);
extern int  __down_interruptible(struct semaphore * sem);
extern void __up(struct semaphore * sem);



 






static inline void wake_one_more(struct semaphore * sem)
{
	atomic_inc(&sem->waking);
}

static inline int waking_non_zero(struct semaphore *sem, struct task_struct *tsk)
{
 

















return 0;
}

extern inline void down(struct semaphore * sem)
{
	if (atomic_dec_return(&sem->count) < 0)
		__down(sem);
}

extern inline int down_interruptible(struct semaphore * sem)
{
	int ret = 0;
	if (atomic_dec_return(&sem->count) < 0)
		ret = __down_interruptible(sem);
	return ret;
}

extern inline void up(struct semaphore * sem)
{
	if (atomic_inc_return(&sem->count) <= 0)
		__up(sem);
}	


# 160 "/home/linas/src/linux/include/linux/fs.h" 2




extern void update_atime (struct inode *inode);


extern void buffer_init(void);
extern void inode_init(void);
extern void file_table_init(void);
extern void dcache_init(void);

typedef char buffer_block[(1<< 10 ) ];

 






 











struct buffer_head {
	 
	struct buffer_head * b_next;	 
	unsigned long b_blocknr;	 
	unsigned long b_size;		 
	kdev_t b_dev;			 
	kdev_t b_rdev;			 
	unsigned long b_rsector;	 
	struct buffer_head * b_this_page;	 
	unsigned long b_state;		 
	struct buffer_head * b_next_free;
	unsigned int b_count;		 

	 
	char * b_data;			 
	unsigned int b_list;		 
	unsigned long b_flushtime;       

	struct wait_queue * b_wait;
	struct buffer_head ** b_pprev;		 
	struct buffer_head * b_prev_free;	 
	struct buffer_head * b_reqnext;		 

	 


	void (*b_end_io)(struct buffer_head *bh, int uptodate);
	void *b_dev_id;
};

typedef void (bh_end_io_t)(struct buffer_head *bh, int uptodate);
void init_buffer(struct buffer_head *bh, kdev_t dev, int block,
		 bh_end_io_t *handler, void *dev_id);

static inline int buffer_uptodate(struct buffer_head * bh)
{
	return test_bit(0 , &bh->b_state);
}	

static inline int buffer_dirty(struct buffer_head * bh)
{
	return test_bit(1 , &bh->b_state);
}

static inline int buffer_locked(struct buffer_head * bh)
{
	return test_bit(2 , &bh->b_state);
}

static inline int buffer_req(struct buffer_head * bh)
{
	return test_bit(3 , &bh->b_state);
}

static inline int buffer_protected(struct buffer_head * bh)
{
	return test_bit(6 , &bh->b_state);
}

 












# 1 "/home/linas/src/linux/include/linux/pipe_fs_i.h" 1



struct pipe_inode_info {
	struct wait_queue * wait;
	char * base;
	unsigned int start;
	unsigned int lock;
	unsigned int rd_openers;
	unsigned int wr_openers;
	unsigned int readers;
	unsigned int writers;
};





















# 265 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/minix_fs_i.h" 1



 


struct minix_inode_info {
	union {
		__u16 i1_data[16];
		__u32 i2_data[16];
	} u;
};


# 266 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ext2_fs_i.h" 1
 

















 


struct ext2_inode_info {
	__u32	i_data[15];
	__u32	i_flags;
	__u32	i_faddr;
	__u8	i_frag_no;
	__u8	i_frag_size;
	__u16	i_osync;
	__u32	i_file_acl;
	__u32	i_dir_acl;
	__u32	i_dtime;
	__u32	i_version;
	__u32	i_block_group;
	__u32	i_next_alloc_block;
	__u32	i_next_alloc_goal;
	__u32	i_prealloc_block;
	__u32	i_prealloc_count;
	__u32	i_high_size;
	int	i_new_inode:1;	 
};


# 267 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/hpfs_fs_i.h" 1



struct hpfs_inode_info {
	ino_t i_parent_dir;	 
	unsigned i_dno;		 
	unsigned i_dpos;	 
	unsigned i_dsubdno;	 
	unsigned i_file_sec;	 
	unsigned i_disk_sec;	 
	unsigned i_n_secs;	 
	unsigned i_conv : 2;	 
};











# 268 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ntfs_fs_i.h" 1



 
struct ntfs_attribute;
struct ntfs_sb_info;

 


typedef u8  ntfs_u8;
typedef u16 ntfs_u16;
typedef u32 ntfs_u32;
typedef u64 ntfs_u64;
typedef s8  ntfs_s8;
typedef s16 ntfs_s16;
typedef s32 ntfs_s32;
typedef s64 ntfs_s64;




typedef __kernel_mode_t ntmode_t;



typedef __kernel_uid_t ntfs_uid_t;



typedef __kernel_gid_t ntfs_gid_t;



typedef __kernel_size_t ntfs_size_t;



typedef __kernel_time_t ntfs_time_t;


 


typedef unsigned short     ntfs_wchar_t;

 


typedef unsigned long long ntfs_offset_t;

 


typedef unsigned long long ntfs_time64_t;

 


typedef unsigned int ntfs_cluster_t;


 
struct ntfs_inode_info{
	struct ntfs_sb_info *vol;
	int i_number;                 
	unsigned sequence_number;
	unsigned char* attr;          
	int attr_count;               
	struct ntfs_attribute *attrs;
	int record_count;             
	 

	int *records;
	union{
		struct{
			int recordsize;
			int clusters_per_record;
		}index;
	} u;	
};


# 269 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/msdos_fs_i.h" 1







 



struct msdos_inode_info {
	 













	struct pipe_inode_info reserved;
	int i_start;	 
	int i_logstart;	 
	int i_attrs;	 
	int i_ctime_ms;	 
	int i_busy;	 

	int i_binary;	 
};


# 270 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/umsdos_fs_i.h" 1










 





































struct dir_locking_info {
	struct wait_queue *p;
	short int looking;	 
	short int creating;	 



	long pid;		 
	 
};

struct umsdos_inode_info {
	union {
		struct msdos_inode_info msdos_info;
		struct pipe_inode_info pipe_info;
		struct dir_locking_info dir_info;
	} u;
	int i_patched;			 
	int i_is_hlink;			 
	unsigned long i_emd_owner;	 
	off_t pos;			 
	 
	struct dentry *i_emd_dentry;	 
	unsigned long i_emd_dir;	 
};


# 271 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/iso_fs_i.h" 1



 


struct iso_inode_info {
	unsigned int i_first_extent;
	unsigned char i_file_format;
	unsigned long i_next_section_ino;
	off_t i_section_size;
};


# 272 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/nfs_fs_i.h" 1



# 1 "/home/linas/src/linux/include/linux/nfs.h" 1
 





# 1 "/home/linas/src/linux/include/linux/sunrpc/msg_prot.h" 1
 












enum rpc_auth_flavor {
	RPC_AUTH_NULL  = 0,
	RPC_AUTH_UNIX  = 1,
	RPC_AUTH_SHORT = 2,
	RPC_AUTH_DES   = 3,
	RPC_AUTH_KRB   = 4,
};

enum rpc_msg_type {
	RPC_CALL = 0,
	RPC_REPLY = 1
};

enum rpc_reply_stat {
	RPC_MSG_ACCEPTED = 0,
	RPC_MSG_DENIED = 1
};

enum rpc_accept_stat {
	RPC_SUCCESS = 0,
	RPC_PROG_UNAVAIL = 1,
	RPC_PROG_MISMATCH = 2,
	RPC_PROC_UNAVAIL = 3,
	RPC_GARBAGE_ARGS = 4,
	RPC_SYSTEM_ERR = 5
};

enum rpc_reject_stat {
	RPC_MISMATCH = 0,
	RPC_AUTH_ERROR = 1
};

enum rpc_auth_stat {
	RPC_AUTH_OK = 0,
	RPC_AUTH_BADCRED = 1,
	RPC_AUTH_REJECTEDCRED = 2,
	RPC_AUTH_BADVERF = 3,
	RPC_AUTH_REJECTEDVERF = 4,
	RPC_AUTH_TOOWEAK = 5
};









# 7 "/home/linas/src/linux/include/linux/nfs.h" 2



















	
enum nfs_stat {
	NFS_OK = 0,
	NFSERR_PERM = 1,
	NFSERR_NOENT = 2,
	NFSERR_IO = 5,
	NFSERR_NXIO = 6,
	NFSERR_EAGAIN = 11,
	NFSERR_ACCES = 13,
	NFSERR_EXIST = 17,
	NFSERR_XDEV = 18,
	NFSERR_NODEV = 19,
	NFSERR_NOTDIR = 20,
	NFSERR_ISDIR = 21,
	NFSERR_INVAL = 22,	 
	NFSERR_FBIG = 27,
	NFSERR_NOSPC = 28,
	NFSERR_ROFS = 30,
	NFSERR_NAMETOOLONG = 63,
	NFSERR_NOTEMPTY = 66,
	NFSERR_DQUOT = 69,
	NFSERR_STALE = 70,
	NFSERR_WFLUSH = 99
};

enum nfs_ftype {
	NFNON = 0,
	NFREG = 1,
	NFDIR = 2,
	NFBLK = 3,
	NFCHR = 4,
	NFLNK = 5,
	NFSOCK = 6,
	NFBAD = 7,
	NFFIFO = 8
};

struct nfs_fh {
	char			data[32 ];
};






















 










extern struct rpc_program	nfs_program;
extern struct rpc_stat		nfs_rpcstat;

struct nfs_time {
	__u32			seconds;
	__u32			useconds;
};

struct nfs_fattr {
	enum nfs_ftype		type;
	__u32			mode;
	__u32			nlink;
	__u32			uid;
	__u32			gid;
	__u32			size;
	__u32			blocksize;
	__u32			rdev;
	__u32			blocks;
	__u32			fsid;
	__u32			fileid;
	struct nfs_time		atime;
	struct nfs_time		mtime;
	struct nfs_time		ctime;
};

struct nfs_sattr {
	__u32			mode;
	__u32			uid;
	__u32			gid;
	__u32			size;
	struct nfs_time		atime;
	struct nfs_time		mtime;
};

struct nfs_fsinfo {
	__u32			tsize;
	__u32			bsize;
	__u32			blocks;
	__u32			bfree;
	__u32			bavail;
};

struct nfs_writeargs {
	struct nfs_fh *		fh;
	__u32			offset;
	__u32			count;
	const void *		buffer;
};

# 222 "/home/linas/src/linux/include/linux/nfs.h"




# 4 "/home/linas/src/linux/include/linux/nfs_fs_i.h" 2



 


struct nfs_inode_info {
	 




	struct pipe_inode_info	pipeinfo;

	 


	unsigned short		flags;

	 
















	unsigned long		read_cache_jiffies;
	unsigned long		read_cache_mtime;
	unsigned long		attrtimeo;

	 




	struct nfs_wreq *	writeback;
};

 





 


struct nfs_lock_info {
	u32		state;
	u32		flags;
};

 





# 273 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/sysv_fs_i.h" 1



 


struct sysv_inode_info {
	u32 i_data[10+1+1+1];	 




};



# 274 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/affs_fs_i.h" 1



# 1 "/home/linas/src/linux/include/linux/a.out.h" 1







# 1 "/home/linas/src/linux/include/asm/a.out.h" 1



    


struct exec
{
  unsigned long a_info;		 
  unsigned a_text;		 
  unsigned a_data;		 
  unsigned a_bss;		 
  unsigned a_syms;		 
  unsigned a_entry;		 
  unsigned a_trsize;		 
  unsigned a_drsize;		 
};








# 8 "/home/linas/src/linux/include/linux/a.out.h" 2




 
enum machine_type {



  M_OLDSUN2 = 0,




  M_68010 = 1,




  M_68020 = 2,




  M_SPARC = 3,

   
  M_386 = 100,
  M_MIPS1 = 151,	 
  M_MIPS2 = 152,	 
};





















 

 

 

 



 





































 




 

















# 1 "/home/linas/src/linux/include/asm/page.h" 1


# 94 "/home/linas/src/linux/include/asm/page.h"

# 131 "/home/linas/src/linux/include/linux/a.out.h" 2




















 





struct nlist {
  union {
    char *n_name;
    struct nlist *n_next;
    long n_strx;
  } n_un;
  unsigned char n_type;
  char n_other;
  short n_desc;
  unsigned long n_value;
};































 









 










 





 



 




struct relocation_info
{
   
  int r_address;
   
  unsigned int r_symbolnum:24;
   


  unsigned int r_pcrel:1;
   

  unsigned int r_length:2;
   





  unsigned int r_extern:1;
   






  unsigned int r_pad:4;

};




# 4 "/home/linas/src/linux/include/linux/affs_fs_i.h" 2

# 1 "/home/linas/src/linux/include/linux/time.h" 1



# 1 "/home/linas/src/linux/include/asm/param.h" 1




















# 4 "/home/linas/src/linux/include/linux/time.h" 2





struct timespec {
	time_t	tv_sec;		 
	long	tv_nsec;	 
};


 













static __inline__ unsigned long
timespec_to_jiffies(struct timespec *value)
{
	unsigned long sec = value->tv_sec;
	long nsec = value->tv_nsec;

	if (sec >= (((~0UL >> 1)-1)  / 100 ))
		return ((~0UL >> 1)-1) ;
	nsec += 1000000000L / 100  - 1;
	nsec /= 1000000000L / 100 ;
	return 100  * sec + nsec;
}

static __inline__ void
jiffies_to_timespec(unsigned long jiffies, struct timespec *value)
{
	value->tv_nsec = (jiffies % 100 ) * (1000000000L / 100 );
	value->tv_sec = jiffies / 100 ;
}
 
struct timeval {
	time_t		tv_sec;		 
	suseconds_t	tv_usec;	 
};

struct timezone {
	int	tz_minuteswest;	 
	int	tz_dsttime;	 
};




extern void do_gettimeofday(struct timeval *tv);
extern void do_settimeofday(struct timeval *tv);
extern void get_fast_time(struct timeval *tv);
extern void (*do_get_fast_time)(struct timeval *);








 







struct  itimerspec {
        struct  timespec it_interval;     
        struct  timespec it_value;        
};

struct	itimerval {
	struct	timeval it_interval;	 
	struct	timeval it_value;	 
};


# 5 "/home/linas/src/linux/include/linux/affs_fs_i.h" 2





struct key_cache {
	struct timeval	 kc_lru_time;	 
	s32	 kc_first;		 
	s32	 kc_last;		 
	s32	 kc_this_key;		 
	int	 kc_this_seq;		 
	s32	 kc_next_key;		 
	s32	 kc_keys[73 ];	 
};



struct ext_cache {
	struct key_cache  kc[4];	 
	s32	 ec[((1UL << 12 )  - 4 * sizeof(struct key_cache) - 4) / 4 ];		 
	int	 max_ext;		 
};

 


struct affs_inode_info {
	u32	 i_protect;			 
	s32	 i_parent;			 
	s32	 i_original;			 
	s32	 i_data[16 ];	 
	struct ext_cache *i_ec;			 
	int	 i_cache_users;			 
	int	 i_lastblock;			 
	short	 i_pa_cnt;			 
	short	 i_pa_next;			 
	short	 i_pa_last;			 
	short	 i_zone;			 
	unsigned char i_hlink;			 
	unsigned char i_pad;
};


# 275 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ufs_fs_i.h" 1
 














struct ufs_inode_info {
	union {
		__u32	i_data[15];
		__u8	i_symlink[4*15];
	} i_u1;
	__u64	i_size;
	__u32	i_flags;
	__u32	i_gen;
	__u32	i_shadow;
	__u32	i_uid;
	__u32	i_gid;
	__u32	i_oeftflag;
	__u16	i_osync;
	__u32	i_lastfrag;
};


# 276 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/coda_fs_i.h" 1
 












# 1 "/home/linas/src/linux/include/linux/coda.h" 1
 




 
















 




























 











 








# 98 "/home/linas/src/linux/include/linux/coda.h"







typedef unsigned long long u_quad_t;














 






 








  



 










struct venus_dirent {
        unsigned long	d_fileno;		 
        unsigned short	d_reclen;		 
        char 		d_type;			 
        char		d_namlen;		 
        char		d_name[255  + 1]; 
};




 












 









typedef u_long VolumeId;
typedef u_long VnodeId;
typedef u_long Unique_t;
typedef u_long FileVersion;




typedef struct ViceFid {
    VolumeId Volume;
    VnodeId Vnode;
    Unique_t Unique;
} ViceFid;




static __inline__ ino_t  coda_f2i(struct ViceFid *fid)
{
	if ( ! fid ) 
		return 0; 
	if (fid->Vnode == 0xfffffffe || fid->Vnode == 0xffffffff)
		return ((fid->Volume << 20) | (fid->Unique & 0xfffff));
	else
		return (fid->Unique + (fid->Vnode<<10) + (fid->Volume<<20));
}
	













typedef u_int32_t vuid_t;
typedef u_int32_t vgid_t;




struct coda_cred {
	vuid_t cr_uid, cr_euid, cr_suid, cr_fsuid;
	vgid_t cr_groupid,     cr_egid, cr_sgid, cr_fsgid;




};




 


enum coda_vtype	{ C_VNON, C_VREG, C_VDIR, C_VBLK, C_VCHR, C_VLNK, C_VSOCK, C_VFIFO, C_VBAD };

struct coda_vattr {
	int     	va_type;	 
	u_short		va_mode;	 
	short		va_nlink;	 
	vuid_t		va_uid;		 
	vgid_t		va_gid;		 
	long		va_fileid;	 
	u_quad_t	va_size;	 
	long		va_blocksize;	 
	struct timespec	va_atime;	 
	struct timespec	va_mtime;	 
	struct timespec	va_ctime;	 
	u_long		va_gen;		 
	u_long		va_flags;	 
	u_quad_t 	        va_rdev;	 
	u_quad_t	va_bytes;	 
	u_quad_t	va_filerev;	 
};



 

















































	 


 


struct coda_in_hdr {
    unsigned long opcode;
    unsigned long unique;	     
    u_short pid;		     
    u_short pgid;		     
    u_short sid;                     
    struct coda_cred cred;	     
};

 
struct coda_out_hdr {
    unsigned long opcode;
    unsigned long unique;	
    unsigned long result;
};

 
struct coda_root_out {
    struct coda_out_hdr oh;
    ViceFid VFid;
};

struct coda_root_in {
    struct coda_in_hdr in;
};

 
 

 
struct coda_open_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int	flags;
};

struct coda_open_out {
    struct coda_out_hdr oh;
    u_quad_t 	dev;
    ino_t	inode;
};


 
struct coda_close_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int	flags;
};

struct coda_close_out {
    struct coda_out_hdr out;
};

 
struct coda_ioctl_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
    int	cmd;
    int	len;
    int	rwflag;
    char *data;			 
};

struct coda_ioctl_out {
    struct coda_out_hdr oh;
    int	len;
    caddr_t	data;		 
};


 
struct coda_getattr_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
};

struct coda_getattr_out {
    struct coda_out_hdr oh;
    struct coda_vattr attr;
};


 
struct coda_setattr_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
    struct coda_vattr attr;
};

struct coda_setattr_out {
    struct coda_out_hdr out;
};

 
struct coda_access_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int	flags;
};

struct coda_access_out {
    struct coda_out_hdr out;
};


 



 
struct  coda_lookup_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int         name;		 
    int         flags;	
};

struct coda_lookup_out {
    struct coda_out_hdr oh;
    ViceFid VFid;
    int	vtype;
};


 
struct coda_create_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
    struct coda_vattr attr;
    int excl;
    int mode;
    int 	name;		 
};

struct coda_create_out {
    struct coda_out_hdr oh;
    ViceFid VFid;
    struct coda_vattr attr;
};


 
struct coda_remove_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int name;		 
};

struct coda_remove_out {
    struct coda_out_hdr out;
};

 
struct coda_link_in {
    struct coda_in_hdr ih;
    ViceFid sourceFid;           
    ViceFid destFid;             
    int tname;		 
};

struct coda_link_out {
    struct coda_out_hdr out;
};


 
struct coda_rename_in {
    struct coda_in_hdr ih;
    ViceFid	sourceFid;
    int 	srcname;
    ViceFid destFid;
    int 	destname;
};

struct coda_rename_out {
    struct coda_out_hdr out;
};

 
struct coda_mkdir_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    struct coda_vattr attr;
    int	   name;		 
};

struct coda_mkdir_out {
    struct coda_out_hdr oh;
    ViceFid VFid;
    struct coda_vattr attr;
};


 
struct coda_rmdir_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int name;		 
};

struct coda_rmdir_out {
    struct coda_out_hdr out;
};

 
struct coda_readdir_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int	count;
    int	offset;
};

struct coda_readdir_out {
    struct coda_out_hdr oh;
    int	size;
    caddr_t	data;		 
};

 
struct coda_symlink_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;           
    int srcname;
    struct coda_vattr attr;
    int tname;
};

struct coda_symlink_out {
    struct coda_out_hdr out;
};

 
struct coda_readlink_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
};

struct coda_readlink_out {
    struct coda_out_hdr oh;
    int	count;
    caddr_t	data;		 
};


 
struct coda_fsync_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
};

struct coda_fsync_out {
    struct coda_out_hdr out;
};

 
struct coda_inactive_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
};

 
struct coda_vget_in {
    struct coda_in_hdr ih;
    ViceFid VFid;
};

struct coda_vget_out {
    struct coda_out_hdr oh;
    ViceFid VFid;
    int	vtype;
};


 
 
 

 
 
struct coda_purgeuser_out {
    struct coda_out_hdr oh;
    struct coda_cred cred;
};

 
 
struct coda_zapfile_out {  
    struct coda_out_hdr oh;
    ViceFid CodaFid;
};

 
 	
struct coda_zapdir_out {	  
    struct coda_out_hdr oh;
    ViceFid CodaFid;
};

 
 	
struct coda_zapvnode_out { 
    struct coda_out_hdr oh;
    struct coda_cred cred;
    ViceFid VFid;
};

 
 	
struct coda_purgefid_out { 
    struct coda_out_hdr oh;
    ViceFid CodaFid;
};

 
struct coda_rdwr_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int	rwflag;
    int	count;
    int	offset;
    int	ioflag;
    caddr_t	data;		 	
};

struct coda_rdwr_out {
    struct coda_out_hdr oh;
    int	rwflag;
    int	count;
    caddr_t	data;	 
};


 
 	
struct coda_replace_out {  
    struct coda_out_hdr oh;
    ViceFid NewFid;
    ViceFid OldFid;
};

 
struct coda_open_by_path_in {
    struct coda_in_hdr ih;
    ViceFid	VFid;
    int	flags;
};

struct coda_open_by_path_out {
    struct coda_out_hdr oh;
	int path;
};

 






union inputArgs {
    struct coda_in_hdr ih;		 
    struct coda_open_in coda_open;
    struct coda_close_in coda_close;
    struct coda_ioctl_in coda_ioctl;
    struct coda_getattr_in coda_getattr;
    struct coda_setattr_in coda_setattr;
    struct coda_access_in coda_access;
    struct coda_lookup_in coda_lookup;
    struct coda_create_in coda_create;
    struct coda_remove_in coda_remove;
    struct coda_link_in coda_link;
    struct coda_rename_in coda_rename;
    struct coda_mkdir_in coda_mkdir;
    struct coda_rmdir_in coda_rmdir;
    struct coda_readdir_in coda_readdir;
    struct coda_symlink_in coda_symlink;
    struct coda_readlink_in coda_readlink;
    struct coda_fsync_in coda_fsync;
    struct coda_inactive_in coda_inactive;
    struct coda_vget_in coda_vget;
    struct coda_rdwr_in coda_rdwr;
	struct coda_open_by_path_in coda_open_by_path;
};

union outputArgs {
    struct coda_out_hdr oh;		 
    struct coda_root_out coda_root;
    struct coda_open_out coda_open;
    struct coda_ioctl_out coda_ioctl;
    struct coda_getattr_out coda_getattr;
    struct coda_lookup_out coda_lookup;
    struct coda_create_out coda_create;
    struct coda_mkdir_out coda_mkdir;
    struct coda_readdir_out coda_readdir;
    struct coda_readlink_out coda_readlink;
    struct coda_vget_out coda_vget;
    struct coda_purgeuser_out coda_purgeuser;
    struct coda_zapfile_out coda_zapfile;
    struct coda_zapdir_out coda_zapdir;
    struct coda_zapvnode_out coda_zapvnode;
    struct coda_purgefid_out coda_purgefid;
    struct coda_rdwr_out coda_rdwr;
    struct coda_replace_out coda_replace;
	struct coda_open_by_path_out coda_open_by_path;
};    

union coda_downcalls {
     
     
    struct coda_purgeuser_out purgeuser;
    struct coda_zapfile_out zapfile;
    struct coda_zapdir_out zapdir;
    struct coda_zapvnode_out zapvnode;
    struct coda_purgefid_out purgefid;
    struct coda_replace_out replace;
};


 




struct ViceIoctl {
        caddr_t in, out;         
        short in_size;           
        short out_size;          
};









struct PioctlData {
        const char *path;
        int follow;
        struct ViceIoctl vi;
};
















# 14 "/home/linas/src/linux/include/linux/coda_fs_i.h" 2





 


struct coda_inode_info {
        struct ViceFid     c_fid;	 
        u_short	           c_flags;      
        u_short	           c_ocount;     
        u_short            c_owrite;     
        u_short            c_mmcount;    
        struct inode      *c_ovp;        
        struct list_head   c_cnhead;     
	struct list_head   c_volrootlist;  
        struct inode      *c_vnode;      
        int                c_magic;      
};

 







int coda_cnode_make(struct inode **, struct ViceFid *, struct super_block *);
int coda_cnode_makectl(struct inode **inode, struct super_block *sb);
struct inode *coda_fid_to_inode(ViceFid *fid, struct super_block *sb);
void coda_replace_fid(struct inode *, ViceFid *, ViceFid *);



# 277 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/romfs_fs_i.h" 1



 

struct romfs_inode_info {
	unsigned long i_metasize;	 
	unsigned long i_dataoffset;	 
};


# 278 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/smb_fs_i.h" 1
 













 


struct smb_inode_info {

	 



        unsigned int open;	 
	__u16 fileid;		 
	__u16 attr;		 

	__u16 access;		 
	__u16 cache_valid;	 
	unsigned long oldmtime;	 
	unsigned long closed;	 
};



# 279 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/hfs_fs_i.h" 1
 












 




struct hfs_inode_info {
	int				magic;      

	struct hfs_cat_entry		*entry;

	 
	struct hfs_fork 		*fork;
	int				convert;

	 
	ino_t				file_type;
	char				dir_size;

	 
	const struct hfs_hdr_layout	*default_layout;
	struct hfs_hdr_layout		*layout;

	 
	int                             tz_secondswest;

         
        void (*d_drop_op)(struct dentry *, const ino_t);
};


# 280 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/adfs_fs_i.h" 1
 








 


struct adfs_inode_info {
	unsigned long	file_id;		 
};


# 281 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/qnx4_fs_i.h" 1
 












# 1 "/home/linas/src/linux/include/linux/qnxtypes.h" 1
 













typedef unsigned short _nxtnt_t;
typedef unsigned char _ftype_t;

typedef struct {
	long xtnt_blk;
	long xtnt_size;
} _xtnt_t;

typedef unsigned short muid_t;
typedef unsigned short mgid_t;
typedef unsigned long qnx_off_t;
typedef unsigned short qnx_nlink_t;


# 14 "/home/linas/src/linux/include/linux/qnx4_fs_i.h" 2


 


struct qnx4_inode_info {
	char i_reserved[16];	 
	off_t i_size;		 
	_xtnt_t i_first_xtnt;	 
	long i_xblk;		 
	time_t i_ftime;		 
	time_t i_mtime;		 
	time_t i_atime;		 
	time_t i_ctime;		 
	_nxtnt_t i_num_xtnts;	 
	mode_t i_mode;		 
	muid_t i_uid;		 
	mgid_t i_gid;		 
	nlink_t i_nlink;	 
	char i_zero[4];		 
	_ftype_t i_type;	 
	unsigned char i_status;	 
};


# 282 "/home/linas/src/linux/include/linux/fs.h" 2


 















 








struct iattr {
	unsigned int	ia_valid;
	umode_t		ia_mode;
	uid_t		ia_uid;
	gid_t		ia_gid;
	off_t		ia_size;
	time_t		ia_atime;
	time_t		ia_mtime;
	time_t		ia_ctime;
	unsigned int	ia_attr_flags;
};

 








 


# 1 "/home/linas/src/linux/include/linux/quota.h" 1
 








































# 1 "/home/linas/src/linux/include/linux/errno.h" 1



# 1 "/home/linas/src/linux/include/asm/errno.h" 1

































































































































 









# 4 "/home/linas/src/linux/include/linux/errno.h" 2




 








# 42 "/home/linas/src/linux/include/linux/quota.h" 2


 





 





 















 











extern int nr_dquots, nr_free_dquots;
extern int max_dquots;
extern int dquot_root_squash;




 



















 




struct dqblk {
	__u32 dqb_bhardlimit;	 
	__u32 dqb_bsoftlimit;	 
	__u32 dqb_curblocks;	 
	__u32 dqb_ihardlimit;	 
	__u32 dqb_isoftlimit;	 
	__u32 dqb_curinodes;	 
	time_t dqb_btime;		 
	time_t dqb_itime;		 
};

 













struct dqstats {
	__u32 lookups;
	__u32 drops;
	__u32 reads;
	__u32 writes;
	__u32 cache_hits;
	__u32 allocated_dquots;
	__u32 free_dquots;
	__u32 syncs;
};



 












struct dquot {
	struct dquot *dq_next;		 
	struct dquot **dq_pprev;
	struct list_head dq_free;	 
	struct dquot *dq_hash_next;	 
	struct dquot **dq_hash_pprev;	 
	struct wait_queue *dq_wait;	 
	int dq_count;			 

	 
	struct vfsmount *dq_mnt;	 
	unsigned int dq_id;		 
	kdev_t dq_dev;			 
	short dq_type;			 
	short dq_flags;			 
	unsigned long dq_referenced;	 

	struct dqblk dq_dqb;		 
};



 










# 208 "/home/linas/src/linux/include/linux/quota.h"


# 333 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/mount.h" 1
 















struct quota_mount_options
{
	unsigned int flags;			 
	struct semaphore semaphore;		 
	struct file *files[2 ];		 
	time_t inode_expire[2 ];		 
	time_t block_expire[2 ];		 
	char rsquash[2 ];		 
};

struct vfsmount
{
  kdev_t mnt_dev;			 
  char *mnt_devname;			 
  char *mnt_dirname;			 
  unsigned int mnt_flags;		 
  struct super_block *mnt_sb;		 
  struct quota_mount_options mnt_dquot;	 
  struct vfsmount *mnt_next;		 
};

struct vfsmount *lookup_vfsmnt(kdev_t dev);

 


 



# 334 "/home/linas/src/linux/include/linux/fs.h" 2


struct inode {
	struct list_head	i_hash;
	struct list_head	i_list;
	struct list_head	i_dentry;

	unsigned long		i_ino;
	unsigned int		i_count;
	kdev_t			i_dev;
	umode_t			i_mode;
	nlink_t			i_nlink;
	uid_t			i_uid;
	gid_t			i_gid;
	kdev_t			i_rdev;
	off_t			i_size;
	time_t			i_atime;
	time_t			i_mtime;
	time_t			i_ctime;
	unsigned long		i_blksize;
	unsigned long		i_blocks;
	unsigned long		i_version;
	unsigned long		i_nrpages;
	struct semaphore	i_sem;
	struct semaphore	i_atomic_write;
	struct inode_operations	*i_op;
	struct super_block	*i_sb;
	struct wait_queue	*i_wait;
	struct file_lock	*i_flock;
	struct vm_area_struct	*i_mmap;
	struct page		*i_pages;
	struct dquot		*i_dquot[2 ];

	unsigned long		i_state;

	unsigned int		i_flags;
	unsigned char		i_pipe;
	unsigned char		i_sock;

	int			i_writecount;
	unsigned int		i_attr_flags;
	union {
		struct pipe_inode_info		pipe_i;
		struct minix_inode_info		minix_i;
		struct ext2_inode_info		ext2_i;
		struct hpfs_inode_info		hpfs_i;
		struct ntfs_inode_info          ntfs_i;
		struct msdos_inode_info		msdos_i;
		struct umsdos_inode_info	umsdos_i;
		struct iso_inode_info		isofs_i;
		struct nfs_inode_info		nfs_i;
		struct sysv_inode_info		sysv_i;
		struct affs_inode_info		affs_i;
		struct ufs_inode_info		ufs_i;
		struct romfs_inode_info		romfs_i;
		struct coda_inode_info		coda_i;
		struct smb_inode_info		smbfs_i;
		struct hfs_inode_info		hfs_i;
		struct adfs_inode_info		adfs_i;
		struct qnx4_inode_info		qnx4_i;	   
		struct socket			socket_i;
		void				*generic_ip;
	} u;
};

 




extern void __mark_inode_dirty(struct inode *);
static inline void mark_inode_dirty(struct inode *inode)
{
	if (!(inode->i_state & 1 ))
		__mark_inode_dirty(inode);
}

struct fown_struct {
	int pid;		 
	uid_t uid, euid;	 
	int signum;		 
};

struct file {
	struct file		*f_next, **f_pprev;
	struct dentry		*f_dentry;
	struct file_operations	*f_op;
	mode_t			f_mode;
	loff_t			f_pos;
	unsigned int 		f_count, f_flags;
	unsigned long 		f_reada, f_ramax, f_raend, f_ralen, f_rawin;
	struct fown_struct	f_owner;

	unsigned long		f_version;

	 
	void			*private_data;
};

extern int init_private_file(struct file *, struct dentry *, int);







 






typedef struct files_struct *fl_owner_t;

struct file_lock {
	struct file_lock *fl_next;	 
	struct file_lock *fl_nextlink;	 
	struct file_lock *fl_prevlink;	 
	struct file_lock *fl_nextblock;  
	struct file_lock *fl_prevblock;
	fl_owner_t fl_owner;
	unsigned int fl_pid;
	struct wait_queue *fl_wait;
	struct file *fl_file;
	unsigned char fl_flags;
	unsigned char fl_type;
	off_t fl_start;
	off_t fl_end;

	void (*fl_notify)(struct file_lock *);	 

	union {
		struct nfs_lock_info	nfs_fl;
	} fl_u;
};

extern struct file_lock			*file_lock_table;

# 1 "/home/linas/src/linux/include/linux/fcntl.h" 1



# 1 "/home/linas/src/linux/include/asm/fcntl.h" 1



 































 


 




 



 












struct flock {
	short l_type;
	short l_whence;
	off_t l_start;
	off_t l_len;
	pid_t l_pid;
};


# 4 "/home/linas/src/linux/include/linux/fcntl.h" 2



# 474 "/home/linas/src/linux/include/linux/fs.h" 2


extern int fcntl_getlk(unsigned int fd, struct flock *l);
extern int fcntl_setlk(unsigned int fd, unsigned int cmd, struct flock *l);

 
extern void locks_remove_posix(struct file *, fl_owner_t id);
extern void locks_remove_flock(struct file *);
extern struct file_lock *posix_test_lock(struct file *, struct file_lock *);
extern int posix_lock_file(struct file *, struct file_lock *, unsigned int);
extern void posix_block_lock(struct file_lock *, struct file_lock *);
extern void posix_unblock_lock(struct file_lock *);



struct fasync_struct {
	int    magic;
	int    fa_fd;
	struct fasync_struct	*fa_next;  
	struct file 		*fa_file;
};



extern int fasync_helper(int, struct file *, int, struct fasync_struct **);

# 1 "/home/linas/src/linux/include/linux/minix_fs_sb.h" 1



 


struct minix_sb_info {
			unsigned long s_ninodes;
			unsigned long s_nzones;
			unsigned long s_imap_blocks;
			unsigned long s_zmap_blocks;
			unsigned long s_firstdatazone;
			unsigned long s_log_zone_size;
			unsigned long s_max_size;
			int s_dirsize;
			int s_namelen;
			int s_link_max;
			struct buffer_head ** s_imap;
			struct buffer_head ** s_zmap;
			struct buffer_head * s_sbh;
			struct minix_super_block * s_ms;
			unsigned short s_mount_state;
			unsigned short s_version;
};


# 500 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ext2_fs_sb.h" 1
 

















# 1 "/home/linas/src/linux/include/linux/ext2_fs.h" 1
 



















 



 




 





 





 












 









 


 




 




 






























 













 


struct ext2_acl_header	 
{
	__u32	aclh_size;
	__u32	aclh_file_count;
	__u32	aclh_acle_count;
	__u32	aclh_first_acle;
};

struct ext2_acl_entry	 
{
	__u32	acle_size;
	__u16	acle_perms;	 
	__u16	acle_type;	 
	__u16	acle_tag;	 
	__u16	acle_pad1;
	__u32	acle_next;	 
					 
};

 


struct ext2_group_desc
{
	__u32	bg_block_bitmap;		 
	__u32	bg_inode_bitmap;		 
	__u32	bg_inode_table;		 
	__u16	bg_free_blocks_count;	 
	__u16	bg_free_inodes_count;	 
	__u16	bg_used_dirs_count;	 
	__u16	bg_pad;
	__u32	bg_reserved[3];
};

 













 








 










 




 	






 







 


struct ext2_inode {
	__u16	i_mode;		 
	__u16	i_uid;		 
	__u32	i_size;		 
	__u32	i_atime;	 
	__u32	i_ctime;	 
	__u32	i_mtime;	 
	__u32	i_dtime;	 
	__u16	i_gid;		 
	__u16	i_links_count;	 
	__u32	i_blocks;	 
	__u32	i_flags;	 
	union {
		struct {
			__u32  l_i_reserved1;
		} linux1;
		struct {
			__u32  h_i_translator;
		} hurd1;
		struct {
			__u32  m_i_reserved1;
		} masix1;
	} osd1;				 
	__u32	i_block[(((12   + 1)  + 1)  + 1) ]; 
	__u32	i_version;	 
	__u32	i_file_acl;	 
	__u32	i_dir_acl;	 
	__u32	i_faddr;	 
	union {
		struct {
			__u8	l_i_frag;	 
			__u8	l_i_fsize;	 
			__u16	i_pad1;
			__u32	l_i_reserved2[2];
		} linux2;
		struct {
			__u8	h_i_frag;	 
			__u8	h_i_fsize;	 
			__u16	h_i_mode_high;
			__u16	h_i_uid_high;
			__u16	h_i_gid_high;
			__u32	h_i_author;
		} hurd2;
		struct {
			__u8	m_i_frag;	 
			__u8	m_i_fsize;	 
			__u16	m_pad1;
			__u32	m_i_reserved2[2];
		} masix2;
	} osd2;				 
};


























 





 

















 





 







 


struct ext2_super_block {
	__u32	s_inodes_count;		 
	__u32	s_blocks_count;		 
	__u32	s_r_blocks_count;	 
	__u32	s_free_blocks_count;	 
	__u32	s_free_inodes_count;	 
	__u32	s_first_data_block;	 
	__u32	s_log_block_size;	 
	__s32	s_log_frag_size;	 
	__u32	s_blocks_per_group;	 
	__u32	s_frags_per_group;	 
	__u32	s_inodes_per_group;	 
	__u32	s_mtime;		 
	__u32	s_wtime;		 
	__u16	s_mnt_count;		 
	__s16	s_max_mnt_count;	 
	__u16	s_magic;		 
	__u16	s_state;		 
	__u16	s_errors;		 
	__u16	s_minor_rev_level; 	 
	__u32	s_lastcheck;		 
	__u32	s_checkinterval;	 
	__u32	s_creator_os;		 
	__u32	s_rev_level;		 
	__u16	s_def_resuid;		 
	__u16	s_def_resgid;		 
	 












	__u32	s_first_ino; 		 
	__u16   s_inode_size; 		 
	__u16	s_block_group_nr; 	 
	__u32	s_feature_compat; 	 
	__u32	s_feature_incompat; 	 
	__u32	s_feature_ro_compat; 	 
	__u8	s_uuid[16];		 
	char	s_volume_name[16]; 	 
	char	s_last_mounted[64]; 	 
	__u32	s_algorithm_usage_bitmap;  
	 



	__u8	s_prealloc_blocks;	 
	__u8	s_prealloc_dir_blocks;	 
	__u16	s_padding1;
	__u32	s_reserved[204];	 
};










 








 










 

























 





 




struct ext2_dir_entry {
	__u32	inode;			 
	__u16	rec_len;		 
	__u16	name_len;		 
	char	name[255 ];	 
};

 





struct ext2_dir_entry_2 {
	__u32	inode;			 
	__u16	rec_len;		 
	__u8	name_len;		 
	__u8	file_type;
	char	name[255 ];	 
};

 














 










 



 







 
extern int ext2_permission (struct inode *, int);

 
extern int ext2_group_sparse(int group);
extern int ext2_new_block (const struct inode *, unsigned long,
			   __u32 *, __u32 *, int *);
extern void ext2_free_blocks (const struct inode *, unsigned long,
			      unsigned long);
extern unsigned long ext2_count_free_blocks (struct super_block *);
extern void ext2_check_blocks_bitmap (struct super_block *);
extern struct ext2_group_desc * ext2_get_group_desc(struct super_block * sb,
						    unsigned int block_group,
						    struct buffer_head ** bh);

 
extern unsigned long ext2_count_free (struct buffer_head *, unsigned);

 
extern int ext2_check_dir_entry (const char *, struct inode *,
				 struct ext2_dir_entry_2 *, struct buffer_head *,
				 unsigned long);

 
extern int ext2_read (struct inode *, struct file *, char *, int);
extern int ext2_write (struct inode *, struct file *, char *, int);

 
extern int ext2_sync_file (struct file *, struct dentry *);

 
extern struct inode * ext2_new_inode (const struct inode *, int, int *);
extern void ext2_free_inode (struct inode *);
extern unsigned long ext2_count_free_inodes (struct super_block *);
extern void ext2_check_inodes_bitmap (struct super_block *);

 
extern int ext2_bmap (struct inode *, int);

extern struct buffer_head * ext2_getblk (struct inode *, long, int, int *);
extern struct buffer_head * ext2_bread (struct inode *, int, int, int *);

extern int ext2_getcluster (struct inode * inode, long block);
extern void ext2_read_inode (struct inode *);
extern void ext2_write_inode (struct inode *);
extern void ext2_put_inode (struct inode *);
extern void ext2_delete_inode (struct inode *);
extern int ext2_sync_inode (struct inode *);
extern void ext2_discard_prealloc (struct inode *);

 
extern int ext2_ioctl (struct inode *, struct file *, unsigned int,
		       unsigned long);

 
extern void ext2_release (struct inode *, struct file *);
extern int ext2_lookup (struct inode *, struct dentry *);
extern int ext2_create (struct inode *,struct dentry *,int);
extern int ext2_mkdir (struct inode *,struct dentry *,int);
extern int ext2_rmdir (struct inode *,struct dentry *);
extern int ext2_unlink (struct inode *,struct dentry *);
extern int ext2_symlink (struct inode *,struct dentry *,const char *);
extern int ext2_link (struct dentry *, struct inode *, struct dentry *);
extern int ext2_mknod (struct inode *, struct dentry *, int, int);
extern int ext2_rename (struct inode *, struct dentry *,
			struct inode *, struct dentry *);

 
extern void ext2_error (struct super_block *, const char *, const char *, ...)
	__attribute__ ((format (printf, 3, 4)));
extern   void ext2_panic (struct super_block *, const char *,
				   const char *, ...)
	__attribute__ ((noreturn,  format (printf, 3, 4)));
extern void ext2_warning (struct super_block *, const char *, const char *, ...)
	__attribute__ ((format (printf, 3, 4)));
extern void ext2_put_super (struct super_block *);
extern void ext2_write_super (struct super_block *);
extern int ext2_remount (struct super_block *, int *, char *);
extern struct super_block * ext2_read_super (struct super_block *,void *,int);
extern int init_ext2_fs(void);
extern int ext2_statfs (struct super_block *, struct statfs *, int);

 
extern void ext2_truncate (struct inode *);

 



 
extern struct inode_operations ext2_dir_inode_operations;

 
extern struct inode_operations ext2_file_inode_operations;

 
extern struct inode_operations ext2_symlink_inode_operations;




# 19 "/home/linas/src/linux/include/linux/ext2_fs_sb.h" 2


 



 



 


struct ext2_sb_info {
	unsigned long s_frag_size;	 
	unsigned long s_frags_per_block; 
	unsigned long s_inodes_per_block; 
	unsigned long s_frags_per_group; 
	unsigned long s_blocks_per_group; 
	unsigned long s_inodes_per_group; 
	unsigned long s_itb_per_group;	 
	unsigned long s_db_per_group;	 
	unsigned long s_desc_per_block;	 
	unsigned long s_groups_count;	 
	struct buffer_head * s_sbh;	 
	struct ext2_super_block * s_es;	 
	struct buffer_head ** s_group_desc;
	unsigned short s_loaded_inode_bitmaps;
	unsigned short s_loaded_block_bitmaps;
	unsigned long s_inode_bitmap_number[8 ];
	struct buffer_head * s_inode_bitmap[8 ];
	unsigned long s_block_bitmap_number[8 ];
	struct buffer_head * s_block_bitmap[8 ];
	int s_rename_lock;
	struct wait_queue * s_rename_wait;
	unsigned long  s_mount_opt;
	unsigned short s_resuid;
	unsigned short s_resgid;
	unsigned short s_mount_state;
	unsigned short s_pad;
	int s_addr_per_block_bits;
	int s_desc_per_block_bits;
	int s_inode_size;
	int s_first_ino;
	int s_feature_compat;
	int s_feature_incompat;
	int s_feature_ro_compat;
};


# 501 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/hpfs_fs_sb.h" 1



struct hpfs_sb_info {
	ino_t sb_root;			 
	unsigned sb_fs_size;		 
	unsigned sb_bitmaps;		 
	unsigned sb_dirband_size;	 
	unsigned sb_dmap;		 
	unsigned sb_n_free;		 
	unsigned sb_n_free_dnodes;	 
	uid_t sb_uid;			 
	gid_t sb_gid;			 
	umode_t sb_mode;		 
	unsigned sb_lowercase : 1;	 
	unsigned sb_conv : 2;		 
};















# 502 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ntfs_fs_sb.h" 1



struct ntfs_sb_info{
	 
	ntfs_uid_t uid;
	ntfs_gid_t gid;
	ntmode_t umask;
        unsigned int nct;
	void *nls_map;
	unsigned int ngt;
	 
	ntfs_size_t partition_bias;	 
	 
	ntfs_u32 at_standard_information;
	ntfs_u32 at_attribute_list;
	ntfs_u32 at_file_name;
	ntfs_u32 at_security_descriptor;
	ntfs_u32 at_data;
	ntfs_u32 at_index_root;
	ntfs_u32 at_index_allocation;
	ntfs_u32 at_bitmap;
	ntfs_u32 at_symlink;  
	 
	int blocksize;
	int clusterfactor;
	int clustersize;
	int mft_recordsize;
	int mft_clusters_per_record;
	int index_recordsize;
	int index_clusters_per_record;
	int mft_cluster;
	 
	unsigned char *mft;
	unsigned short *upcase;
	unsigned int upcase_length;
	 
	struct ntfs_inode_info *mft_ino;
	struct ntfs_inode_info *mftmirr;
	struct ntfs_inode_info *bitmap;
	struct super_block *sb;
};


# 503 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/msdos_fs_sb.h" 1


# 1 "/home/linas/src/linux/include/linux/fat_cvf.h" 1





struct cvf_format
{ int cvf_version;
  char* cvf_version_text;
  unsigned long flags;
  int (*detect_cvf) (struct super_block*sb);
  int (*mount_cvf) (struct super_block*sb,char*options);
  int (*unmount_cvf) (struct super_block*sb);
  struct buffer_head* (*cvf_bread) (struct super_block*sb,int block);
  struct buffer_head* (*cvf_getblk) (struct super_block*sb,int block);
  void (*cvf_brelse) (struct super_block *sb,struct buffer_head *bh);
  void (*cvf_mark_buffer_dirty) (struct super_block *sb,
                              struct buffer_head *bh,
                              int dirty_val);
  void (*cvf_set_uptodate) (struct super_block *sb,
                         struct buffer_head *bh,
                         int val);
  int (*cvf_is_uptodate) (struct super_block *sb,struct buffer_head *bh);
  void (*cvf_ll_rw_block) (struct super_block *sb,
                        int opr,
                        int nbreq,
                        struct buffer_head *bh[32]);
  int (*fat_access) (struct super_block *sb,int nr,int new_value);
  int (*cvf_statfs) (struct super_block *sb,struct statfs *buf, int bufsiz);
  int (*cvf_bmap) (struct inode *inode,int block);
  int (*cvf_smap) (struct inode *inode,int sector);
  ssize_t (*cvf_file_read) ( struct file *, char *, size_t, loff_t *);
  ssize_t (*cvf_file_write) ( struct file *, const char *, size_t, loff_t *);
  int (*cvf_mmap) (struct file *, struct vm_area_struct *);
  int (*cvf_readpage) (struct inode *, struct page *);
  int (*cvf_writepage) (struct inode *, struct page *);
  int (*cvf_dir_ioctl) (struct inode * inode, struct file * filp,
                        unsigned int cmd, unsigned long arg);
  void (*zero_out_cluster) (struct inode*, int clusternr);
};

int register_cvf_format(struct cvf_format*cvf_format);
int unregister_cvf_format(struct cvf_format*cvf_format);
void dec_cvf_format_use_count_by_version(int version);
int detect_cvf(struct super_block*sb,char*force);

extern struct cvf_format *cvf_formats[];
extern int cvf_format_use_count[];


# 3 "/home/linas/src/linux/include/linux/msdos_fs_sb.h" 2


 



struct fat_mount_options {
	uid_t fs_uid;
	gid_t fs_gid;
	unsigned short fs_umask;
	unsigned short codepage;   
	char *iocharset;           
	unsigned char name_check;  
	unsigned char conversion;  
	unsigned quiet:1,          
		 showexec:1,       
		 sys_immutable:1,  
		 dotsOK:1,         
		 isvfat:1,         
		 utf8:1,	   
		 unicode_xlate:1,  
		 posixfs:1,        
		 numtail:1,        
		 atari:1,          
		 fat32:1;	   
};

struct vfat_unicode {
	unsigned char uni1;
	unsigned char uni2;
};

struct msdos_sb_info {
	unsigned short cluster_size;  
	unsigned char fats,fat_bits;  
	unsigned short fat_start;
	unsigned long fat_length;     
	unsigned long dir_start;
	unsigned short dir_entries;   
	unsigned long data_start;     
	unsigned long clusters;       
	unsigned long root_cluster;   
	unsigned long fsinfo_offset;  
	struct wait_queue *fat_wait;
	int fat_lock;
	int prev_free;                
	int free_clusters;            
	struct fat_mount_options options;
	struct nls_table *nls_disk;   
	struct nls_table *nls_io;     
	struct cvf_format* cvf_format;
	void* private_data;	
};


# 504 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/iso_fs_sb.h" 1



 


struct isofs_sb_info {
	unsigned long s_ninodes;
	unsigned long s_nzones;
	unsigned long s_firstdatazone;
	unsigned long s_log_zone_size;
	unsigned long s_max_size;
	
	unsigned char s_high_sierra;  
	unsigned char s_mapping;
	unsigned char s_rock;
	unsigned char s_joliet_level;
	unsigned char s_utf8;
	unsigned char s_cruft;  


	unsigned char s_unhide;
	unsigned char s_nosuid;
	unsigned char s_nodev;
	mode_t s_mode;
	gid_t s_gid;
	uid_t s_uid;
	struct nls_table *s_nls_iocharset;  
};


# 505 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/nfs_fs_sb.h" 1




# 1 "/home/linas/src/linux/include/linux/in.h" 1
 





















 
enum {
  IPPROTO_IP = 0,		 
  IPPROTO_ICMP = 1,		 
  IPPROTO_IGMP = 2,		 
  IPPROTO_IPIP = 4,		 
  IPPROTO_TCP = 6,		 
  IPPROTO_EGP = 8,		 
  IPPROTO_PUP = 12,		 
  IPPROTO_UDP = 17,		 
  IPPROTO_IDP = 22,		 
  IPPROTO_RSVP = 46,		 
  IPPROTO_GRE = 47,		 

  IPPROTO_IPV6	 = 41,		 

  IPPROTO_PIM    = 103,		 

  IPPROTO_RAW	 = 255,		 
  IPPROTO_MAX
};


 
struct in_addr {
	__u32	s_addr;
};
















 


 










 




 

struct ip_mreq 
{
	struct in_addr imr_multiaddr;	 
	struct in_addr imr_interface;	 
};

struct ip_mreqn
{
	struct in_addr	imr_multiaddr;		 
	struct in_addr	imr_address;		 
	int		imr_ifindex;		 
};

struct in_pktinfo
{
	int		ipi_ifindex;
	struct in_addr	ipi_spec_dst;
	struct in_addr	ipi_addr;
};

 

struct sockaddr_in {
  sa_family_t		sin_family;	 
  unsigned short int	sin_port;	 
  struct in_addr	sin_addr;	 

   
  unsigned char		__pad[16  - sizeof(short int) -
			sizeof(unsigned short int) - sizeof(struct in_addr)];
};



 




























 


 


 


 


 



 






 



 









# 5 "/home/linas/src/linux/include/linux/nfs_fs_sb.h" 2


 


struct nfs_server {
	struct rpc_clnt *	client;		 
	int			flags;		 
	int			rsize;		 
	int			wsize;		 
	unsigned int		bsize;		 
	unsigned int		acregmin;	 
	unsigned int		acregmax;
	unsigned int		acdirmin;
	unsigned int		acdirmax;
	char *			hostname;	 
};

 


struct nfs_sb_info {
	struct nfs_server	s_server;
	struct nfs_fh		s_root;
};


# 506 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/sysv_fs_sb.h" 1



 








struct sysv_sb_info {
	int	       s_type;		 
	unsigned int   s_block_size;	 
	unsigned int   s_block_size_1;	 
	unsigned int   s_block_size_bits;	 
	unsigned int   s_block_size_inc_bits;	 
	unsigned int   s_block_size_dec_bits;	 
	char	       s_convert;	 
	char	       s_kludge_symlinks;  
	char	       s_truncate;	 
					 
	nlink_t        s_link_max;	 
	unsigned int   s_inodes_per_block;	 
	unsigned int   s_inodes_per_block_1;	 
	unsigned int   s_inodes_per_block_bits;	 
	unsigned int   s_ind_per_block;		 
	unsigned int   s_ind_per_block_1;	 
	unsigned int   s_ind_per_block_bits;	 
	unsigned int   s_ind_per_block_2;	 
	unsigned int   s_ind_per_block_2_1;	 
	unsigned int   s_ind_per_block_2_bits;	 
	unsigned int   s_ind_per_block_3;	 
	unsigned int   s_ind_per_block_block_size_1;	 
	unsigned int   s_ind_per_block_block_size_bits;	 
	unsigned int   s_ind_per_block_2_block_size_1;	 
	unsigned int   s_ind_per_block_2_block_size_bits;  
	unsigned int   s_ind0_size;		 
	unsigned int   s_ind1_size;		 
	unsigned int   s_ind2_size;		 
	unsigned int   s_toobig_block;		 
	unsigned int   s_block_base;	 
	unsigned short s_fic_size;	 
	unsigned short s_flc_size;	 
	 
	struct buffer_head *s_bh1;
	struct buffer_head *s_bh2;
	 

	char *         s_sbd1;		 
	char *         s_sbd2;		 
	u16            *s_sb_fic_count;	 
        u16            *s_sb_fic_inodes;  
	u16            *s_sb_total_free_inodes;  
	u16            *s_sb_flc_count;	 
	u32	       *s_sb_flc_blocks;  
	u32            *s_sb_total_free_blocks; 
	u32            *s_sb_time;	 
	u32            *s_sb_state;	 
	 

	u32            s_firstinodezone;  
	u32            s_firstdatazone;	 
	u32            s_ninodes;	 
	u32            s_ndatazones;	 
	u32            s_nzones;	 
};
 

 



















































# 507 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/affs_fs_sb.h" 1



 











struct affs_bm_info {
	struct buffer_head *bm_bh;	 
	s32 bm_firstblk;		 
	s32 bm_key;			 
	int bm_count;			 
};

struct affs_alloc_zone {
	short az_size;			 
	short az_count;			 
	int az_free;			 
};

struct affs_zone {
	unsigned long z_ino;		 
	struct affs_bm_info *z_bm;	 
	int z_start;			 
	int z_end;			 
	int z_az_no;			 
	unsigned long z_lru_time;	 
};

struct affs_sb_info {
	int s_partition_size;		 
	int s_blksize;			 
	s32 s_root_block;		 
	int s_hashsize;			 
	unsigned long s_flags;		 
	s16 s_uid;			 
	s16 s_gid;			 
	umode_t s_mode;			 
	int s_reserved;			 
	struct buffer_head *s_root_bh;	 
	struct affs_bm_info *s_bitmap;	 
	int s_bm_count;			 
	int s_nextzone;			 
	int s_num_az;			 
	struct affs_zone *s_zones;	 
	struct affs_alloc_zone *s_alloc; 
	char *s_zonemap;		 
	char *s_prefix;			 
	int s_prefix_len;		 
	char s_volume[32];		 
};















# 508 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/ufs_fs_sb.h" 1
 















# 1 "/home/linas/src/linux/include/linux/ufs_fs.h" 1
 

























# 1 "/home/linas/src/linux/include/linux/kernel.h" 1



 





# 1 "/home/linas/src/i370/usr/lib/gcc-lib/i370-ibm-linux/2.96/include/stdarg.h" 1 3
 
































































 






typedef void *__gnuc_va_list;



 



 

















void va_end (__gnuc_va_list);		 


 








 







 























 
 













# 175 "/home/linas/src/i370/usr/lib/gcc-lib/i370-ibm-linux/2.96/include/stdarg.h" 3


 




 

 

 

typedef __gnuc_va_list va_list;
























# 10 "/home/linas/src/linux/include/linux/kernel.h" 2



 
 




























extern void math_error(void);
  void panic(const char * fmt, ...)
	__attribute__ ((noreturn,  format (printf, 1, 2)));
  void do_exit(long error_code)
	__attribute__((noreturn)) ;
extern unsigned long simple_strtoul(const char *,char **,unsigned int);
extern long simple_strtol(const char *,char **,unsigned int);
extern int sprintf(char * buf, const char * fmt, ...);
extern int vsprintf(char *buf, const char *, va_list);

extern int session_of_pgrp(int pgrp);

   int printk(const char * fmt, ...)
	__attribute__ ((format (printf, 1, 2)));












 












struct sysinfo {
	long uptime;			 
	unsigned long loads[3];		 
	unsigned long totalram;		 
	unsigned long freeram;		 
	unsigned long sharedram;	 
	unsigned long bufferram;	 
	unsigned long totalswap;	 
	unsigned long freeswap;		 
	unsigned short procs;		 
	char _f[22];			 
};


# 27 "/home/linas/src/linux/include/linux/ufs_fs.h" 2











































 
 


 







 



 




 




 





 



 

















 













            
 






 










 










 






 










 





















 







struct ufs_timeval {
	__s32	tv_sec;
	__s32	tv_usec;
};

 











   
struct ufs_dir_entry {
	__u32  d_ino;			 
	__u16  d_reclen;		 
	union {
		__u16	d_namlen;		 
		struct {
			__u8	d_type;		 
			__u8	d_namlen;	 
		} d_44;
	} d_u;
	__u8	d_name[255  + 1];	 
};

struct ufs_csum {
	__u32	cs_ndir;	 
	__u32	cs_nbfree;	 
	__u32	cs_nifree;	 
	__u32	cs_nffree;	 
};

 


struct ufs_super_block {
	__u32	fs_link;	 
	__u32	fs_rlink;	 
	__u32	fs_sblkno;	 
	__u32	fs_cblkno;	 
	__u32	fs_iblkno;	 
	__u32	fs_dblkno;	 
	__u32	fs_cgoffset;	 
	__u32	fs_cgmask;	 
	__u32	fs_time;	 
	__u32	fs_size;	 
	__u32	fs_dsize;	 
	__u32	fs_ncg;		 
	__u32	fs_bsize;	 
	__u32	fs_fsize;	 
	__u32	fs_frag;	 
 
	__u32	fs_minfree;	 
	__u32	fs_rotdelay;	 
	__u32	fs_rps;		 
 
	__u32	fs_bmask;	 
	__u32	fs_fmask;	 
	__u32	fs_bshift;	 
	__u32	fs_fshift;	 
 
	__u32	fs_maxcontig;	 
	__u32	fs_maxbpg;	 
 
	__u32	fs_fragshift;	 
	__u32	fs_fsbtodb;	 
	__u32	fs_sbsize;	 
	__u32	fs_csmask;	 
	__u32	fs_csshift;	 
	__u32	fs_nindir;	 
	__u32	fs_inopb;	 
	__u32	fs_nspf;	 
 
	__u32	fs_optim;	 
 
	__u32	fs_npsect;	 
	__u32	fs_interleave;	 
	__u32	fs_trackskew;	 
 
 
 
 
	__u32	fs_id[2];	 
 
	__u32	fs_csaddr;	 
	__u32	fs_cssize;	 
	__u32	fs_cgsize;	 
 
	__u32	fs_ntrak;	 
	__u32	fs_nsect;	 
	__u32	fs_spc;		 
 
	__u32	fs_ncyl;	 
 
	__u32	fs_cpg;		 
	__u32	fs_ipg;		 
	__u32	fs_fpg;		 
 
	struct ufs_csum fs_cstotal;	 
 
	__u8	fs_fmod;	 
	__u8	fs_clean;	 
	__u8	fs_ronly;	 
	__u8	fs_flags;	 
	__u8	fs_fsmnt[512 ];	 
 
	__u32	fs_cgrotor;	 
	__u32	fs_csp[31 ];	 
	__u32	fs_maxcluster;
	__u32	fs_cpc;		 
	__u16	fs_opostbl[16][8];	 	
	union {
		struct {
			__s32	fs_sparecon[53]; 
			__s32	fs_reclaim;
			__s32	fs_sparecon2[1];
			__s32	fs_state;	 
			__u32	fs_qbmask[2];	 
			__u32	fs_qfmask[2];	 
		} fs_sun;
		struct {
			__s32	fs_sparecon[50]; 
			__s32	fs_contigsumsize; 
			__s32	fs_maxsymlinklen; 
			__s32	fs_inodefmt;	 
			__u32	fs_maxfilesize[2];	 
			__u32	fs_qbmask[2];	 
			__u32	fs_qfmask[2];	 
			__s32	fs_state;	 
		} fs_44;
	} fs_u;
	__s32	fs_postblformat;	 
	__s32	fs_nrpos;		 
	__s32	fs_postbloff;		 
	__s32	fs_rotbloff;		 
	__s32	fs_magic;		 
	__u8	fs_space[1];		 
};

 





 





 





 








 


struct	ufs_cylinder_group {
	__u32	cg_link;		 
	__u32	cg_magic;		 
	__u32	cg_time;		 
	__u32	cg_cgx;			 
	__u16	cg_ncyl;		 
	__u16	cg_niblk;		 
	__u32	cg_ndblk;		 
	struct	ufs_csum cg_cs;		 
	__u32	cg_rotor;		 
	__u32	cg_frotor;		 
	__u32	cg_irotor;		 
	__u32	cg_frsum[(8192  / 1024 ) ];	 
	__u32	cg_btotoff;		 
	__u32	cg_boff;		 
	__u32	cg_iusedoff;		 
	__u32	cg_freeoff;		 
	__u32	cg_nextfreeoff;		 
	union {
		struct {
			__u32	cg_clustersumoff;	 
			__u32	cg_clusteroff;		 
			__u32	cg_nclusterblks;	 
			__u32	cg_sparecon[13];	 
		} cg_44;
		__u32	cg_sparecon[16];	 
	} cg_u;
	__u8	cg_space[1];		 
 
};

 


struct ufs_inode {
	__u16	ui_mode;		 
	__u16	ui_nlink;		 
	union {
		struct {
			__u16	ui_suid;	 
			__u16	ui_sgid;	 
		} oldids;
		__u32	ui_inumber;		 
		__u32	ui_author;		 
	} ui_u1;
	__u64	ui_size;		 
	struct ufs_timeval ui_atime;	 
	struct ufs_timeval ui_mtime;	 
	struct ufs_timeval ui_ctime;	 
	union {
		struct {
			__u32	ui_db[12 ]; 
			__u32	ui_ib[3 ]; 
		} ui_addr;
		__u8	ui_symlink[4*(12 + 3 )]; 
	} ui_u2;
	__u32	ui_flags;		 
	__u32	ui_blocks;		 
	__u32	ui_gen;			 
	union {
		struct {
			__u32	ui_shadow;	 
			__u32	ui_uid;		 
			__u32	ui_gid;		 
			__u32	ui_oeftflag;	 
		} ui_sun;
		struct {
			__u32	ui_uid;		 
			__u32	ui_gid;		 
			__s32	ui_spare[2];	 
		} ui_44;
		struct {
			__u32	ui_uid;		 
			__u32	ui_gid;		 
			__u16	ui_modeh;	 
			__u16	ui_spare;	 
			__u32	ui_trans;	 
		} ui_hurd;
	} ui_u3;
};

 
 






 








 
extern int ufs_permission (struct inode *, int);

 
extern void ufs_free_fragments (struct inode *, unsigned, unsigned);
extern void ufs_free_blocks (struct inode *, unsigned, unsigned);
extern unsigned ufs_new_fragments (struct inode *, u32 *, unsigned, unsigned, unsigned, int *);

 
extern struct ufs_cg_private_info * ufs_load_cylinder (struct super_block *, unsigned);
extern void ufs_put_cylinder (struct super_block *, unsigned);

 
extern struct inode_operations ufs_dir_inode_operations;
extern struct file_operations ufs_dir_operations;
extern int ufs_check_dir_entry (const char *, struct inode *, struct ufs_dir_entry *, struct buffer_head *, unsigned long);

 
extern struct inode_operations ufs_file_inode_operations;
extern struct file_operations ufs_file_operations;

 
extern void ufs_free_inode (struct inode *inode);
extern struct inode * ufs_new_inode (const struct inode *, int, int *);

 
extern int ufs_bmap (struct inode *, int);
extern void ufs_read_inode (struct inode *);
extern void ufs_put_inode (struct inode *);
extern void ufs_write_inode (struct inode *);
extern int ufs_sync_inode (struct inode *);
extern void ufs_write_inode (struct inode *);
extern void ufs_delete_inode (struct inode *);
extern struct buffer_head * ufs_getfrag (struct inode *, unsigned, int, int *);
extern struct buffer_head * ufs_bread (struct inode *, unsigned, int, int *);

 
extern int ufs_lookup (struct inode *, struct dentry *);
extern int ufs_mkdir(struct inode *, struct dentry *, int);
extern int ufs_rmdir (struct inode *, struct dentry *);
extern int ufs_unlink (struct inode *, struct dentry *);
extern int ufs_create (struct inode *, struct dentry *, int);
extern int ufs_rename (struct inode *, struct dentry *, struct inode *, struct dentry *);
extern int ufs_mknod (struct inode *, struct dentry *, int, int);
extern int ufs_symlink (struct inode *, struct dentry *, const char *);
extern int ufs_link (struct dentry *, struct inode *, struct dentry *);
        
 
extern struct super_operations ufs_super_ops;
extern struct file_system_type ufs_fs_type;
extern void ufs_warning (struct super_block *, const char *, const char *, ...) __attribute__ ((format (printf, 3, 4)));
extern void ufs_error (struct super_block *, const char *, const char *, ...) __attribute__ ((format (printf, 3, 4)));
extern void ufs_panic (struct super_block *, const char *, const char *, ...) __attribute__ ((format (printf, 3, 4)));
extern int init_ufs_fs(void);
extern void ufs_write_super (struct super_block *);

 
extern struct inode_operations ufs_symlink_inode_operations;

 
extern void ufs_truncate (struct inode *);




# 17 "/home/linas/src/linux/include/linux/ufs_fs_sb.h" 2


 



struct ufs_buffer_head {
	unsigned fragment;			 
	unsigned count;				 
	struct buffer_head * bh[(8192  / 1024 ) ];	 
};

struct ufs_cg_private_info {
	struct ufs_cylinder_group ucg;
	__u32	c_cgx;		 
	__u16	c_ncyl;		 
	__u16	c_niblk;	 
	__u32	c_ndblk;	 
	__u32	c_rotor;	 
	__u32	c_frotor;	 
	__u32	c_irotor;	 
	__u32	c_btotoff;	 
	__u32	c_boff;		 
	__u32	c_iusedoff;	 
	__u32	c_freeoff;	 
	__u32	c_nextfreeoff;	 
	__u32	c_clustersumoff; 
	__u32	c_clusteroff;	 
	__u32	c_nclusterblks;	 
};	

struct ufs_sb_private_info {
	struct ufs_buffer_head s_ubh;  
	__u32	s_sblkno;	 
	__u32	s_cblkno;	 
	__u32	s_iblkno;	 
	__u32	s_dblkno;	 
	__u32	s_cgoffset;	 
	__u32	s_cgmask;	 
	__u32	s_size;		 
	__u32	s_dsize;	 
	__u32	s_ncg;		 
	__u32	s_bsize;	 
	__u32	s_fsize;	 
	__u32	s_fpb;		 
	__u32	s_minfree;	 
	__u32	s_bmask;	 
	__u32	s_fmask;	 
	__u32	s_bshift;	 
	__u32   s_fshift;	 
	__u32	s_fpbshift;	 
	__u32	s_fsbtodb;	 
	__u32	s_sbsize;	 
	__u32   s_csmask;	 
	__u32	s_csshift;	 
	__u32	s_nindir;	 
	__u32	s_inopb;	 
	__u32	s_nspf;		 
	__u32	s_npsect;	 
	__u32	s_interleave;	 
	__u32	s_trackskew;	 
	__u32	s_csaddr;	 
	__u32	s_cssize;	 
	__u32	s_cgsize;	 
	__u32	s_ntrak;	 
	__u32	s_nsect;	 
	__u32	s_spc;		 
	__u32	s_ipg;		 
	__u32	s_fpg;		 
	__u32	s_cpc;		 
	__s32	s_contigsumsize; 
	__s64	s_qbmask;	 
	__s64	s_qfmask;	 
	__s32	s_postblformat;	 
	__s32	s_nrpos;	 
        __s32	s_postbloff;	 
	__s32	s_rotbloff;	 

	__u32	s_fpbmask;	 
	__u32	s_apb;		 
	__u32	s_2apb;		 
	__u32	s_3apb;		 
	__u32	s_apbmask;	 
	__u32	s_apbshift;	 
	__u32	s_2apbshift;	 
	__u32	s_3apbshift;	 
	__u32	s_nspfshift;	 
	__u32	s_nspb;		 
	__u32	s_inopf;	 
	__u32	s_sbbase;	 
	__u32	s_bpf;		 
	__u32	s_bpfshift;	 
	__u32	s_bpfmask;	 
};





struct ufs_sb_info {
	struct ufs_sb_private_info * s_uspi;	
	struct ufs_csum	* s_csp[31 ];
	int s_rename_lock;
	struct wait_queue * s_rename_wait;
	unsigned s_swab;
	unsigned s_flags;
	struct buffer_head ** s_ucg;
	struct ufs_cg_private_info * s_ucpi[8 ]; 
	unsigned s_cgno[8 ];
	unsigned short s_cg_loaded;
	unsigned s_mount_opt;
};

 





struct ufs_super_block_first {
	__u32	fs_link;
	__u32	fs_rlink;
	__u32	fs_sblkno;
	__u32	fs_cblkno;
	__u32	fs_iblkno;
	__u32	fs_dblkno;
	__u32	fs_cgoffset;
	__u32	fs_cgmask;
	__u32	fs_time;
	__u32	fs_size;
	__u32	fs_dsize;
	__u32	fs_ncg;
	__u32	fs_bsize;
	__u32	fs_fsize;
	__u32	fs_frag;
	__u32	fs_minfree;
	__u32	fs_rotdelay;
	__u32	fs_rps;
	__u32	fs_bmask;
	__u32	fs_fmask;
	__u32	fs_bshift;
	__u32	fs_fshift;
	__u32	fs_maxcontig;
	__u32	fs_maxbpg;
	__u32	fs_fragshift;
	__u32	fs_fsbtodb;
	__u32	fs_sbsize;
	__u32	fs_csmask;
	__u32	fs_csshift;
	__u32	fs_nindir;
	__u32	fs_inopb;
	__u32	fs_nspf;
	__u32	fs_optim;
	__u32	fs_npsect;
	__u32	fs_interleave;
	__u32	fs_trackskew;
	__u32	fs_id[2];
	__u32	fs_csaddr;
	__u32	fs_cssize;
	__u32	fs_cgsize;
	__u32	fs_ntrak;
	__u32	fs_nsect;
	__u32	fs_spc;
	__u32	fs_ncyl;
	__u32	fs_cpg;
	__u32	fs_ipg;
	__u32	fs_fpg;
	struct ufs_csum fs_cstotal;
	__u8	fs_fmod;
	__u8	fs_clean;
	__u8	fs_ronly;
	__u8	fs_flags;
	__u8	fs_fsmnt[512  - 212];

};

struct ufs_super_block_second {
	__u8	fs_fsmnt[212];
	__u32	fs_cgrotor;
	__u32	fs_csp[31 ];
	__u32	fs_maxcluster;
	__u32	fs_cpc;
	__u16	fs_opostbl[82];
};	

struct ufs_super_block_third {
	__u16	fs_opostbl[46];
	union {
		struct {
			__s32	fs_sparecon[53]; 
			__s32	fs_reclaim;
			__s32	fs_sparecon2[1];
			__s32	fs_state;	 
			__u32	fs_qbmask[2];	 
			__u32	fs_qfmask[2];	 
		} fs_sun;
		struct {
			__s32	fs_sparecon[50]; 
			__s32	fs_contigsumsize; 
			__s32	fs_maxsymlinklen; 
			__s32	fs_inodefmt;	 
			__u32	fs_maxfilesize[2];	 
			__u32	fs_qbmask[2];	 
			__u32	fs_qfmask[2];	 
			__s32	fs_state;	 
		} fs_44;
	} fs_u;
	__s32	fs_postblformat;
	__s32	fs_nrpos;
	__s32	fs_postbloff;
	__s32	fs_rotbloff;
	__s32	fs_magic;
	__u8	fs_space[1];
};


# 509 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/romfs_fs_sb.h" 1



 

struct romfs_sb_info {
	unsigned long s_maxsize;
};


# 510 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/smb_fs_sb.h" 1
 













# 1 "/home/linas/src/linux/include/linux/smb.h" 1
 












enum smb_protocol { 
	SMB_PROTOCOL_NONE, 
	SMB_PROTOCOL_CORE, 
	SMB_PROTOCOL_COREPLUS, 
	SMB_PROTOCOL_LANMAN1, 
	SMB_PROTOCOL_LANMAN2, 
	SMB_PROTOCOL_NT1 
};

enum smb_case_hndl {
	SMB_CASE_DEFAULT,
	SMB_CASE_LOWER,
	SMB_CASE_UPPER
};

struct smb_dskattr {
        __u16 total;
        __u16 allocblocks;
        __u16 blocksize;
        __u16 free;
};

struct smb_conn_opt {

         
	unsigned int fd;

	enum smb_protocol protocol;
	enum smb_case_hndl case_handling;

	 

	__u32              max_xmit;
	__u16              server_uid;
	__u16              tid;

         
        __u16              secmode;
        __u16              maxmux;
        __u16              maxvcs;
        __u16              rawmode;
        __u32              sesskey;

	 
	__u32              maxraw;
	__u32              capabilities;
	__u16              serverzone;
};






 


struct smb_fattr {

	__u16 attr;

	unsigned long	f_ino;
	umode_t		f_mode;
	nlink_t		f_nlink;
	uid_t		f_uid;
	gid_t		f_gid;
	kdev_t		f_rdev;
	off_t		f_size;
	time_t		f_atime;
	time_t		f_mtime;
	time_t		f_ctime;
	unsigned long	f_blksize;
	unsigned long	f_blocks;
};

struct smb_dirent {
	struct smb_fattr attr;

	int f_pos;
	int len;
	__u8 name[255 ];
};

enum smb_conn_state {
        CONN_VALID,              
        CONN_INVALID,            

        CONN_RETRIED             
};

 














 




# 15 "/home/linas/src/linux/include/linux/smb_fs_sb.h" 2


 




struct smb_sb_info {
        enum smb_conn_state state;
	struct file * sock_file;

        struct smb_mount_data *mnt;
        unsigned char *temp_buf;

	 


	unsigned int generation;
	pid_t conn_pid;
	struct smb_conn_opt opt;

	struct semaphore sem;
	struct wait_queue * wait;

	__u32              packet_size;
	unsigned char *    packet;
        unsigned short     rcls;  
        unsigned short     err;

         
        void *data_ready;
};




# 511 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/hfs_fs_sb.h" 1
 












 
struct hfs_name;

typedef int (*hfs_namein_fn) (char *, const struct hfs_name *);
typedef void (*hfs_nameout_fn) (struct hfs_name *, const char *, int);
typedef void (*hfs_ifill_fn) (struct inode *, ino_t);

 




struct hfs_sb_info {
	int			magic;		 
	struct hfs_mdb		*s_mdb;		 
	int			s_quiet;	 

	int			s_lowercase;	 
	int			s_afpd;		 
	hfs_namein_fn		s_namein;	 


	hfs_nameout_fn		s_nameout;	 


	hfs_ifill_fn		s_ifill;	 

	const struct hfs_name	*s_reserved1;	 
	const struct hfs_name	*s_reserved2;	 
	__u32			s_type;		 
	__u32			s_creator;	 
	umode_t			s_umask;	 

	uid_t			s_uid;		 
	gid_t			s_gid;		 
	char			s_conv;		 
};


# 512 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/adfs_fs_sb.h" 1
 








# 1 "/home/linas/src/linux/include/linux/adfs_fs.h" 1




 



 


struct adfs_discrecord {
    unsigned char  log2secsize;
    unsigned char  secspertrack;
    unsigned char  heads;
    unsigned char  density;
    unsigned char  idlen;
    unsigned char  log2bpmb;
    unsigned char  skew;
    unsigned char  bootoption;
    unsigned char  lowsector;
    unsigned char  nzones;
    unsigned short zone_spare;
    unsigned long  root;
    unsigned long  disc_size;
    unsigned short disc_id;
    unsigned char  disc_name[10];
    unsigned long  disc_type;
    unsigned long  disc_size_high;
    unsigned char  log2sharesize:4;
    unsigned char  unused:4;
    unsigned char  big_flag:1;
};









 


struct adfs_dirheader {
	unsigned char startmasseq;
	unsigned char startname[4];
};





 


struct adfs_direntry {
	char dirobname[10];

	__u8 dirload[4];
	__u8 direxec[4];
	__u8 dirlen[4];
	__u8 dirinddiscadd[3];
	__u8 newdiratts;







};


struct adfs_idir_entry {
	__u32		inode_no;			 
	__u32		file_id;			 
	__u32		name_len;			 
	__u32		size;				 
	__u32		mtime;				 
	__u32		filetype;			 
	__u8		mode;				 
	char		name[255 ];	 
};

 


union adfs_dirtail {
	struct {
		unsigned char dirlastmask;
		char dirname[10];
		unsigned char dirparent[3];
		char dirtitle[19];
		unsigned char reserved[14];
		unsigned char endmasseq;
		unsigned char endname[4];
		unsigned char dircheckbyte;
	} old;
	struct {
		unsigned char dirlastmask;
		unsigned char reserved[2];
		unsigned char dirparent[3];
		char dirtitle[19];
		char dirname[10];
		unsigned char endmasseq;
		unsigned char endname[4];
		unsigned char dircheckbyte;
	} new;
};


 




extern inline int adfs_checkbblk(unsigned char *ptr)
{
	unsigned int result = 0;
	unsigned char *p = ptr + 511;

	do {
	        result = (result & 0xff) + (result >> 8);
        	result = result + *--p;
	} while (p != ptr);

	return (result & 0xff) != ptr[511];
}

 
extern unsigned int adfs_val (unsigned char *p, int len);
extern int adfs_dir_read_parent (struct inode *inode, struct buffer_head **bhp);
extern int adfs_dir_read (struct inode *inode, struct buffer_head **bhp);
extern int adfs_dir_check (struct inode *inode, struct buffer_head **bhp,
			   int buffers, union adfs_dirtail *dtp);
extern void adfs_dir_free (struct buffer_head **bhp, int buffers);
extern int adfs_dir_get (struct super_block *sb, struct buffer_head **bhp,
			 int buffers, int pos, unsigned long parent_object_id,
			 struct adfs_idir_entry *ide);
extern int adfs_dir_find_entry (struct super_block *sb, struct buffer_head **bhp,
				int buffers, unsigned int index,
				struct adfs_idir_entry *ide);

 
extern int adfs_inode_validate (struct inode *inode);
extern unsigned long adfs_inode_generate (unsigned long parent_id, int diridx);
extern unsigned long adfs_inode_objid (struct inode *inode);
extern unsigned int adfs_parent_bmap (struct inode *inode, int block);
extern int adfs_bmap (struct inode *inode, int block);
extern void adfs_read_inode (struct inode *inode);

 
extern int adfs_map_lookup (struct super_block *sb, int frag_id, int offset);

 
extern int adfs_lookup (struct inode *dir, struct dentry *dentry);

 
extern int init_adfs_fs (void);
extern void adfs_error (struct super_block *, const char *, const char *, ...);

 



 
extern struct inode_operations adfs_dir_inode_operations;

 
extern struct inode_operations adfs_file_inode_operations;



# 10 "/home/linas/src/linux/include/linux/adfs_fs_sb.h" 2


 


struct adfs_sb_info {
	struct buffer_head *s_sbh;	 
	struct adfs_discrecord *s_dr;	 
	__u16	s_zone_size;		 
	__u16	s_ids_per_zone;		 
	__u32	s_idlen;		 
	__u32	s_map_size;		 
	__u32	s_zonesize;		 
	__u32	s_map_block;		 
	struct buffer_head **s_map;	 
	__u32	s_root;			 
	__s8	s_map2blk;		 
};


# 513 "/home/linas/src/linux/include/linux/fs.h" 2

# 1 "/home/linas/src/linux/include/linux/qnx4_fs_sb.h" 1
 














 



struct qnx4_sb_info {
	struct buffer_head *sb_buf;	 
	struct qnx4_super_block *sb;	 
	unsigned int Version;	 
	struct qnx4_inode_entry *BitMap;	 
};


# 514 "/home/linas/src/linux/include/linux/fs.h" 2


extern struct list_head super_blocks;


struct super_block {
	struct list_head	s_list;		 
	kdev_t			s_dev;
	unsigned long		s_blocksize;
	unsigned char		s_blocksize_bits;
	unsigned char		s_lock;
	unsigned char		s_rd_only;
	unsigned char		s_dirt;
	struct file_system_type	*s_type;
	struct super_operations	*s_op;
	struct dquot_operations	*dq_op;
	unsigned long		s_flags;
	unsigned long		s_magic;
	unsigned long		s_time;
	struct dentry		*s_root;
	struct wait_queue	*s_wait;

	struct inode		*s_ibasket;
	short int		s_ibasket_count;
	short int		s_ibasket_max;
	struct list_head	s_dirty;	 

	union {
		struct minix_sb_info	minix_sb;
		struct ext2_sb_info	ext2_sb;
		struct hpfs_sb_info	hpfs_sb;
		struct ntfs_sb_info     ntfs_sb;
		struct msdos_sb_info	msdos_sb;
		struct isofs_sb_info	isofs_sb;
		struct nfs_sb_info	nfs_sb;
		struct sysv_sb_info	sysv_sb;
		struct affs_sb_info	affs_sb;
		struct ufs_sb_info	ufs_sb;
		struct romfs_sb_info	romfs_sb;
		struct smb_sb_info	smbfs_sb;
		struct hfs_sb_info	hfs_sb;
		struct adfs_sb_info	adfs_sb;
		struct qnx4_sb_info	qnx4_sb;	   
		void			*generic_sbp;
	} u;
};

 


extern int vfs_rmdir(struct inode *, struct dentry *);
extern int vfs_unlink(struct inode *, struct dentry *);
extern int vfs_rename(struct inode *, struct dentry *, struct inode *, struct dentry *);

 





typedef int (*filldir_t)(void *, const char *, int, off_t, ino_t);
	
struct file_operations {
	loff_t (*llseek) (struct file *, loff_t, int);
	ssize_t (*read) (struct file *, char *, size_t, loff_t *);
	ssize_t (*write) (struct file *, const char *, size_t, loff_t *);
	int (*readdir) (struct file *, void *, filldir_t);
	unsigned int (*poll) (struct file *, struct poll_table_struct *);
	int (*ioctl) (struct inode *, struct file *, unsigned int, unsigned long);
	int (*mmap) (struct file *, struct vm_area_struct *);
	int (*open) (struct inode *, struct file *);
	int (*flush) (struct file *);
	int (*release) (struct inode *, struct file *);
	int (*fsync) (struct file *, struct dentry *);
	int (*fasync) (int, struct file *, int);
	int (*check_media_change) (kdev_t dev);
	int (*revalidate) (kdev_t dev);
	int (*lock) (struct file *, int, struct file_lock *);
};

struct inode_operations {
	struct file_operations * default_file_ops;
	int (*create) (struct inode *,struct dentry *,int);
	int (*lookup) (struct inode *,struct dentry *);
	int (*link) (struct dentry *,struct inode *,struct dentry *);
	int (*unlink) (struct inode *,struct dentry *);
	int (*symlink) (struct inode *,struct dentry *,const char *);
	int (*mkdir) (struct inode *,struct dentry *,int);
	int (*rmdir) (struct inode *,struct dentry *);
	int (*mknod) (struct inode *,struct dentry *,int,int);
	int (*rename) (struct inode *, struct dentry *,
			struct inode *, struct dentry *);
	int (*readlink) (struct dentry *, char *,int);
	struct dentry * (*follow_link) (struct dentry *, struct dentry *, unsigned int);
	int (*readpage) (struct file *, struct page *);
	int (*writepage) (struct file *, struct page *);
	int (*bmap) (struct inode *,int);
	void (*truncate) (struct inode *);
	int (*permission) (struct inode *, int);
	int (*smap) (struct inode *,int);
	int (*updatepage) (struct file *, struct page *, unsigned long, unsigned int, int);
	int (*revalidate) (struct dentry *);
};

struct super_operations {
	void (*read_inode) (struct inode *);
	void (*write_inode) (struct inode *);
	void (*put_inode) (struct inode *);
	void (*delete_inode) (struct inode *);
	int (*notify_change) (struct dentry *, struct iattr *);
	void (*put_super) (struct super_block *);
	void (*write_super) (struct super_block *);
	int (*statfs) (struct super_block *, struct statfs *, int);
	int (*remount_fs) (struct super_block *, int *, char *);
	void (*clear_inode) (struct inode *);
	void (*umount_begin) (struct super_block *);
};

struct dquot_operations {
	void (*initialize) (struct inode *, short);
	void (*drop) (struct inode *);
	int (*alloc_block) (const struct inode *, unsigned long, uid_t, char);
	int (*alloc_inode) (const struct inode *, unsigned long, uid_t);
	void (*free_block) (const struct inode *, unsigned long);
	void (*free_inode) (const struct inode *, unsigned long);
	int (*transfer) (struct inode *, struct iattr *, char, uid_t);
};

struct file_system_type {
	const char *name;
	int fs_flags;
	struct super_block *(*read_super) (struct super_block *, void *, int);
	struct file_system_type * next;
};

extern int register_filesystem(struct file_system_type *);
extern int unregister_filesystem(struct file_system_type *);





extern int locks_mandatory_locked(struct inode *inode);
extern int locks_mandatory_area(int read_write, struct inode *inode,
				struct file *filp, loff_t offset,
				size_t count);

extern inline int locks_verify_locked(struct inode *inode)
{
	 


	if ((((  inode  )->i_sb && (  inode  )->i_sb->s_flags & (  64  )) || (  inode  )->i_flags & (  64  ))   &&
	    (inode->i_mode & (0002000  | 00010 )) == 0002000 )
		return (locks_mandatory_locked(inode));
	return (0);
}

extern inline int locks_verify_area(int read_write, struct inode *inode,
				    struct file *filp, loff_t offset,
				    size_t count)
{
	 


	if ((((  inode  )->i_sb && (  inode  )->i_sb->s_flags & (  64  )) || (  inode  )->i_flags & (  64  ))   &&
	    (inode->i_mode & (0002000  | 00010 )) == 0002000 )
		return (locks_mandatory_area(read_write, inode, filp, offset,
					     count));
	return (0);
}


 

   int sys_open(const char *, int, int);
   int sys_close(unsigned int);		 
extern int do_truncate(struct dentry *, unsigned long);
extern int get_unused_fd(void);
extern void put_unused_fd(unsigned int);
extern int close_fp(struct file *, fl_owner_t id);
extern struct file *filp_open(const char *, int, int);

extern char * getname(const char * filename);



extern void kill_fasync(struct fasync_struct *fa, int sig);
extern int register_blkdev(unsigned int, const char *, struct file_operations *);
extern int unregister_blkdev(unsigned int major, const char * name);
extern int blkdev_open(struct inode * inode, struct file * filp);
extern int blkdev_release (struct inode * inode);
extern struct file_operations def_blk_fops;
extern struct inode_operations blkdev_inode_operations;

 
extern int register_chrdev(unsigned int, const char *, struct file_operations *);
extern int unregister_chrdev(unsigned int major, const char * name);
extern int chrdev_open(struct inode * inode, struct file * filp);
extern struct file_operations def_chr_fops;
extern struct inode_operations chrdev_inode_operations;
extern char * bdevname(kdev_t dev);
extern char * cdevname(kdev_t dev);
extern char * kdevname(kdev_t dev);


extern void init_fifo(struct inode * inode);
extern struct inode_operations fifo_inode_operations;

 
extern void make_bad_inode(struct inode * inode);
extern int is_bad_inode(struct inode * inode);

extern struct file_operations connecting_fifo_fops;
extern struct file_operations read_fifo_fops;
extern struct file_operations write_fifo_fops;
extern struct file_operations rdwr_fifo_fops;
extern struct file_operations read_pipe_fops;
extern struct file_operations write_pipe_fops;
extern struct file_operations rdwr_pipe_fops;

extern struct file_system_type *get_fs_type(const char *name);

extern int fs_may_remount_ro(struct super_block *);
extern int fs_may_mount(kdev_t dev);

extern struct file *inuse_filps;

extern void refile_buffer(struct buffer_head * buf);
extern void set_writetime(struct buffer_head * buf, int flag);
extern int try_to_free_buffers(struct page *);

extern int nr_buffers;
extern int buffermem;
extern int nr_buffer_heads;






void mark_buffer_uptodate(struct buffer_head * bh, int on);

extern inline void mark_buffer_clean(struct buffer_head * bh)
{
	if (test_and_clear_bit(1 , &bh->b_state)) {
		if (bh->b_list == 2 )
			refile_buffer(bh);
	}
}

extern inline void mark_buffer_dirty(struct buffer_head * bh, int flag)
{
	if (!test_and_set_bit(1 , &bh->b_state)) {
		set_writetime(bh, flag);
		if (bh->b_list != 2 )
			refile_buffer(bh);
	}
}

extern int check_disk_change(kdev_t dev);
extern int invalidate_inodes(struct super_block * sb);
extern void invalidate_inode_pages(struct inode *);
extern void invalidate_buffers(kdev_t dev);
extern int floppy_is_wp(int minor);
extern void sync_inodes(kdev_t dev);
extern void write_inode_now(struct inode *inode);
extern void sync_dev(kdev_t dev);
extern int fsync_dev(kdev_t dev);
extern void sync_supers(kdev_t dev);
extern int bmap(struct inode * inode,int block);
extern int notify_change(struct dentry *, struct iattr *);
extern int permission(struct inode * inode,int mask);
extern int get_write_access(struct inode *inode);
extern void put_write_access(struct inode *inode);
extern struct dentry * open_namei(const char * pathname, int flag, int mode);
extern struct dentry * do_mknod(const char * filename, int mode, dev_t dev);
extern int do_pipe(int *);

 
extern int is_subdir(struct dentry *, struct dentry *);
extern ino_t find_inode_number(struct dentry *, struct qstr *);

 











extern struct dentry * lookup_dentry(const char *, struct dentry *, unsigned int);
extern struct dentry * __namei(const char *, unsigned int);




extern void iput(struct inode *);
extern struct inode * iget(struct super_block *, unsigned long);
extern void clear_inode(struct inode *);
extern struct inode * get_empty_inode(void);

extern void insert_inode_hash(struct inode *);
extern void remove_inode_hash(struct inode *);
extern struct file * get_empty_filp(void);
extern struct buffer_head * get_hash_table(kdev_t, int, int);
extern struct buffer_head * getblk(kdev_t, int, int);
extern struct buffer_head * find_buffer(kdev_t dev, int block, int size);
extern void ll_rw_block(int, int, struct buffer_head * bh[]);
extern int is_read_only(kdev_t);
extern void __brelse(struct buffer_head *);
extern inline void brelse(struct buffer_head *buf)
{
	if (buf)
		__brelse(buf);
}
extern void __bforget(struct buffer_head *buf);
extern inline void bforget(struct buffer_head *buf)
{
	if (buf)
		__bforget(buf);
}
extern void set_blocksize(kdev_t dev, int size);
extern unsigned int get_hardblocksize(kdev_t dev);
extern struct buffer_head * bread(kdev_t dev, int block, int size);
extern struct buffer_head * breada(kdev_t dev,int block, int size, 
				   unsigned int pos, unsigned int filesize);

extern int brw_page(int, struct page *, kdev_t, int [], int, int);

extern int generic_readpage(struct file *, struct page *);
extern int generic_file_mmap(struct file *, struct vm_area_struct *);
extern ssize_t generic_file_read(struct file *, char *, size_t, loff_t *);
extern ssize_t generic_file_write(struct file *, const char*, size_t, loff_t*);

extern struct super_block *get_super(kdev_t dev);
extern void put_super(kdev_t dev);
unsigned long generate_cluster(kdev_t dev, int b[], int size);
unsigned long generate_cluster_swab32(kdev_t dev, int b[], int size);
extern kdev_t ROOT_DEV;

extern void show_buffers(void);
extern void mount_root(void);


extern kdev_t real_root_dev;
extern int change_root(kdev_t new_root_dev,const char *put_old);


extern ssize_t char_read(struct file *, char *, size_t, loff_t *);
extern ssize_t block_read(struct file *, char *, size_t, loff_t *);
extern int read_ahead[];

extern ssize_t char_write(struct file *, const char *, size_t, loff_t *);
extern ssize_t block_write(struct file *, const char *, size_t, loff_t *);

extern int block_fsync(struct file *, struct dentry *dir);
extern int file_fsync(struct file *, struct dentry *dir);

extern int inode_change_ok(struct inode *, struct iattr *);
extern void inode_setattr(struct inode *, struct iattr *);

 
# 1 "/home/linas/src/linux/include/linux/minix_fs.h" 1



 



 







 




















 



struct minix_inode {
	__u16 i_mode;
	__u16 i_uid;
	__u32 i_size;
	__u32 i_time;
	__u8  i_gid;
	__u8  i_nlinks;
	__u16 i_zone[9];
};

 





struct minix2_inode {
	__u16 i_mode;
	__u16 i_nlinks;
	__u16 i_uid;
	__u16 i_gid;
	__u32 i_size;
	__u32 i_atime;
	__u32 i_mtime;
	__u32 i_ctime;
	__u32 i_zone[10];
};

 


struct minix_super_block {
	__u16 s_ninodes;
	__u16 s_nzones;
	__u16 s_imap_blocks;
	__u16 s_zmap_blocks;
	__u16 s_firstdatazone;
	__u16 s_log_zone_size;
	__u32 s_max_size;
	__u16 s_magic;
	__u16 s_state;
	__u32 s_zones;
};

struct minix_dir_entry {
	__u16 inode;
	char name[0];
};



extern int minix_lookup(struct inode * dir, struct dentry *dentry);
extern int minix_create(struct inode * dir, struct dentry *dentry, int mode);
extern int minix_mkdir(struct inode * dir, struct dentry *dentry, int mode);
extern int minix_rmdir(struct inode * dir, struct dentry *dentry);
extern int minix_unlink(struct inode * dir, struct dentry *dentry);
extern int minix_symlink(struct inode * inode, struct dentry *dentry,
	const char * symname);
extern int minix_link(struct dentry * old_dentry, struct inode * dir, struct dentry *dentry);
extern int minix_mknod(struct inode * dir, struct dentry *dentry, int mode, int rdev);
extern int minix_rename(struct inode * old_dir, struct dentry *old_dentry,
			struct inode * new_dir, struct dentry *new_dentry);
extern struct inode * minix_new_inode(const struct inode * dir);
extern void minix_free_inode(struct inode * inode);
extern unsigned long minix_count_free_inodes(struct super_block *sb);
extern int minix_new_block(struct super_block * sb);
extern void minix_free_block(struct super_block * sb, int block);
extern unsigned long minix_count_free_blocks(struct super_block *sb);

extern int minix_bmap(struct inode *,int);

extern struct buffer_head * minix_getblk(struct inode *, int, int);
extern struct buffer_head * minix_bread(struct inode *, int, int);

extern void minix_truncate(struct inode *);
extern int init_minix_fs(void);
extern int minix_sync_inode(struct inode *);
extern int minix_sync_file(struct file *, struct dentry *);

extern struct inode_operations minix_file_inode_operations;
extern struct inode_operations minix_dir_inode_operations;
extern struct inode_operations minix_symlink_inode_operations;
extern struct dentry_operations minix_dentry_operations;




# 881 "/home/linas/src/linux/include/linux/fs.h" 2






# 14 "fs/binfmt_elf.c" 2


# 1 "/home/linas/src/linux/include/linux/sched.h" 1





extern unsigned long event;

# 1 "/home/linas/src/linux/include/linux/binfmts.h" 1



# 1 "/home/linas/src/linux/include/linux/ptrace.h" 1


 
 

 




















# 4 "/home/linas/src/linux/include/linux/binfmts.h" 2

# 1 "/home/linas/src/linux/include/linux/capability.h" 1
 





 







 




 




 


typedef struct __user_cap_header_struct {
	__u32 version;
	int pid;
} *cap_user_header_t;
 
typedef struct __user_cap_data_struct {
        __u32 effective;
        __u32 permitted;
        __u32 inheritable;
} *cap_user_data_t;
  


 









typedef __u32 kernel_cap_t;


  






 



 





 





 




    
 





 








 



 





 
 
 



 
 




 



 




 



 



 



 
 
 
 
 

 
 
 
 
 
 



 
 



 
 




 



 



 



 



 



 



 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 
 
 
 
 

 
 
 
 
 
 
 
 
 

 



 



 

 





 
 
 
 

 
 
 
 



 
 
 



 
 





 


 






















static inline kernel_cap_t cap_combine(kernel_cap_t a, kernel_cap_t b)
{
     kernel_cap_t dest;
     ( dest )  = ( a )  | ( b ) ;
     return dest;
}

static inline kernel_cap_t cap_intersect(kernel_cap_t a, kernel_cap_t b)
{
     kernel_cap_t dest;
     ( dest )  = ( a )  & ( b ) ;
     return dest;
}

static inline kernel_cap_t cap_drop(kernel_cap_t a, kernel_cap_t drop)
{
     kernel_cap_t dest;
     ( dest )  = ( a )  & ~( drop ) ;
     return dest;
}

static inline kernel_cap_t cap_invert(kernel_cap_t c)
{
     kernel_cap_t dest;
     ( dest )  = ~( c ) ;
     return dest;
}













# 5 "/home/linas/src/linux/include/linux/binfmts.h" 2


 








 


struct linux_binprm{
	char buf[128];
	unsigned long page[32 ];
	unsigned long p;
	int sh_bang;
	int java;		 
	struct dentry * dentry;
	int e_uid, e_gid;
	kernel_cap_t cap_inheritable, cap_permitted, cap_effective;
	int argc, envc;
	char * filename;	 
	unsigned long loader, exec;
};

 



struct linux_binfmt {
	struct linux_binfmt * next;
	struct module *module;
	int (*load_binary)(struct linux_binprm *, struct  _i370_interrupt_state_s  * regs);
	int (*load_shlib)(int fd);
	int (*core_dump)(long signr, struct _i370_interrupt_state_s  * regs);
};

extern int register_binfmt(struct linux_binfmt *);
extern int unregister_binfmt(struct linux_binfmt *);

extern int read_exec(struct dentry *, unsigned long offset,
	char * addr, unsigned long count, int to_kmem);

extern int open_dentry(struct dentry *, int mode);

extern int init_elf_binfmt(void);
extern int init_elf32_binfmt(void);
extern int init_aout_binfmt(void);
extern int init_aout32_binfmt(void);
extern int init_script_binfmt(void);
extern int init_java_binfmt(void);
extern int init_em86_binfmt(void);
extern int init_misc_binfmt(void);

extern int prepare_binprm(struct linux_binprm *);
extern void remove_arg_zero(struct linux_binprm *);
extern int search_binary_handler(struct linux_binprm *,struct _i370_interrupt_state_s  *);
extern int flush_old_exec(struct linux_binprm * bprm);
extern unsigned long setup_arg_pages(unsigned long p, struct linux_binprm * bprm);
extern unsigned long copy_strings(int argc,char ** argv,unsigned long *page,
		unsigned long p, int from_kmem);

extern void compute_creds(struct linux_binprm *binprm);

 




# 8 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/personality.h" 1







 




 














 
typedef void (*lcall7_func)(struct _i370_interrupt_state_s  *);


 




struct exec_domain {
	const char *name;
	lcall7_func handler;
	unsigned char pers_low, pers_high;
	unsigned long * signal_map;
	unsigned long * signal_invmap;
	struct module * module;
	struct exec_domain *next;
};

extern struct exec_domain default_exec_domain;

extern struct exec_domain *lookup_exec_domain(unsigned long personality);
extern int register_exec_domain(struct exec_domain *it);
extern int unregister_exec_domain(struct exec_domain *it);
   int sys_personality(unsigned long personality);


# 9 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/tasks.h" 1



 


 












 





# 10 "/home/linas/src/linux/include/linux/sched.h" 2



# 1 "/home/linas/src/linux/include/linux/times.h" 1



struct tms {
	clock_t tms_utime;
	clock_t tms_stime;
	clock_t tms_cutime;
	clock_t tms_cstime;
};


# 13 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/timex.h" 1
 















 




































 












 















 

























 

























 


# 1 "/home/linas/src/linux/include/asm/timex.h" 1
 





 






typedef unsigned long cycles_t;

 





extern cycles_t cacheflush_time;

static inline cycles_t get_cycles(void)
{







	return 0;

}


# 138 "/home/linas/src/linux/include/linux/timex.h" 2


 


 



struct timex {
	unsigned int modes;	 
	long offset;		 
	long freq;		 
	long maxerror;		 
	long esterror;		 
	int status;		 
	long constant;		 
	long precision;		 
	long tolerance;		 


	struct timeval time;	 
	long tick;		 

	long ppsfreq;            
	long jitter;             
	int shift;               
	long stabil;             
	long jitcnt;             
	long calcnt;             
	long errcnt;             
	long stbcnt;             

	int  :32; int  :32; int  :32; int  :32;
	int  :32; int  :32; int  :32; int  :32;
	int  :32; int  :32; int  :32; int  :32;
};

 











 










 






















 











 




extern long tick;                       
extern int tickadj;			 

 


extern int time_state;		 
extern int time_status;		 
extern long time_offset;	 
extern long time_constant;	 
extern long time_tolerance;	 
extern long time_precision;	 
extern long time_maxerror;	 
extern long time_esterror;	 

extern long time_phase;		 
extern long time_freq;		 
extern long time_adj;		 
extern long time_reftime;	 

extern long time_adjust;	 

 
extern long pps_offset;		 
extern long pps_jitter;		 
extern long pps_freq;		 
extern long pps_stabil;		 
extern long pps_valid;		 

 
extern int pps_shift;		 
extern long pps_jitcnt;		 
extern long pps_calcnt;		 
extern long pps_errcnt;		 
extern long pps_stbcnt;		 




# 14 "/home/linas/src/linux/include/linux/sched.h" 2




# 1 "/home/linas/src/linux/include/asm/page.h" 1


# 94 "/home/linas/src/linux/include/asm/page.h"

# 18 "/home/linas/src/linux/include/linux/sched.h" 2


# 1 "/home/linas/src/linux/include/linux/smp.h" 1



 




# 65 "/home/linas/src/linux/include/linux/smp.h"


 


 









# 20 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/tty.h" 1



 



 






		 





# 1 "/home/linas/src/linux/include/linux/major.h" 1



 




 

 























































































 





  




static __inline__ int scsi_blk_major(int m) {
	return (((  m  ) == 8  || ((  m  ) >= 65  && (  m  ) <= 71 )) 	|| ( m ) == 11 ) ;
}


# 21 "/home/linas/src/linux/include/linux/tty.h" 2

# 1 "/home/linas/src/linux/include/linux/termios.h" 1




# 1 "/home/linas/src/linux/include/asm/termios.h" 1



 






# 1 "/home/linas/src/linux/include/asm/ioctls.h" 1


































































































   








# 11 "/home/linas/src/linux/include/asm/termios.h" 2

# 1 "/home/linas/src/linux/include/asm/termbits.h" 1





typedef unsigned char	cc_t;
typedef unsigned int	speed_t;
typedef unsigned int	tcflag_t;

 






struct termios {
	tcflag_t c_iflag;		 
	tcflag_t c_oflag;		 
	tcflag_t c_cflag;		 
	tcflag_t c_lflag;		 
	cc_t c_cc[19 ];		 
	cc_t c_line;			 
	speed_t c_ispeed;		 
	speed_t c_ospeed;		 
};

 



















 












   





 




































 



















































 
















 





 




 





# 12 "/home/linas/src/linux/include/asm/termios.h" 2


struct sgttyb {
	char	sg_ispeed;
	char	sg_ospeed;
	char	sg_erase;
	char	sg_kill;
	short	sg_flags;
};

struct tchars {
	char	t_intrc;
	char	t_quitc;
	char	t_startc;
	char	t_stopc;
	char	t_eofc;
	char	t_brkc;
};

struct ltchars {
	char	t_suspc;
	char	t_dsuspc;
	char	t_rprntc;
	char	t_flushc;
	char	t_werasc;
	char	t_lnextc;
};











































































 








struct winsize {
	unsigned short ws_row;
	unsigned short ws_col;
	unsigned short ws_xpixel;
	unsigned short ws_ypixel;
};


struct termio {
	unsigned short c_iflag;		 
	unsigned short c_oflag;		 
	unsigned short c_cflag;		 
	unsigned short c_lflag;		 
	unsigned char c_line;		 
	unsigned char c_cc[10 ];	 
};

 












 



 












 


 
















 

















 



# 220 "/home/linas/src/linux/include/asm/termios.h"







# 5 "/home/linas/src/linux/include/linux/termios.h" 2



# 22 "/home/linas/src/linux/include/linux/tty.h" 2

# 1 "/home/linas/src/linux/include/linux/tqueue.h" 1
 
















# 1 "/home/linas/src/linux/include/asm/spinlock.h" 1





 





  typedef struct { } spinlock_t;
  


















 












  typedef struct { } rwlock_t;
  























# 146 "/home/linas/src/linux/include/asm/spinlock.h"











# 18 "/home/linas/src/linux/include/linux/tqueue.h" 2


 






















struct tq_struct {
	struct tq_struct *next;		 
	unsigned long sync;		 
	void (*routine)(void *);	 
	void *data;			 
};

typedef struct tq_struct * task_queue;



extern task_queue tq_timer, tq_immediate, tq_scheduler, tq_disk;

 





















extern spinlock_t tqueue_lock;

 


extern __inline__ void queue_task(struct tq_struct *bh_pointer,
			   task_queue *bh_list)
{
	if (!test_and_set_bit(0,&bh_pointer->sync)) {
		unsigned long flags;
		do {   flags  = __cli() ; } while (0) ;
		bh_pointer->next = *bh_list;
		*bh_list = bh_pointer;
		__restore_flags(   flags  )  ;
	}
}

 


extern __inline__ void run_task_queue(task_queue *list)
{
	if (*list) {
		unsigned long flags;
		struct tq_struct *p;

		do {   flags  = __cli() ; } while (0) ;
		p = *list;
		*list = ((void *) 0) ;
		__restore_flags(   flags  )  ;
		
		while (p) {
			void *arg;
			void (*f) (void *);
			struct tq_struct *save_p;
			arg    = p -> data;
			f      = p -> routine;
			save_p = p;
			p      = p -> next;
			__asm__ __volatile__ ("BCR 15,0" : : : "memory") ;
			save_p -> sync = 0;
			(*f)(arg);
		}
	}
}


# 23 "/home/linas/src/linux/include/linux/tty.h" 2

# 1 "/home/linas/src/linux/include/linux/tty_driver.h" 1



 



















































































































struct tty_driver {
	int	magic;		 
	const char	*driver_name;
	const char	*name;
	int	name_base;	 
	short	major;		 
	short	minor_start;	 
	short	num;		 
	short	type;		 
	short	subtype;	 
	struct termios init_termios;  
	int	flags;		 
	int	*refcount;	 
	struct proc_dir_entry *proc_entry;  
	struct tty_driver *other;  

	 


	struct tty_struct **table;
	struct termios **termios;
	struct termios **termios_locked;
	void *driver_state;	 
	
	 



	int  (*open)(struct tty_struct * tty, struct file * filp);
	void (*close)(struct tty_struct * tty, struct file * filp);
	int  (*write)(struct tty_struct * tty, int from_user,
		      const unsigned char *buf, int count);
	void (*put_char)(struct tty_struct *tty, unsigned char ch);
	void (*flush_chars)(struct tty_struct *tty);
	int  (*write_room)(struct tty_struct *tty);
	int  (*chars_in_buffer)(struct tty_struct *tty);
	int  (*ioctl)(struct tty_struct *tty, struct file * file,
		    unsigned int cmd, unsigned long arg);
	void (*set_termios)(struct tty_struct *tty, struct termios * old);
	void (*throttle)(struct tty_struct * tty);
	void (*unthrottle)(struct tty_struct * tty);
	void (*stop)(struct tty_struct *tty);
	void (*start)(struct tty_struct *tty);
	void (*hangup)(struct tty_struct *tty);
	void (*break_ctl)(struct tty_struct *tty, int state);
	void (*flush_buffer)(struct tty_struct *tty);
	void (*set_ldisc)(struct tty_struct *tty);
	void (*wait_until_sent)(struct tty_struct *tty, int timeout);
	void (*send_xchar)(struct tty_struct *tty, char ch);
	int (*read_proc)(char *page, char **start, off_t off,
			  int count, int *eof, void *data);
	int (*write_proc)(struct file *file, const char *buffer,
			  unsigned long count, void *data);

	 


	struct tty_driver *next;
	struct tty_driver *prev;
};

 


 




















 







 





 



 




# 24 "/home/linas/src/linux/include/linux/tty.h" 2

# 1 "/home/linas/src/linux/include/linux/tty_ldisc.h" 1



 


































































































struct tty_ldisc {
	int	magic;
	char	*name;
	int	num;
	int	flags;
	 


	int	(*open)(struct tty_struct *);
	void	(*close)(struct tty_struct *);
	void	(*flush_buffer)(struct tty_struct *tty);
	ssize_t	(*chars_in_buffer)(struct tty_struct *tty);
	ssize_t	(*read)(struct tty_struct * tty, struct file * file,
			unsigned char * buf, size_t nr);
	ssize_t	(*write)(struct tty_struct * tty, struct file * file,
			 const unsigned char * buf, size_t nr);	
	int	(*ioctl)(struct tty_struct * tty, struct file * file,
			 unsigned int cmd, unsigned long arg);
	void	(*set_termios)(struct tty_struct *tty, struct termios * old);
	unsigned int (*poll)(struct tty_struct *, struct file *,
			     struct poll_table_struct *);
	
	 


	void	(*receive_buf)(struct tty_struct *, const unsigned char *cp,
			       char *fp, int count);
	int	(*receive_room)(struct tty_struct *);
	void	(*write_wakeup)(struct tty_struct *);
};






# 25 "/home/linas/src/linux/include/linux/tty.h" 2

# 1 "/home/linas/src/linux/include/linux/serialP.h" 1
 











 











 


struct async_icount {
	__u32	cts, dsr, rng, dcd, tx, rx;
	__u32	frame, parity, overrun, brk;
	__u32	buf_overrun;
};

struct serial_state {
	int	magic;
	int	baud_base;
	int	port;
	int	irq;
	int	flags;
	int	hub6;
	int	type;
	int	line;
	int	xmit_fifo_size;
	int	custom_divisor;
	int	count;
	unsigned short	close_delay;
	unsigned short	closing_wait;  
	struct async_icount	icount;	
	struct termios		normal_termios;
	struct termios		callout_termios;
	struct async_struct *info;
};

struct async_struct {
	int			magic;
	int			port;
	int			hub6;
	int			flags;
	int			xmit_fifo_size;
	struct serial_state	*state;
	struct tty_struct 	*tty;
	int			read_status_mask;
	int			ignore_status_mask;
	int			timeout;
	int			quot;
	int			x_char;	 
	int			close_delay;
	unsigned short		closing_wait;
	unsigned short		closing_wait2;
	int			IER; 	 
	int			MCR; 	 
	unsigned long		event;
	unsigned long		last_active;
	int			line;
	int			blocked_open;  
	long			session;  
	long			pgrp;  
	unsigned char 		*xmit_buf;
	int			xmit_head;
	int			xmit_tail;
	int			xmit_cnt;
	struct tq_struct	tqueue;
	struct wait_queue	*open_wait;
	struct wait_queue	*close_wait;
	struct wait_queue	*delta_msr_wait;
	struct async_struct	*next_port;  
	struct async_struct	*prev_port;
};




 




 





 


struct rs_multiport_struct {
	int		port1;
	unsigned char	mask1, match1;
	int		port2;
	unsigned char	mask2, match2;
	int		port3;
	unsigned char	mask3, match3;
	int		port4;
	unsigned char	mask4, match4;
	int		port_monitor;
};


# 26 "/home/linas/src/linux/include/linux/tty.h" 2





 








 















 



struct screen_info {
	unsigned char  orig_x;			 
	unsigned char  orig_y;			 
	unsigned short dontuse1;		 
	unsigned short orig_video_page;		 
	unsigned char  orig_video_mode;		 
	unsigned char  orig_video_cols;		 
	unsigned short unused2;			 
	unsigned short orig_video_ega_bx;	 
	unsigned short unused3;			 
	unsigned char  orig_video_lines;	 
	unsigned char  orig_video_isVGA;	 
	unsigned short orig_video_points;	 

	 
	unsigned short lfb_width;		 
	unsigned short lfb_height;		 
	unsigned short lfb_depth;		 
	unsigned long  lfb_base;		 
	unsigned long  lfb_size;		 
	unsigned short dontuse2, dontuse3;	 
	unsigned short lfb_linelength;		 
	unsigned char  red_size;		 
	unsigned char  red_pos;			 
	unsigned char  green_size;		 
	unsigned char  green_pos;		 
	unsigned char  blue_size;		 
	unsigned char  blue_pos;		 
	unsigned char  rsvd_size;		 
	unsigned char  rsvd_pos;		 
	unsigned short vesapm_seg;		 
	unsigned short vesapm_off;		 
	unsigned short pages;			 
						 
};

extern struct screen_info screen_info;
























 






 






struct tty_flip_buffer {
	struct tq_struct tqueue;
	struct semaphore pty_sem;
	char		*char_buf_ptr;
	unsigned char	*flag_buf_ptr;
	int		count;
	int		buf_num;
	unsigned char	char_buf[2* 512 ];
	char		flag_buf[2* 512 ];
	unsigned char	slop[4];  
};
 




 

























































































 













struct tty_struct {
	int	magic;
	struct tty_driver driver;
	struct tty_ldisc ldisc;
	struct termios *termios, *termios_locked;
	int pgrp;
	int session;
	kdev_t	device;
	unsigned long flags;
	int count;
	struct winsize winsize;
	unsigned char stopped:1, hw_stopped:1, flow_stopped:1, packet:1;
	unsigned char low_latency:1, warned:1;
	unsigned char ctrl_status;

	struct tty_struct *link;
	struct fasync_struct *fasync;
	struct tty_flip_buffer flip;
	int max_flip_cnt;
	int alt_speed;		 
	struct wait_queue *write_wait;
	struct wait_queue *read_wait;
	struct tq_struct tq_hangup;
	void *disc_data;
	void *driver_data;


	
	 



	unsigned int column;
	unsigned char lnext:1, erasing:1, raw:1, real_raw:1, icanon:1;
	unsigned char closing:1;
	unsigned short minimum_to_wake;
	unsigned overrun_time;
	int num_overrun;
	unsigned long process_char_map[256/(8*sizeof(unsigned long))];
	char *read_buf;
	int read_head;
	int read_tail;
	int read_cnt;
	unsigned long read_flags[4096 /(8*sizeof(unsigned long))];
	int canon_data;
	unsigned long canon_head;
	unsigned int canon_column;
	struct semaphore atomic_read;
};

 


 






















extern void tty_write_flush(struct tty_struct *);

extern struct termios tty_std_termios;
extern struct tty_struct * redirect;
extern struct tty_ldisc ldiscs[];
extern int fg_console, last_console, want_console;

extern int kmsg_redirect;

extern unsigned long con_init(unsigned long);

extern int rs_init(void);
extern int lp_init(void);
extern int pty_init(void);
extern int tty_init(void);
extern int pcxe_init(void);
extern int pc_init(void);
extern int vcs_init(void);
extern int rp_init(void);
extern int cy_init(void);
extern int stl_init(void);
extern int stli_init(void);
extern int riscom8_init(void);
extern int specialix_init(void);
extern int espserial_init(void);
extern int macserial_init(void);

extern int tty_paranoia_check(struct tty_struct *tty, kdev_t device,
			      const char *routine);
extern char *tty_name(struct tty_struct *tty, char *buf);
extern void tty_wait_until_sent(struct tty_struct * tty, long timeout);
extern int tty_check_change(struct tty_struct * tty);
extern void stop_tty(struct tty_struct * tty);
extern void start_tty(struct tty_struct * tty);
extern int tty_register_ldisc(int disc, struct tty_ldisc *new_ldisc);
extern int tty_register_driver(struct tty_driver *driver);
extern int tty_unregister_driver(struct tty_driver *driver);
extern int tty_read_raw_data(struct tty_struct *tty, unsigned char *bufp,
			     int buflen);
extern void tty_write_message(struct tty_struct *tty, char *msg);

extern int is_orphaned_pgrp(int pgrp);
extern int is_ignored(int sig);
extern int tty_signal(int sig, struct tty_struct *tty);
extern void tty_hangup(struct tty_struct * tty);
extern void tty_vhangup(struct tty_struct * tty);
extern void tty_unhangup(struct file *filp);
extern int tty_hung_up_p(struct file * filp);
extern void do_SAK(struct tty_struct *tty);
extern void disassociate_ctty(int priv);
extern void tty_flip_buffer_push(struct tty_struct *tty);
extern int tty_get_baud_rate(struct tty_struct *tty);

 
extern struct tty_ldisc tty_ldisc_N_TTY;

 
extern int n_tty_ioctl(struct tty_struct * tty, struct file * file,
		       unsigned int cmd, unsigned long arg);

 

extern long serial_console_init(long kmem_start, long kmem_end);
 
 

extern int pcxe_open(struct tty_struct *tty, struct file *filp);

 

extern void console_print(const char *);

 

extern int vt_ioctl(struct tty_struct *tty, struct file * file,
		    unsigned int cmd, unsigned long arg);



# 21 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/sem.h" 1



# 1 "/home/linas/src/linux/include/linux/ipc.h" 1







struct ipc_perm
{
	__kernel_key_t	key;
	__kernel_uid_t	uid;
	__kernel_gid_t	gid;
	__kernel_uid_t	cuid;
	__kernel_gid_t	cgid;
	__kernel_mode_t	mode; 
	unsigned short	seq;
};

 




 

   



 










 








# 4 "/home/linas/src/linux/include/linux/sem.h" 2


 


 








 



 
struct semid_ds {
	struct ipc_perm	sem_perm;		 
	__kernel_time_t	sem_otime;		 
	__kernel_time_t	sem_ctime;		 
	struct sem	*sem_base;		 
	struct sem_queue *sem_pending;		 
	struct sem_queue **sem_pending_last;	 
	struct sem_undo	*undo;			 
	unsigned short	sem_nsems;		 
};

 
struct sembuf {
	unsigned short  sem_num;	 
	short		sem_op;		 
	short		sem_flg;	 
};

 
union semun {
	int val;			 
	struct semid_ds *buf;		 
	unsigned short *array;		 
	struct seminfo *__buf;		 
	void *__pad;
};

struct  seminfo {
	int semmap;
	int semmni;
	int semmns;
	int semmnu;
	int semmsl;
	int semopm;
	int semume;
	int semusz;
	int semvmx;
	int semaem;
};







 








 
struct sem {
	int	semval;		 
	int	sempid;		 
};

 
struct sem_queue {
	struct sem_queue *	next;	  
	struct sem_queue **	prev;	  
	struct wait_queue *	sleeper;  
	struct sem_undo *	undo;	  
	int    			pid;	  
	int    			status;	  
	struct semid_ds *	sma;	  
	struct sembuf *		sops;	  
	int			nsops;	  
	int			alter;	  
};

 


struct sem_undo {
	struct sem_undo *	proc_next;	 
	struct sem_undo *	id_next;	 
	int			semid;		 
	short *			semadj;		 
};

   int sys_semget (key_t key, int nsems, int semflg);
   int sys_semop (int semid, struct sembuf *sops, unsigned nsops);
   int sys_semctl (int semid, int semnum, int cmd, union semun arg);




# 22 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/signal.h" 1



# 1 "/home/linas/src/linux/include/asm/signal.h" 1





 
struct siginfo;

 






typedef unsigned long old_sigset_t;		 

typedef struct {
	unsigned long sig[(64  / 32 ) ];
} sigset_t;
































 





 



 



























 









 















 
typedef void (*__sighandler_t)(int);





struct old_sigaction {
	__sighandler_t sa_handler;
	old_sigset_t sa_mask;
	unsigned long sa_flags;
	void (*sa_restorer)(void);
};

struct sigaction {
	__sighandler_t sa_handler;
	unsigned long sa_flags;
	void (*sa_restorer)(void);
	sigset_t sa_mask;		 
};

struct k_sigaction {
	struct sigaction sa;
};

typedef struct sigaltstack {
	void *ss_sp;
	int ss_flags;
	size_t ss_size;
} stack_t;


# 1 "/home/linas/src/linux/include/asm/sigcontext.h" 1






struct sigcontext_struct {
	unsigned long	_unused[4];
	int		signal;
	unsigned long	handler;
	unsigned long	oldmask;
	struct _i370_interrupt_state_s  	*regs;
};


# 149 "/home/linas/src/linux/include/asm/signal.h" 2





# 4 "/home/linas/src/linux/include/linux/signal.h" 2

# 1 "/home/linas/src/linux/include/asm/siginfo.h" 1



 



typedef union sigval {
	int sival_int;
	void *sival_ptr;
} sigval_t;




typedef struct siginfo {
	int si_signo;
	int si_errno;
	int si_code;

	union {
		int _pad[((128 /sizeof(int)) - 3) ];

		 
		struct {
			pid_t _pid;		 
			uid_t _uid;		 
		} _kill;

		 
		struct {
			unsigned int _timer1;
			unsigned int _timer2;
		} _timer;

		 
		struct {
			pid_t _pid;		 
			uid_t _uid;		 
			sigval_t _sigval;
		} _rt;

		 
		struct {
			pid_t _pid;		 
			uid_t _uid;		 
			int _status;		 
			clock_t _utime;
			clock_t _stime;
		} _sigchld;

		 
		struct {
			void *_addr;  
		} _sigfault;

		 
		struct {
			int _band;	 
			int _fd;
		} _sigpoll;
	} _sifields;
} siginfo_t;

 














 














 












 












 






 







 






 










 










 














typedef struct sigevent {
	sigval_t sigev_value;
	int sigev_signo;
	int sigev_notify;
	union {
		int _pad[((64 /sizeof(int)) - 3) ];

		struct {
			void (*_function)(sigval_t);
			void *_attribute;	 
		} _sigev_thread;
	} _sigev_un;
} sigevent_t;





# 5 "/home/linas/src/linux/include/linux/signal.h" 2



 



struct signal_queue
{
	struct signal_queue *next;
	siginfo_t info;
};

 






 

extern inline void sigaddset(sigset_t *set, int _sig)
{
	unsigned long sig = _sig - 1;
	if ((64  / 32 )  == 1)
		set->sig[0] |= 1UL << sig;
	else
		set->sig[sig / 32 ] |= 1UL << (sig % 32 );
}

extern inline void sigdelset(sigset_t *set, int _sig)
{
	unsigned long sig = _sig - 1;
	if ((64  / 32 )  == 1)
		set->sig[0] &= ~(1UL << sig);
	else
		set->sig[sig / 32 ] &= ~(1UL << (sig % 32 ));
}

extern inline int sigismember(sigset_t *set, int _sig)
{
	unsigned long sig = _sig - 1;
	if ((64  / 32 )  == 1)
		return 1 & (set->sig[0] >> sig);
	else
		return 1 & (set->sig[sig / 32 ] >> (sig % 32 ));
}

extern inline int sigfindinword(unsigned long word)
{
	return ffz(~word);
}






# 1 "/home/linas/src/linux/include/linux/string.h" 1













extern char * ___strtok;
extern char * strcpy(char *,const char *);
extern char * strncpy(char *,const char *, __kernel_size_t);
extern char * strcat(char *, const char *);
extern char * strncat(char *, const char *, __kernel_size_t);
extern char * strchr(const char *,int);
extern char * strrchr(const char *,int);
extern char * strpbrk(const char *,const char *);
extern char * strtok(char *,const char *);
extern char * strstr(const char *,const char *);
extern __kernel_size_t strlen(const char *);
extern __kernel_size_t strnlen(const char *,__kernel_size_t);
extern __kernel_size_t strspn(const char *,const char *);
extern int strcmp(const char *,const char *);
extern int strncmp(const char *,const char *,__kernel_size_t);
extern int strnicmp(const char *, const char *, __kernel_size_t);

extern void * memset(void *,int,__kernel_size_t);
extern void * memcpy(void *,const void *,__kernel_size_t);
extern void * memmove(void *,const void *,__kernel_size_t);
extern void * memscan(void *,int,__kernel_size_t);
extern int memcmp(const void *,const void *,__kernel_size_t);

 


# 1 "/home/linas/src/linux/include/asm/string.h" 1















extern int strcasecmp(const char *, const char *);
extern void *memchr (const void *,int, size_t);


# 40 "/home/linas/src/linux/include/linux/string.h" 2







# 64 "/home/linas/src/linux/include/linux/signal.h" 2



# 102 "/home/linas/src/linux/include/linux/signal.h"


extern inline void  sigorsets (sigset_t *r, const sigset_t *a, const sigset_t *b) {	unsigned long a0, a1, a2, a3, b0, b1, b2, b3;	unsigned long i;	for (i = 0; i < (64  / 32 ) /4; ++i) {	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1];	a2 = a->sig[4*i+2]; a3 = a->sig[4*i+3];	b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1];	b2 = b->sig[4*i+2]; b3 = b->sig[4*i+3];	r->sig[4*i+0] =   (( a0 ) | (  b0 )) ;	r->sig[4*i+1] =   (( a1 ) | (  b1 )) ;	r->sig[4*i+2] =   (( a2 ) | (  b2 )) ;	r->sig[4*i+3] =   (( a3 ) | (  b3 )) ;	}	switch ((64  / 32 )  % 4) {	case 3:	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1]; a2 = a->sig[4*i+2]; b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1]; b2 = b->sig[4*i+2]; r->sig[4*i+0] =   (( a0 ) | (  b0 )) ;	r->sig[4*i+1] =   (( a1 ) | (  b1 )) ;	r->sig[4*i+2] =   (( a2 ) | (  b2 )) ;	break;	case 2:	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1];	b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1];	r->sig[4*i+0] =   (( a0 ) | (  b0 )) ;	r->sig[4*i+1] =   (( a1 ) | (  b1 )) ;	break;	case 1:	a0 = a->sig[4*i+0]; b0 = b->sig[4*i+0];	r->sig[4*i+0] =   (( a0 ) | (  b0 )) ;	break;	}	} 


extern inline void  sigandsets (sigset_t *r, const sigset_t *a, const sigset_t *b) {	unsigned long a0, a1, a2, a3, b0, b1, b2, b3;	unsigned long i;	for (i = 0; i < (64  / 32 ) /4; ++i) {	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1];	a2 = a->sig[4*i+2]; a3 = a->sig[4*i+3];	b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1];	b2 = b->sig[4*i+2]; b3 = b->sig[4*i+3];	r->sig[4*i+0] =   (( a0 ) & (  b0 )) ;	r->sig[4*i+1] =   (( a1 ) & (  b1 )) ;	r->sig[4*i+2] =   (( a2 ) & (  b2 )) ;	r->sig[4*i+3] =   (( a3 ) & (  b3 )) ;	}	switch ((64  / 32 )  % 4) {	case 3:	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1]; a2 = a->sig[4*i+2]; b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1]; b2 = b->sig[4*i+2]; r->sig[4*i+0] =   (( a0 ) & (  b0 )) ;	r->sig[4*i+1] =   (( a1 ) & (  b1 )) ;	r->sig[4*i+2] =   (( a2 ) & (  b2 )) ;	break;	case 2:	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1];	b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1];	r->sig[4*i+0] =   (( a0 ) & (  b0 )) ;	r->sig[4*i+1] =   (( a1 ) & (  b1 )) ;	break;	case 1:	a0 = a->sig[4*i+0]; b0 = b->sig[4*i+0];	r->sig[4*i+0] =   (( a0 ) & (  b0 )) ;	break;	}	} 


extern inline void  signandsets (sigset_t *r, const sigset_t *a, const sigset_t *b) {	unsigned long a0, a1, a2, a3, b0, b1, b2, b3;	unsigned long i;	for (i = 0; i < (64  / 32 ) /4; ++i) {	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1];	a2 = a->sig[4*i+2]; a3 = a->sig[4*i+3];	b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1];	b2 = b->sig[4*i+2]; b3 = b->sig[4*i+3];	r->sig[4*i+0] =   (( a0 ) & ~(  b0 )) ;	r->sig[4*i+1] =   (( a1 ) & ~(  b1 )) ;	r->sig[4*i+2] =   (( a2 ) & ~(  b2 )) ;	r->sig[4*i+3] =   (( a3 ) & ~(  b3 )) ;	}	switch ((64  / 32 )  % 4) {	case 3:	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1]; a2 = a->sig[4*i+2]; b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1]; b2 = b->sig[4*i+2]; r->sig[4*i+0] =   (( a0 ) & ~(  b0 )) ;	r->sig[4*i+1] =   (( a1 ) & ~(  b1 )) ;	r->sig[4*i+2] =   (( a2 ) & ~(  b2 )) ;	break;	case 2:	a0 = a->sig[4*i+0]; a1 = a->sig[4*i+1];	b0 = b->sig[4*i+0]; b1 = b->sig[4*i+1];	r->sig[4*i+0] =   (( a0 ) & ~(  b0 )) ;	r->sig[4*i+1] =   (( a1 ) & ~(  b1 )) ;	break;	case 1:	a0 = a->sig[4*i+0]; b0 = b->sig[4*i+0];	r->sig[4*i+0] =   (( a0 ) & ~(  b0 )) ;	break;	}	} 







# 134 "/home/linas/src/linux/include/linux/signal.h"


extern inline void  signotset (sigset_t *set)	{	unsigned long i;	for (i = 0; i < (64  / 32 ) /4; ++i) {	set->sig[4*i+0] =   (~( set->sig[4*i+0] )) ;	set->sig[4*i+1] =   (~( set->sig[4*i+1] )) ;	set->sig[4*i+2] =   (~( set->sig[4*i+2] )) ;	set->sig[4*i+3] =   (~( set->sig[4*i+3] )) ;	}	switch ((64  / 32 )  % 4) {	case 3: set->sig[4*i+2] =   (~( set->sig[4*i+2] )) ;	case 2: set->sig[4*i+1] =   (~( set->sig[4*i+1] )) ;	case 1: set->sig[4*i+0] =   (~( set->sig[4*i+0] )) ;	}	} 




extern inline void sigemptyset(sigset_t *set)
{
	switch ((64  / 32 ) ) {
	default:
		memset(set, 0, sizeof(sigset_t));
		break;
	case 2: set->sig[1] = 0;
	case 1:	set->sig[0] = 0;
		break;
	}
}

extern inline void sigfillset(sigset_t *set)
{
	switch ((64  / 32 ) ) {
	default:
		memset(set, -1, sizeof(sigset_t));
		break;
	case 2: set->sig[1] = -1;
	case 1:	set->sig[0] = -1;
		break;
	}
}

extern char * render_sigset_t(sigset_t *set, char *buffer);

 

extern inline void sigaddsetmask(sigset_t *set, unsigned long mask)
{
	set->sig[0] |= mask;
}

extern inline void sigdelsetmask(sigset_t *set, unsigned long mask)
{
	set->sig[0] &= ~mask;
}

extern inline int sigtestsetmask(sigset_t *set, unsigned long mask)
{
	return (set->sig[0] & mask) != 0;
}

extern inline void siginitset(sigset_t *set, unsigned long mask)
{
	set->sig[0] = mask;
	switch ((64  / 32 ) ) {
	default:
		memset(&set->sig[1], 0, sizeof(long)*((64  / 32 ) -1));
		break;
	case 2: set->sig[1] = 0;
	case 1:
	}
}

extern inline void siginitsetinv(sigset_t *set, unsigned long mask)
{
	set->sig[0] = ~mask;
	switch ((64  / 32 ) ) {
	default:
		memset(&set->sig[1], -1, sizeof(long)*((64  / 32 ) -1));
		break;
	case 2: set->sig[1] = -1;
	case 1:
	}
}






# 23 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/securebits.h" 1





extern unsigned securebits;

 







 




 









# 24 "/home/linas/src/linux/include/linux/sched.h" 2


 











 









extern unsigned long avenrun[];		 
















extern int nr_running, nr_tasks;
extern int last_pid;



# 1 "/home/linas/src/linux/include/linux/param.h" 1






# 70 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/resource.h" 1





 



 










struct	rusage {
	struct timeval ru_utime;	 
	struct timeval ru_stime;	 
	long	ru_maxrss;		 
	long	ru_ixrss;		 
	long	ru_idrss;		 
	long	ru_isrss;		 
	long	ru_minflt;		 
	long	ru_majflt;		 
	long	ru_nswap;		 
	long	ru_inblock;		 
	long	ru_oublock;		 
	long	ru_msgsnd;		 
	long	ru_msgrcv;		 
	long	ru_nsignals;		 
	long	ru_nvcsw;		 
	long	ru_nivcsw;		 
};



struct rlimit {
	long	rlim_cur;
	long	rlim_max;
};








 



# 1 "/home/linas/src/linux/include/asm/resource.h" 1



















# 32 "/home/linas/src/linux/include/asm/resource.h"




# 58 "/home/linas/src/linux/include/linux/resource.h" 2



# 71 "/home/linas/src/linux/include/linux/sched.h" 2

# 1 "/home/linas/src/linux/include/linux/timer.h" 1



 






















struct timer_struct {
	unsigned long expires;
	void (*fn)(void);
};

extern unsigned long timer_active;
extern struct timer_struct timer_table[32];

 












struct timer_list {
	struct timer_list *next;  
	struct timer_list *prev;
	unsigned long expires;
	unsigned long data;
	void (*function)(unsigned long);
};

extern void add_timer(struct timer_list * timer);
extern int  del_timer(struct timer_list * timer);

 




void mod_timer(struct timer_list *timer, unsigned long expires);

extern void it_real_fn(unsigned long);

extern inline void init_timer(struct timer_list * timer)
{
	timer->next = ((void *) 0) ;
	timer->prev = ((void *) 0) ;
}

extern inline int timer_pending(struct timer_list * timer)
{
	return timer->prev != ((void *) 0) ;
}

 

















# 72 "/home/linas/src/linux/include/linux/sched.h" 2











 






 





struct sched_param {
	int sched_priority;
};









 





extern rwlock_t tasklist_lock;
extern spinlock_t scheduler_lock;

extern void sched_init(void);
extern void show_state(void);
extern void trap_init(void);


extern signed long  schedule_timeout(signed long timeout)  ;
   void schedule(void);

 


struct files_struct {
	atomic_t count;
	int max_fds;
	struct file ** fd;	 
	fd_set close_on_exec;
	fd_set open_fds;
};









struct fs_struct {
	atomic_t count;
	int umask;
	struct dentry * root, * pwd;
};







 


 


struct mm_struct {
	struct vm_area_struct *mmap;		 
	struct vm_area_struct *mmap_avl;	 
	struct vm_area_struct *mmap_cache;	 
	pgd_t * pgd;
	atomic_t count;
	int map_count;				 
	struct semaphore mmap_sem;
	unsigned long context;
	unsigned long start_code, end_code, start_data, end_data;
	unsigned long start_brk, brk, start_stack;
	unsigned long arg_start, arg_end, env_start, env_end;
	unsigned long rss, total_vm, locked_vm;
	unsigned long def_flags;
	unsigned long cpu_vm_mask;
	 



	void * segments;
};


# 195 "/home/linas/src/linux/include/linux/sched.h"

struct signal_struct {
	atomic_t		count;
	struct k_sigaction	action[64 ];
	spinlock_t		siglock;
};







 




struct user_struct;

struct task_struct {
 
	volatile long state;	 
	unsigned long flags;	 
	int sigpending;
	mm_segment_t addr_limit;	 



	struct exec_domain *exec_domain;
	long need_resched;

 
	long counter;
	long priority;
	cycles_t avg_slice;
 
	int has_cpu;
	int processor;
	int last_processor;
	int lock_depth;		 	
	struct task_struct *next_task, *prev_task;
	struct task_struct *next_run,  *prev_run;

 
	struct linux_binfmt *binfmt;
	int exit_code, exit_signal;
	int pdeath_signal;   
	 
	unsigned long personality;
	int dumpable:1;
	int did_exec:1;
	pid_t pid;
	pid_t pgrp;
	pid_t tty_old_pgrp;
	pid_t session;
	 
	int leader;
	 




	struct task_struct *p_opptr, *p_pptr, *p_cptr, *p_ysptr, *p_osptr;

	 
	struct task_struct *pidhash_next;
	struct task_struct **pidhash_pprev;

	 
	struct task_struct **tarray_ptr;

	struct wait_queue *wait_chldexit;	 
	struct semaphore *vfork_sem;		 
	unsigned long policy, rt_priority;
	unsigned long it_real_value, it_prof_value, it_virt_value;
	unsigned long it_real_incr, it_prof_incr, it_virt_incr;
	struct timer_list real_timer;
	struct tms times;
	unsigned long start_time;
	long per_cpu_utime[1 ], per_cpu_stime[1 ];
 
	unsigned long min_flt, maj_flt, nswap, cmin_flt, cmaj_flt, cnswap;
	int swappable:1;
	unsigned long swap_address;
	unsigned long swap_cnt;		 
 
	uid_t uid,euid,suid,fsuid;
	gid_t gid,egid,sgid,fsgid;
	int ngroups;
	gid_t	groups[32 ];
        kernel_cap_t   cap_effective, cap_inheritable, cap_permitted;
	struct user_struct *user;
 
	struct rlimit rlim[10 ];
	unsigned short used_math;
	char comm[16];
 
	int link_count;
	struct tty_struct *tty;  
 
	struct sem_undo *semundo;
	struct sem_queue *semsleeping;
 
	struct thread_struct tss;
 
	struct fs_struct *fs;
 
	struct files_struct *files;
 
	struct mm_struct *mm;

 
	spinlock_t sigmask_lock;	 
	struct signal_struct *sig;
	sigset_t signal, blocked;
	struct signal_queue *sigqueue, **sigqueue_tail;
	unsigned long sas_ss_sp;
	size_t sas_ss_size;
};

 



					 














 







 




# 381 "/home/linas/src/linux/include/linux/sched.h"

union task_union {
	struct task_struct task;
	unsigned long stack[2048];
};

extern union task_union init_task_union;

extern struct   mm_struct init_mm;
extern struct task_struct *task[512 ];

extern struct task_struct **tarray_freelist;
extern spinlock_t taskslot_lock;

extern __inline__ void add_free_taskslot(struct task_struct **t)
{
	do { } while(0) ;
	*t = (struct task_struct *) tarray_freelist;
	tarray_freelist = t;
	do { } while(0) ;
}

extern __inline__ struct task_struct **get_free_taskslot(void)
{
	struct task_struct **tslot;

	do { } while(0) ;
	if((tslot = tarray_freelist) != ((void *) 0) )
		tarray_freelist = (struct task_struct **) *tslot;
	do { } while(0) ;

	return tslot;
}

 

extern struct task_struct *pidhash[(512  >> 2) ];



extern __inline__ void hash_pid(struct task_struct *p)
{
	struct task_struct **htable = &pidhash[(((( p->pid ) >> 8) ^ ( p->pid )) & ((512  >> 2)  - 1)) ];

	if((p->pidhash_next = *htable) != ((void *) 0) )
		(*htable)->pidhash_pprev = &p->pidhash_next;
	*htable = p;
	p->pidhash_pprev = htable;
}

extern __inline__ void unhash_pid(struct task_struct *p)
{
	if(p->pidhash_next)
		p->pidhash_next->pidhash_pprev = p->pidhash_pprev;
	*p->pidhash_pprev = p->pidhash_next;
}

extern __inline__ struct task_struct *find_task_by_pid(int pid)
{
	struct task_struct *p, **htable = &pidhash[(((( pid ) >> 8) ^ ( pid )) & ((512  >> 2)  - 1)) ];

	for(p = *htable; p && p->pid != pid; p = p->pidhash_next)
		;

	return p;
}

 
extern int alloc_uid(struct task_struct *p);
void free_uid(struct task_struct *p);

# 1 "/home/linas/src/linux/include/asm/current.h" 1



 



extern struct task_struct *current;


# 452 "/home/linas/src/linux/include/linux/sched.h" 2


extern unsigned long volatile jiffies;
extern unsigned long itimer_ticks;
extern unsigned long itimer_next;
extern struct timeval xtime;
extern void do_timer(struct _i370_interrupt_state_s  *);

extern unsigned int * prof_buffer;
extern unsigned long prof_len;
extern unsigned long prof_shift;



extern void  __wake_up(struct wait_queue ** p, unsigned int mode)  ;
extern void  sleep_on(struct wait_queue ** p)  ;
extern long  sleep_on_timeout(struct wait_queue ** p,
				      signed long timeout)  ;
extern void  interruptible_sleep_on(struct wait_queue ** p)  ;
extern long  interruptible_sleep_on_timeout(struct wait_queue ** p,
						    signed long timeout)  ;
extern void  wake_up_process(struct task_struct * tsk)  ;




extern int in_group_p(gid_t grp);

extern void flush_signals(struct task_struct *);
extern void flush_signal_handlers(struct task_struct *);
extern int dequeue_signal(sigset_t *block, siginfo_t *);
extern int send_sig_info(int, struct siginfo *info, struct task_struct *);
extern int force_sig_info(int, struct siginfo *info, struct task_struct *);
extern int kill_pg_info(int, struct siginfo *info, pid_t);
extern int kill_sl_info(int, struct siginfo *info, pid_t);
extern int kill_proc_info(int, struct siginfo *info, pid_t);
extern int kill_something_info(int, struct siginfo *info, int);
extern void notify_parent(struct task_struct * tsk, int);
extern void force_sig(int sig, struct task_struct * p);
extern int send_sig(int sig, struct task_struct * p, int priv);
extern int kill_pg(pid_t, int, int);
extern int kill_sl(pid_t, int, int);
extern int kill_proc(pid_t, int, int);
extern int do_sigaction(int sig, const struct k_sigaction *act,
			struct k_sigaction *oact);
extern int do_sigaltstack(const stack_t *ss, stack_t *oss, unsigned long sp);

extern inline int signal_pending(struct task_struct *p)
{
	return (p->sigpending != 0);
}

 



static inline void recalc_sigpending(struct task_struct *t)
{
	unsigned long ready;
	long i;

	switch ((64  / 32 ) ) {
	default:
		for (i = (64  / 32 ) , ready = 0; --i >= 0 ;)
			ready |= t->signal.sig[i] &~ t->blocked.sig[i];
		break;

	case 4: ready  = t->signal.sig[3] &~ t->blocked.sig[3];
		ready |= t->signal.sig[2] &~ t->blocked.sig[2];
		ready |= t->signal.sig[1] &~ t->blocked.sig[1];
		ready |= t->signal.sig[0] &~ t->blocked.sig[0];
		break;

	case 2: ready  = t->signal.sig[1] &~ t->blocked.sig[1];
		ready |= t->signal.sig[0] &~ t->blocked.sig[0];
		break;

	case 1: ready  = t->signal.sig[0] &~ t->blocked.sig[0];
	}

	t->sigpending = (ready != 0);
}

 

static inline int on_sig_stack(unsigned long sp)
{
	return (sp >= current->sas_ss_sp
		&& sp < current->sas_ss_sp + current->sas_ss_size);
}

static inline int sas_ss_flags(unsigned long sp)
{
	return (current->sas_ss_size == 0 ? 2 
		: on_sig_stack(sp) ? 1  : 0);
}

extern int request_irq(unsigned int irq,
		       void (*handler)(int, void *, struct _i370_interrupt_state_s  *),
		       unsigned long flags, 
		       const char *device,
		       void *dev_id);
extern void free_irq(unsigned int irq, void *dev_id);

 













extern inline int suser(void)
{
	if (! ( (1 << ( 0  +1)) & 0x00000000  ? (1 << ( 0  )) & 0x00000000  :	(1 << ( 0  )) & securebits )  && current->euid == 0) { 
		current->flags |= 0x00000100 ;
		return 1;
	}
	return 0;
}

extern inline int fsuser(void)
{
	if (! ( (1 << ( 0  +1)) & 0x00000000  ? (1 << ( 0  )) & 0x00000000  :	(1 << ( 0  )) & securebits )  && current->fsuid == 0) {
		current->flags |= 0x00000100 ;
		return 1;
	}
	return 0;
}

 





extern inline int capable(int cap)
{

	if (((  current->cap_effective  )  &   (1 << (   cap  )) ) )



        {
		current->flags |= 0x00000100 ;
		return 1;
	}
	return 0;
}

 


extern struct mm_struct * mm_alloc(void);
static inline void mmget(struct mm_struct * mm)
{
	atomic_inc(&mm->count);
}
extern void mmput(struct mm_struct *);
 
extern void mm_release(void);

extern int  copy_thread(int, unsigned long, unsigned long, struct task_struct *, struct _i370_interrupt_state_s  *);
extern void flush_thread(void);
extern void exit_thread(void);

extern void exit_mm(struct task_struct *);
extern void exit_fs(struct task_struct *);
extern void exit_files(struct task_struct *);
extern void exit_sighand(struct task_struct *);

extern int do_execve(char *, char **, char **, struct _i370_interrupt_state_s  *);
extern int do_fork(unsigned long, unsigned long, struct _i370_interrupt_state_s  *);

 




extern inline void __add_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	wait->next = *p ? : ((struct wait_queue *)(( p )-1)) ;
	*p = wait;
}

extern rwlock_t waitqueue_lock;

extern inline void add_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	unsigned long flags;

	do {   flags  = __cli() ; } while (0) ;
	__add_wait_queue(p, wait);
	__restore_flags(   flags  )  ;
}

extern inline void __remove_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	struct wait_queue * next = wait->next;
	struct wait_queue * head = next;
	struct wait_queue * tmp;

	while ((tmp = head->next) != wait) {
		head = tmp;
	}
	head->next = next;
}

extern inline void remove_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	unsigned long flags;

	do {   flags  = __cli() ; } while (0) ;
	__remove_wait_queue(p, wait);
	__restore_flags(   flags  )  ; 
}


# 685 "/home/linas/src/linux/include/linux/sched.h"


# 696 "/home/linas/src/linux/include/linux/sched.h"







# 16 "fs/binfmt_elf.c" 2

# 1 "/home/linas/src/linux/include/linux/mm.h" 1










extern unsigned long max_mapnr;
extern unsigned long num_physpages;
extern void * high_memory;
extern int page_cluster;

# 1 "/home/linas/src/linux/include/asm/page.h" 1


# 94 "/home/linas/src/linux/include/asm/page.h"

# 16 "/home/linas/src/linux/include/linux/mm.h" 2



 








 





struct vm_area_struct {
	struct mm_struct * vm_mm;	 
	unsigned long vm_start;
	unsigned long vm_end;

	 
	struct vm_area_struct *vm_next;

	pgprot_t vm_page_prot;
	unsigned short vm_flags;

	 
	short vm_avl_height;
	struct vm_area_struct * vm_avl_left;
	struct vm_area_struct * vm_avl_right;

	 


	struct vm_area_struct *vm_next_share;
	struct vm_area_struct **vm_pprev_share;

	struct vm_operations_struct * vm_ops;
	unsigned long vm_offset;
	struct file * vm_file;
	unsigned long vm_pte;			 
};

 























 



extern pgprot_t protection_map[16];


 




struct vm_operations_struct {
	void (*open)(struct vm_area_struct * area);
	void (*close)(struct vm_area_struct * area);
	void (*unmap)(struct vm_area_struct *area, unsigned long, size_t);
	void (*protect)(struct vm_area_struct *area, unsigned long, size_t, unsigned int newprot);
	int (*sync)(struct vm_area_struct *area, unsigned long, size_t, unsigned int flags);
	void (*advise)(struct vm_area_struct *area, unsigned long, size_t, unsigned int advise);
	unsigned long (*nopage)(struct vm_area_struct * area, unsigned long address, int write_access);
	unsigned long (*wppage)(struct vm_area_struct * area, unsigned long address,
		unsigned long page);
	int (*swapout)(struct vm_area_struct *, struct page *);
	pte_t (*swapin)(struct vm_area_struct *, unsigned long, unsigned long);
};

 







typedef struct page {
	 
	struct page *next;
	struct page *prev;
	struct inode *inode;
	unsigned long offset;
	struct page *next_hash;
	atomic_t count;
	unsigned long flags;	 
	struct wait_queue *wait;
	struct page **pprev_hash;
	struct buffer_head * buffers;
} mem_map_t;

 














 





























 
































































extern mem_map_t * mem_map;

 






extern unsigned long  __get_free_pages(int gfp_mask, unsigned long gfp_order)  ;

extern inline unsigned long get_free_page(int gfp_mask)
{
	unsigned long page;

	page = __get_free_pages(( gfp_mask ),0) ;
	if (page)
		memset((void *)( page ), 0, (1UL << 12 ) ) ;
	return page;
}

extern int low_on_memory;

 


extern void  free_pages(unsigned long addr, unsigned long order)  ;
extern void  __free_page(struct page *)  ;

extern void show_free_areas(void);
extern unsigned long put_dirty_page(struct task_struct * tsk,unsigned long page,
	unsigned long address);

extern void free_page_tables(struct mm_struct * mm);
extern void clear_page_tables(struct mm_struct *, unsigned long, int);
extern int new_page_tables(struct task_struct * tsk);

extern void zap_page_range(struct mm_struct *mm, unsigned long address, unsigned long size);
extern int copy_page_range(struct mm_struct *dst, struct mm_struct *src, struct vm_area_struct *vma);
extern int remap_page_range(unsigned long from, unsigned long to, unsigned long size, pgprot_t prot);
extern int zeromap_page_range(unsigned long from, unsigned long size, pgprot_t prot);

extern void vmtruncate(struct inode * inode, unsigned long offset);
extern int handle_mm_fault(struct task_struct *tsk,struct vm_area_struct *vma, unsigned long address, int write_access);
extern void make_pages_present(unsigned long addr, unsigned long end);

extern int pgt_cache_water[2];
extern int check_pgt_cache(void);

extern unsigned long paging_init(unsigned long start_mem, unsigned long end_mem);
extern void mem_init(unsigned long start_mem, unsigned long end_mem);
extern void show_mem(void);
extern void oom(struct task_struct * tsk);
extern void si_meminfo(struct sysinfo * val);

 
extern void vma_init(void);
extern void merge_segments(struct mm_struct *, unsigned long, unsigned long);
extern void insert_vm_struct(struct mm_struct *, struct vm_area_struct *);
extern void build_mmap_avl(struct mm_struct *);
extern void exit_mmap(struct mm_struct *);
extern unsigned long get_unmapped_area(unsigned long, unsigned long);

extern unsigned long do_mmap(struct file *, unsigned long, unsigned long,
	unsigned long, unsigned long, unsigned long);
extern int do_munmap(unsigned long, size_t);

 
extern void remove_inode_page(struct page *);
extern unsigned long page_unuse(struct page *);
extern int shrink_mmap(int, int);
extern void truncate_inode_pages(struct inode *, unsigned long);
extern unsigned long get_cached_page(struct inode *, unsigned long, int);
extern void put_cached_page(unsigned long);

 


















 




 


extern int free_memory_available(void);
			
 

static inline int expand_stack(struct vm_area_struct * vma, unsigned long address)
{
	unsigned long grow;

	address &= (~((1UL << 12 ) -1)) ;
	grow = vma->vm_start - address;
	if (vma->vm_end - address
	    > (unsigned long) current->rlim[3 ].rlim_cur ||
	    (vma->vm_mm->total_vm << 12 ) + grow
	    > (unsigned long) current->rlim[9 ].rlim_cur)
		return - 12 ;
	vma->vm_start = address;
	vma->vm_offset -= grow;
	vma->vm_mm->total_vm += grow >> 12 ;
	if (vma->vm_flags & 0x2000 )
		vma->vm_mm->locked_vm += grow >> 12 ;
	return 0;
}

 
extern struct vm_area_struct * find_vma(struct mm_struct * mm, unsigned long addr);

 

static inline struct vm_area_struct * find_vma_intersection(struct mm_struct * mm, unsigned long start_addr, unsigned long end_addr)
{
	struct vm_area_struct * vma = find_vma(mm,start_addr);

	if (vma && end_addr <= vma->vm_start)
		vma = ((void *) 0) ;
	return vma;
}









# 17 "fs/binfmt_elf.c" 2

# 1 "/home/linas/src/linux/include/linux/mman.h" 1



# 1 "/home/linas/src/linux/include/asm/mman.h" 1



























 




# 4 "/home/linas/src/linux/include/linux/mman.h" 2





# 18 "fs/binfmt_elf.c" 2






# 1 "/home/linas/src/linux/include/linux/file.h" 1
 






extern void __fput(struct file *);

 



extern inline struct file * fcheck_task(struct task_struct *p, unsigned int fd)
{
	struct file * file = ((void *) 0) ;

	if (p->files && fd < p->files->max_fds)
		file = p->files->fd[fd];
	return file;
}

 


extern inline struct file * fcheck(unsigned int fd)
{
	struct file * file = ((void *) 0) ;

	if (fd < current->files->max_fds)
		file = current->files->fd[fd];
	return file;
}

extern inline struct file * fget(unsigned int fd)
{
	struct file * file = fcheck(fd);

	if (file)
		file->f_count++;
	return file;
}

 


extern inline void fd_install(unsigned int fd, struct file *file)
{
	current->files->fd[fd] = file;
}

 















extern void fput(struct file *file); 
extern void put_filp(struct file *file);


# 24 "fs/binfmt_elf.c" 2



# 1 "/home/linas/src/linux/include/linux/malloc.h" 1



# 1 "/home/linas/src/linux/include/linux/slab.h" 1
 










typedef struct kmem_cache_s kmem_cache_t;




 










 













 




 
extern long kmem_cache_init(long, long);
extern void kmem_cache_sizes_init(void);
extern kmem_cache_t *kmem_find_general_cachep(size_t);
extern kmem_cache_t *kmem_cache_create(const char *, size_t, size_t, unsigned long,
				       void (*)(void *, kmem_cache_t *, unsigned long),
				       void (*)(void *, kmem_cache_t *, unsigned long));
extern int kmem_cache_shrink(kmem_cache_t *);
extern void *kmem_cache_alloc(kmem_cache_t *, int);
extern void kmem_cache_free(kmem_cache_t *, void *);

extern void *kmalloc(size_t, int);
extern void kfree(const void *);
extern void kfree_s(const void *, size_t);

extern void kmem_cache_reap(int);
extern int get_slabinfo(char *);

 
extern kmem_cache_t	*vm_area_cachep;
extern kmem_cache_t	*mm_cachep;




# 4 "/home/linas/src/linux/include/linux/malloc.h" 2


# 27 "fs/binfmt_elf.c" 2

# 1 "/home/linas/src/linux/include/linux/shm.h" 1





# 1 "/home/linas/src/linux/include/asm/shmparam.h" 1



 



 











 










 













# 6 "/home/linas/src/linux/include/linux/shm.h" 2


struct shmid_ds {
	struct ipc_perm		shm_perm;	 
	int			shm_segsz;	 
	__kernel_time_t		shm_atime;	 
	__kernel_time_t		shm_dtime;	 
	__kernel_time_t		shm_ctime;	 
	__kernel_ipc_pid_t	shm_cpid;	 
	__kernel_ipc_pid_t	shm_lpid;	 
	unsigned short		shm_nattch;	 
	unsigned short 		shm_unused;	 
	void 			*shm_unused2;	 
	void			*shm_unused3;	 
};

struct shmid_kernel
{	
	struct shmid_ds		u;
	 
	unsigned long		shm_npages;	 
	unsigned long		*shm_pages;	  
	struct vm_area_struct	*attaches;	 
};

 



 




 



 



struct	shminfo {
	int shmmax;
	int shmmin;
	int shmmni;
	int shmseg;
	int shmall;
};

struct shm_info {
	int used_ids;
	unsigned long shm_tot;	 
	unsigned long shm_rss;	 
	unsigned long shm_swp;	 
	unsigned long swap_attempts;
	unsigned long swap_successes;
};



 



   int sys_shmget (key_t key, int size, int flag);
   int sys_shmat (int shmid, char *shmaddr, int shmflg, unsigned long *addr);
   int sys_shmdt (char *shmaddr);
   int sys_shmctl (int shmid, int cmd, struct shmid_ds *buf);
extern void shm_unuse(unsigned long entry, unsigned long page);




# 28 "fs/binfmt_elf.c" 2


# 1 "/home/linas/src/linux/include/linux/elfcore.h" 1







# 1 "/home/linas/src/linux/include/linux/user.h" 1
# 1 "/home/linas/src/linux/include/asm/user.h" 1



 


# 1 "/home/linas/src/linux/include/asm/page.h" 1


# 94 "/home/linas/src/linux/include/asm/page.h"

# 7 "/home/linas/src/linux/include/asm/user.h" 2


 






















struct user {
	struct _i370_interrupt_state_s 	regs;			 
	size_t		u_tsize;		 
	size_t		u_dsize;		 
	size_t		u_ssize;		 
	unsigned long	start_code;		 
	unsigned long	start_data;		 
	unsigned long	start_stack;		 
	long int	signal;			 
	struct regs *	u_ar0;			 
	unsigned long	magic;			 
	char		u_comm[32];		 
};








# 1 "/home/linas/src/linux/include/linux/user.h" 2

# 8 "/home/linas/src/linux/include/linux/elfcore.h" 2


struct elf_siginfo
{
	int	si_signo;			 
	int	si_code;			 
	int	si_errno;			 
};

# 1 "/home/linas/src/linux/include/asm/elf.h" 1



 





 







 




 









 






typedef unsigned long elf_greg_t;
typedef elf_greg_t elf_gregset_t[16 ];

typedef double elf_fpreg_t;
typedef elf_fpreg_t elf_fpregset_t[16 ];







 





 














# 17 "/home/linas/src/linux/include/linux/elfcore.h" 2









 








struct elf_prstatus
{





	struct elf_siginfo pr_info;	 
	short	pr_cursig;		 
	unsigned long pr_sigpend;	 
	unsigned long pr_sighold;	 




	pid_t	pr_pid;
	pid_t	pr_ppid;
	pid_t	pr_pgrp;
	pid_t	pr_sid;
	struct timeval pr_utime;	 
	struct timeval pr_stime;	 
	struct timeval pr_cutime;	 
	struct timeval pr_cstime;	 



	elf_gregset_t pr_reg;	 
	int pr_fpvalid;		 
};



struct elf_prpsinfo
{
	char	pr_state;	 
	char	pr_sname;	 
	char	pr_zomb;	 
	char	pr_nice;	 
	unsigned long pr_flag;	 
	uid_t	pr_uid;
	gid_t	pr_gid;
	pid_t	pr_pid, pr_ppid, pr_pgrp, pr_sid;
	 
	char	pr_fname[16];	 
	char	pr_psargs[(80) ];	 
};








# 30 "fs/binfmt_elf.c" 2

# 1 "/home/linas/src/linux/include/linux/init.h" 1



 







































 






# 1 "/home/linas/src/linux/include/asm/init.h" 1

















# 30 "/home/linas/src/linux/include/asm/init.h"


# 51 "/home/linas/src/linux/include/linux/init.h" 2

# 60 "/home/linas/src/linux/include/linux/init.h"









# 31 "fs/binfmt_elf.c" 2


# 1 "/home/linas/src/linux/include/asm/uaccess.h" 1



 
 









 
















 











extern inline int verify_area(int type, const void * addr, unsigned long size)
{
	return ( (!(( ( ( size ) ) ) & 0x80000000)) && (!((((unsigned long) ( (unsigned long)( addr ) ) )+ ( ( size ) ) ) & 0x80000000)))    ? 0 : - 14 ;
}


 












struct exception_table_entry
{
	unsigned long insn, fixup;
};

 
extern unsigned long search_exception_table(unsigned long);


 



























 


















extern long __put_user_bad(void);

















extern	void put_user_data(long data, void *addr, long len);


# 149 "/home/linas/src/linux/include/asm/uaccess.h"

struct __large_struct { unsigned long buf[100]; };


 
















# 178 "/home/linas/src/linux/include/asm/uaccess.h"

extern long __get_user_bad(void);


# 191 "/home/linas/src/linux/include/asm/uaccess.h"

 






 

extern int __copy_to_user(void *to, const void *from, unsigned long size);
extern int __copy_from_user(void *to, const void *from, unsigned long size);

extern inline unsigned long
copy_from_user(void *to, const void *from, unsigned long n)
{
	if (( (!(( ( (  n ) ) ) & 0x80000000)) && (!((((unsigned long) ( (unsigned long)(  from ) ) )+ ( (  n ) ) ) & 0x80000000)))   )
		return __copy_from_user(to, from, n);
	return n;
}

extern inline unsigned long
copy_to_user(void *to, const void *from, unsigned long n)
{
	if (( (!(( ( (  n ) ) ) & 0x80000000)) && (!((((unsigned long) ( (unsigned long)(  to ) ) )+ ( (  n ) ) ) & 0x80000000)))   )
		return __copy_to_user(to, from, n);
	return n;
}

extern unsigned long
__clear_user(void *addr, unsigned long size);

extern inline unsigned long
clear_user(void *addr, unsigned long size)
{
	if (( (!(( ( (  size ) ) ) & 0x80000000)) && (!((((unsigned long) ( (unsigned long)(  addr ) ) )+ ( (  size ) ) ) & 0x80000000)))   )
		return __clear_user(addr, size);
	return size? - 14 : 0;
}

extern int __strncpy_from_user(char *dst, const char *src, long count);

extern inline long
strncpy_from_user(char *dst, const char *src, long count)
{
	if (( (!(( ( (  1 ) ) ) & 0x80000000)) && (!((((unsigned long) ( (unsigned long)(  src ) ) )+ ( (  1 ) ) ) & 0x80000000)))   )
		return __strncpy_from_user(dst, src, count);
	return - 14 ;
}

 





extern long strlen_user(const char *);




# 33 "fs/binfmt_elf.c" 2

# 1 "/home/linas/src/linux/include/asm/pgtable.h" 1

 










# 1 "/home/linas/src/linux/include/asm/mmu.h" 1
 








 
typedef struct _i370_pte_s {
	unsigned long za:1;	 
	unsigned long pfra:19;	 
	unsigned long zb:1;	 
	unsigned long iv:1;	 
	unsigned long pp:1;	 
	unsigned long zc:9;	 
} i370_pte_t; 

 
typedef struct _i370_ste_s {
	unsigned long za:1;	 
	unsigned long pto:25;	 
	unsigned long iv:1;	 
	unsigned long c:1;	 
	unsigned long ptl:4;	 
} i370_ste_t;


 
 








typedef struct _pte {
   	unsigned long page_num:20;
   	unsigned long flags:12;		 
} pte;






 



# 13 "/home/linas/src/linux/include/asm/pgtable.h" 2

# 1 "/home/linas/src/linux/include/asm/page.h" 1


# 94 "/home/linas/src/linux/include/asm/page.h"

# 14 "/home/linas/src/linux/include/asm/pgtable.h" 2


extern void i370_flush_tlb_all(void);
extern void i370_flush_tlb_mm(struct mm_struct *mm);
extern void i370_flush_tlb_page(struct vm_area_struct *vma, unsigned long vmaddr);
extern void i370_flush_tlb_range(struct mm_struct *mm, unsigned long start,
			    unsigned long end);






 










extern unsigned long va_to_phys(unsigned long address);
extern pte_t *va_to_pte(struct task_struct *tsk, unsigned long address);


 











 






 




 







 



 


 


 


 
















 







 



















 





























 







extern pte_t __bad_page(void);
extern pte_t * __bad_pagetable(void);

extern unsigned long empty_zero_page[1024];





 


 


 




 
 







     

 




 









extern inline int 
	pte_none(pte_t pte)	{ return ((( pte ).pte)  & 0x400  ); }
extern inline int 
	pte_present(pte_t pte)	{ return !(((( pte ).pte)  & 0x400 )); }
extern inline void 
	pte_clear(pte_t *ptep)	{ (( *ptep ).pte)  = 0x400  | 0x200 ; }


 


extern inline int 
	pmd_none(pmd_t pmd)	{ return (( pmd ).pmd)  & 0x20 ; }
extern inline int 
	pmd_bad(pmd_t pmd)	{ return 0; }
extern inline int 
	pmd_present(pmd_t pmd)	{ return ((( pmd ).pmd)  & 0x20 ) == 0; }
extern inline void 
	pmd_clear(pmd_t * pmdp)	{ (( *pmdp ).pmd)  = 0x20 ; }


 




extern inline int pgd_none(pgd_t pgd)		{ return 0; }
extern inline int pgd_bad(pgd_t pgd)		{ return 0; }
extern inline int pgd_present(pgd_t pgd)	{ return 1; }
extern inline void pgd_clear(pgd_t * pgdp)	{ }

 



extern inline int pte_read(pte_t pte)		{ return (( pte ).pte)  & 0x001 ; }
extern inline int pte_write(pte_t pte)		{ return !((( pte ).pte)  & 0x200 ); }
extern inline int pte_exec(pte_t pte)		{ return (( pte ).pte)  & 0x001 ; }

 
extern inline int pte_dirty(pte_t pte)		{ return (( pte ).pte)  & 0x002 ; }
extern inline int pte_young(pte_t pte)		{ return !((( pte ).pte)  & 0x004 ); }

extern inline void pte_uncache(pte_t pte)       { }
extern inline void pte_cache(pte_t pte)         { }

extern inline pte_t 
	pte_rdprotect(pte_t pte) { (( pte ).pte)  &= ~0x001 ; return pte; }
extern inline pte_t 
	pte_mkread(pte_t pte) 	{ (( pte ).pte)  |= 0x001 ; return pte; }

extern inline pte_t 
	pte_exprotect(pte_t pte) { (( pte ).pte)  &= ~0x001 ; return pte; }
extern inline pte_t 
	pte_mkexec(pte_t pte) 	{ (( pte ).pte)  |= 0x001 ; return pte; }

extern inline pte_t 
	pte_wrprotect(pte_t pte) { (( pte ).pte)  |= 0x200  ; return pte; }
extern inline pte_t 
	pte_mkwrite(pte_t pte) 	{ (( pte ).pte)  &= ~0x200 ; return pte; }

extern inline pte_t 
	pte_mkclean(pte_t pte) 	{ (( pte ).pte)  &= ~(0x002  ); return pte; }
extern inline pte_t 
	pte_mkdirty(pte_t pte) 	{ (( pte ).pte)  |= 0x002 ; return pte; }

extern inline pte_t 
	pte_mkold(pte_t pte)  	{ (( pte ).pte)  |= 0x004 ; return pte; }
extern inline pte_t 
	pte_mkyoung(pte_t pte) 	{ (( pte ).pte)  &= ~0x004 ; return pte; }



 










extern inline void 
set_pte (pte_t * ptep, pte_t val)	 
{
	if ((( val ).pte) ) { 
		*ptep = val;
	} else {
		pte_clear (ptep);
	}
}

 




static inline pte_t mk_pte_phys(unsigned long page, pgprot_t pgprot)
{ pte_t pte; 
printk ("mk_pte_phys for vaddr=%lx flags=%lx\n",page,(( pgprot ).pgprot) );
(( pte ).pte)  = (page & 0x7ffff000 ) | (( pgprot ).pgprot) ; return pte; }

extern inline pte_t mk_pte(unsigned long page, pgprot_t pgprot)
{ pte_t pte; 
printk ("mk_pte %lx %lx\n",page, (( pgprot ).pgprot) );
(( pte ).pte)  = (page & 0x7ffff000 ) | (( pgprot ).pgprot) ; return pte; }

extern inline pte_t pte_modify(pte_t pte, pgprot_t newprot)
{ (( pte ).pte)  = ((( pte ).pte)  & ((~((1UL << 12 ) -1))  | 0x004  | 0x002 ) ) | (( newprot ).pgprot) ; 
printk ("pte_modify %lx %lx\n", (( pte ).pte) ,(( newprot ).pgprot) );
return pte; }

 
extern inline unsigned long pte_page(pte_t pte)
{ return (unsigned long) ((( pte ).pte)  & 0x7ffff000 ); }

 
extern inline unsigned long pmd_page(pmd_t pmd)
{ return (( pmd ).pmd)  & 0x7fffffc0 ; }


 


 
extern inline pgd_t * pgd_offset(struct mm_struct * mm, unsigned long address)
{
	 
	return mm->pgd + ((address & 0x7fffffff ) >> 20 );
}

 
extern inline pmd_t * pmd_offset(pgd_t * dir, unsigned long address)
{
	return (pmd_t *) dir;
}

  
extern inline pte_t * pte_offset(pmd_t * dir, unsigned long address)
{
	pte_t * ppp = (pte_t *) pmd_page(*dir);
	 
	ppp += (address >> 12 ) & (256  - 1);
	return ppp;
}

extern __inline__ pgd_t *i370_pgd_alloc(void)
{
	pgd_t *ret;

	 
	ret = (pgd_t *)__get_free_pages((0x04  | 0x01  | 0x10 ) ,1);
	if (ret) {
		 
		 
		 
		int i;
		pmd_t *pme = (pmd_t *) ret;
printk ("in pgd_alloc alloced 2 pages at %p\n", ret);
		for (i=0; i< ((0x80000000UL)  / (1UL << 20 ) ) ; i++) {
			pmd_clear (pme);
			pme ++;
		}
		
	}
	return ret;
}

extern __inline__ void i370_pgd_free(pgd_t *pgd)
{
	 
	free_pages((unsigned long)pgd,1);
}


extern __inline__ void i370_pte_free(pte_t *pte)
{
	free_pages(( (unsigned long)pte ),0) ;
}

extern void __bad_pte(pmd_t *pmd);















extern pte_t *i370_get_pte(pmd_t *pmd, unsigned long pt_entry_index);

extern inline pte_t * i370_pte_alloc(pmd_t * pmd, unsigned long address)
{
	unsigned long entry_idx = (address >> 12 ) & (256  - 1);
	if (pmd_none(*pmd)) {
		return i370_get_pte(pmd, entry_idx);
	}
	if (pmd_bad(*pmd)) {
		__bad_pte(pmd);
		return ((void *) 0) ;
	}
	return ((pte_t *)pmd_page(*pmd)) + entry_idx;
}

 



extern inline void i370_pmd_free(pmd_t * pmd)
{
}

extern inline pmd_t * i370_pmd_alloc(pgd_t * pgd, unsigned long address)
{
	return (pmd_t *) pgd;
}


extern int do_check_pgt_cache(int, int);

 
 



extern inline void set_pgdir(unsigned long address, pgd_t entry)
{
	printk ("i370_set_pgdir(): unimplemented\n");
	i370_halt();
# 464 "/home/linas/src/linux/include/asm/pgtable.h"

}

 
extern pgd_t swapper_pg_dir[2048];

extern __inline__ pte_t *find_pte(struct mm_struct *mm, unsigned long va)
{
	pgd_t *dir;
	pmd_t *pmd;
	pte_t *pte = ((void *) 0) ;

	va &= 0x7fffffff ;
printk ("find_pte for va=0x%lx\n", va);
	
	dir = pgd_offset( mm, va );
	if (dir)
	{
printk ("find_pte got pgd for dir=%p\n", dir);
		pmd = pmd_offset(dir, va);
		if (pmd && pmd_present(*pmd))
		{
			pte = pte_offset(pmd, va);
 
printk ("find_pte got pmd for va=%lx pte=%p\n", va, pte);
		}
	}
	return pte;
}

 





 
















 




# 34 "fs/binfmt_elf.c" 2






# 1 "/home/linas/src/linux/include/linux/elf.h" 1






 
typedef __u32	Elf32_Addr;
typedef __u16	Elf32_Half;
typedef __u32	Elf32_Off;
typedef __s32	Elf32_Sword;
typedef __u32	Elf32_Word;

 
typedef __u64	Elf64_Addr;
typedef __u16	Elf64_Half;
typedef __s16	Elf64_SHalf;
typedef __u64	Elf64_Off;
typedef __s64	Elf64_Sword;
typedef __u64	Elf64_Word;

 










 








 





















 






 



























 













 



















typedef struct dynamic{
  Elf32_Sword d_tag;
  union{
    Elf32_Sword	d_val;
    Elf32_Addr	d_ptr;
  } d_un;
} Elf32_Dyn;

typedef struct {
  Elf64_Word d_tag;		 
  union {
    Elf64_Word d_val;
    Elf64_Word d_ptr;
  } d_un;
} Elf64_Dyn;

 
















 








































 








 


























 































 




typedef struct elf32_rel {
  Elf32_Addr	r_offset;
  Elf32_Word	r_info;
} Elf32_Rel;

typedef struct elf64_rel {
  Elf64_Addr r_offset;	 
  Elf64_Word r_info;	 
} Elf64_Rel;

typedef struct elf32_rela{
  Elf32_Addr	r_offset;
  Elf32_Word	r_info;
  Elf32_Sword	r_addend;
} Elf32_Rela;

typedef struct elf64_rela {
  Elf64_Addr r_offset;	 
  Elf64_Word r_info;	 
  Elf64_Word r_addend;	 
} Elf64_Rela;

typedef struct elf32_sym{
  Elf32_Word	st_name;
  Elf32_Addr	st_value;
  Elf32_Word	st_size;
  unsigned char	st_info;
  unsigned char	st_other;
  Elf32_Half	st_shndx;
} Elf32_Sym;

typedef struct elf64_sym {
  Elf32_Word st_name;		 
  unsigned char	st_info;	 
  unsigned char	st_other;	 
  Elf64_Half st_shndx;		 
  Elf64_Addr st_value;		 
  Elf64_Word st_size;		 
} Elf64_Sym;




typedef struct elf32_hdr{
  unsigned char	e_ident[16 ];
  Elf32_Half	e_type;
  Elf32_Half	e_machine;
  Elf32_Word	e_version;
  Elf32_Addr	e_entry;   
  Elf32_Off	e_phoff;
  Elf32_Off	e_shoff;
  Elf32_Word	e_flags;
  Elf32_Half	e_ehsize;
  Elf32_Half	e_phentsize;
  Elf32_Half	e_phnum;
  Elf32_Half	e_shentsize;
  Elf32_Half	e_shnum;
  Elf32_Half	e_shstrndx;
} Elf32_Ehdr;

typedef struct elf64_hdr {
  unsigned char	e_ident[16];		 
  Elf64_SHalf e_type;
  Elf64_Half e_machine;
  __s32 e_version;
  Elf64_Addr e_entry;		 
  Elf64_Off e_phoff;		 
  Elf64_Off e_shoff;		 
  __s32 e_flags;
  Elf64_SHalf e_ehsize;
  Elf64_SHalf e_phentsize;
  Elf64_SHalf e_phnum;
  Elf64_SHalf e_shentsize;
  Elf64_SHalf e_shnum;
  Elf64_SHalf e_shstrndx;
} Elf64_Ehdr;

 





typedef struct elf32_phdr{
  Elf32_Word	p_type;
  Elf32_Off	p_offset;
  Elf32_Addr	p_vaddr;
  Elf32_Addr	p_paddr;
  Elf32_Word	p_filesz;
  Elf32_Word	p_memsz;
  Elf32_Word	p_flags;
  Elf32_Word	p_align;
} Elf32_Phdr;

typedef struct elf64_phdr {
  __s32 p_type;
  __s32 p_flags;
  Elf64_Off p_offset;		 
  Elf64_Addr p_vaddr;		 
  Elf64_Addr p_paddr;		 
  Elf64_Word p_filesz;		 
  Elf64_Word p_memsz;		 
  Elf64_Word p_align;		 
} Elf64_Phdr;

 


















 





 







 
typedef struct {
  Elf32_Word	sh_name;
  Elf32_Word	sh_type;
  Elf32_Word	sh_flags;
  Elf32_Addr	sh_addr;
  Elf32_Off	sh_offset;
  Elf32_Word	sh_size;
  Elf32_Word	sh_link;
  Elf32_Word	sh_info;
  Elf32_Word	sh_addralign;
  Elf32_Word	sh_entsize;
} Elf32_Shdr;

typedef struct elf64_shdr {
  Elf32_Word sh_name;		 
  Elf32_Word sh_type;		 
  Elf64_Word sh_flags;		 
  Elf64_Addr sh_addr;		 
  Elf64_Off sh_offset;		 
  Elf64_Word sh_size;		 
  Elf32_Word sh_link;		 
  Elf32_Word sh_info;		 
  Elf64_Word sh_addralign;	 
  Elf64_Word sh_entsize;	 
} Elf64_Shdr;






























 





 
typedef struct elf32_note {
  Elf32_Word	n_namesz;	 
  Elf32_Word	n_descsz;	 
  Elf32_Word	n_type;		 
} Elf32_Nhdr;

 
 




typedef struct elf64_note {
  Elf32_Word n_namesz;	 
  Elf32_Word n_descsz;	 
  Elf32_Word n_type;	 
} Elf64_Nhdr;



extern Elf32_Dyn _DYNAMIC [];















# 40 "fs/binfmt_elf.c" 2


static int load_elf_binary(struct linux_binprm * bprm, struct _i370_interrupt_state_s  * regs);
static int load_elf_library(int fd);
extern int dump_fpu (struct _i370_interrupt_state_s  *, elf_fpregset_t *);
extern void dump_thread(struct _i370_interrupt_state_s  *, struct user *);






 




static int elf_core_dump(long signr, struct _i370_interrupt_state_s  * regs);








static struct linux_binfmt elf_format = {

	((void *) 0) , ((void *) 0) , load_elf_binary, load_elf_library, elf_core_dump



};

static void set_brk(unsigned long start, unsigned long end)
{
	start = ((( start ) + 4096  - 1) & ~(4096  - 1)) ;
	end = ((( end ) + 4096  - 1) & ~(4096  - 1)) ;
	if (end <= start)
		return;
	do_mmap(((void *) 0) , start, end - start,
		0x1  | 0x2  | 0x4 ,
		0x10  | 0x02 , 0);
}


 





static void padzero(unsigned long elf_bss)
{
	unsigned long nbyte;

	nbyte = (( elf_bss ) & (4096 -1)) ;
	if (nbyte) {
		nbyte = 4096  - nbyte;
		clear_user((void *) elf_bss, nbyte);
	}
}

static unsigned long  * 
create_elf_tables(char *p, int argc, int envc,
		  struct elf32_hdr  * exec,
		  unsigned long load_addr,
		  unsigned long load_bias,
		  unsigned long interp_load_addr, int ibcs)
{
	char *  *argv;
	char *  *envp;
	unsigned long  *sp, *csp;
	char *k_platform, *u_platform;
	long hwcap;
	size_t platform_len = 0;

	 






	hwcap = (0) ;
	k_platform = (((void *) 0) ) ;

	if (k_platform) {
		platform_len = strlen(k_platform) + 1;
		u_platform = p - platform_len;
		__copy_to_user(u_platform, k_platform, platform_len);
	} else
		u_platform = p;

	 




	sp = (unsigned long  *)((~15UL & (unsigned long)(u_platform)) - 16UL);
	csp = sp;
	csp -= ((exec ? 13 *2 : 4) + (k_platform ? 2 : 0));
	csp -= envc+1;
	csp -= argc+1;
	csp -= (!ibcs ? 3 : 1);	 
	if ((unsigned long)csp & 15UL)
		sp -= ((unsigned long)csp & 15UL) / sizeof(*sp);

	 






	sp -= 2;
	({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  0  ) ) ) , ( (  sp+( 0 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  0  ) ) ) , ( (  sp+( 0 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  0  ) ) ) , ( (  sp+( 0 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  0 ) ) ) , ( (  sp+( 0 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  0 ) ) ) , ( (  sp+( 0 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  0 ) ) ) , ( (  sp+( 0 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
	if (k_platform) {
		sp -= 2;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  15  ) ) ) , ( (  sp+( 0 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  15  ) ) ) , ( (  sp+( 0 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  15  ) ) ) , ( (  sp+( 0 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  (unsigned long )(unsigned long) u_platform ) ) ) , ( (  sp+( 0 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  (unsigned long )(unsigned long) u_platform ) ) ) , ( (  sp+( 0 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  (unsigned long )(unsigned long) u_platform ) ) ) , ( (  sp+( 0 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
	}
	sp -= 2;
	({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  16  ) ) ) , ( (  sp+( 0 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  16  ) ) ) , ( (  sp+( 0 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  16  ) ) ) , ( (  sp+( 0 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  hwcap ) ) ) , ( (  sp+( 0 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  hwcap ) ) ) , ( (  sp+( 0 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  hwcap ) ) ) , ( (  sp+( 0 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;

	if (exec) {
		sp -= 11*2;

		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  3  ) ) ) , ( (  sp+( 0 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  3  ) ) ) , ( (  sp+( 0 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2) )))( (  3  ) ) ) , ( (  sp+( 0 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 0 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  load_addr + exec->e_phoff ) ) ) , ( (  sp+( 0 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  load_addr + exec->e_phoff ) ) ) , ( (  sp+( 0 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 0 *2+1) )))( (  load_addr + exec->e_phoff ) ) ) , ( (  sp+( 0 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 1 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 1 *2) )))( (  4  ) ) ) , ( (  sp+( 1 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 1 *2) )))( (  4  ) ) ) , ( (  sp+( 1 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 1 *2) )))( (  4  ) ) ) , ( (  sp+( 1 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 1 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 1 *2+1) )))( (  sizeof (struct elf32_phdr ) ) ) ) , ( (  sp+( 1 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 1 *2+1) )))( (  sizeof (struct elf32_phdr ) ) ) ) , ( (  sp+( 1 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 1 *2+1) )))( (  sizeof (struct elf32_phdr ) ) ) ) , ( (  sp+( 1 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 2 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 2 *2) )))( (  5  ) ) ) , ( (  sp+( 2 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 2 *2) )))( (  5  ) ) ) , ( (  sp+( 2 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 2 *2) )))( (  5  ) ) ) , ( (  sp+( 2 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 2 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 2 *2+1) )))( (  exec->e_phnum ) ) ) , ( (  sp+( 2 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 2 *2+1) )))( (  exec->e_phnum ) ) ) , ( (  sp+( 2 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 2 *2+1) )))( (  exec->e_phnum ) ) ) , ( (  sp+( 2 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 3 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 3 *2) )))( (  6  ) ) ) , ( (  sp+( 3 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 3 *2) )))( (  6  ) ) ) , ( (  sp+( 3 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 3 *2) )))( (  6  ) ) ) , ( (  sp+( 3 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 3 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 3 *2+1) )))( (  4096  ) ) ) , ( (  sp+( 3 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 3 *2+1) )))( (  4096  ) ) ) , ( (  sp+( 3 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 3 *2+1) )))( (  4096  ) ) ) , ( (  sp+( 3 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 4 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 4 *2) )))( (  7  ) ) ) , ( (  sp+( 4 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 4 *2) )))( (  7  ) ) ) , ( (  sp+( 4 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 4 *2) )))( (  7  ) ) ) , ( (  sp+( 4 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 4 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 4 *2+1) )))( (  interp_load_addr ) ) ) , ( (  sp+( 4 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 4 *2+1) )))( (  interp_load_addr ) ) ) , ( (  sp+( 4 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 4 *2+1) )))( (  interp_load_addr ) ) ) , ( (  sp+( 4 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 5 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 5 *2) )))( (  8  ) ) ) , ( (  sp+( 5 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 5 *2) )))( (  8  ) ) ) , ( (  sp+( 5 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 5 *2) )))( (  8  ) ) ) , ( (  sp+( 5 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 5 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 5 *2+1) )))( (  0 ) ) ) , ( (  sp+( 5 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 5 *2+1) )))( (  0 ) ) ) , ( (  sp+( 5 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 5 *2+1) )))( (  0 ) ) ) , ( (  sp+( 5 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 6 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 6 *2) )))( (  9  ) ) ) , ( (  sp+( 6 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 6 *2) )))( (  9  ) ) ) , ( (  sp+( 6 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 6 *2) )))( (  9  ) ) ) , ( (  sp+( 6 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 6 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 6 *2+1) )))( (  load_bias + exec->e_entry ) ) ) , ( (  sp+( 6 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 6 *2+1) )))( (  load_bias + exec->e_entry ) ) ) , ( (  sp+( 6 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 6 *2+1) )))( (  load_bias + exec->e_entry ) ) ) , ( (  sp+( 6 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 7 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 7 *2) )))( (  11  ) ) ) , ( (  sp+( 7 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 7 *2) )))( (  11  ) ) ) , ( (  sp+( 7 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 7 *2) )))( (  11  ) ) ) , ( (  sp+( 7 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 7 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 7 *2+1) )))( (  (unsigned long ) current->uid ) ) ) , ( (  sp+( 7 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 7 *2+1) )))( (  (unsigned long ) current->uid ) ) ) , ( (  sp+( 7 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 7 *2+1) )))( (  (unsigned long ) current->uid ) ) ) , ( (  sp+( 7 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 8 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 8 *2) )))( (  12  ) ) ) , ( (  sp+( 8 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 8 *2) )))( (  12  ) ) ) , ( (  sp+( 8 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 8 *2) )))( (  12  ) ) ) , ( (  sp+( 8 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 8 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 8 *2+1) )))( (  (unsigned long ) current->euid ) ) ) , ( (  sp+( 8 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 8 *2+1) )))( (  (unsigned long ) current->euid ) ) ) , ( (  sp+( 8 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 8 *2+1) )))( (  (unsigned long ) current->euid ) ) ) , ( (  sp+( 8 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 9 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 9 *2) )))( (  13  ) ) ) , ( (  sp+( 9 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 9 *2) )))( (  13  ) ) ) , ( (  sp+( 9 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 9 *2) )))( (  13  ) ) ) , ( (  sp+( 9 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 9 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 9 *2+1) )))( (  (unsigned long ) current->gid ) ) ) , ( (  sp+( 9 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 9 *2+1) )))( (  (unsigned long ) current->gid ) ) ) , ( (  sp+( 9 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 9 *2+1) )))( (  (unsigned long ) current->gid ) ) ) , ( (  sp+( 9 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 10 *2) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 10 *2) )))( (  14  ) ) ) , ( (  sp+( 10 *2) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 10 *2) )))( (  14  ) ) ) , ( (  sp+( 10 *2) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 10 *2) )))( (  14  ) ) ) , ( (  sp+( 10 *2) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  sp+( 10 *2+1) )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  sp+( 10 *2+1) )))( (  (unsigned long ) current->egid ) ) ) , ( (  sp+( 10 *2+1) ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  sp+( 10 *2+1) )))( (  (unsigned long ) current->egid ) ) ) , ( (  sp+( 10 *2+1) ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  sp+( 10 *2+1) )))( (  (unsigned long ) current->egid ) ) ) , ( (  sp+( 10 *2+1) ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ; ;
	}


	sp -= envc+1;
	envp = (char *  *) sp;
	sp -= argc+1;
	argv = (char *  *) sp;
	if (!ibcs) {
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*( --sp )) ) ) {	case 1: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )(unsigned long) envp ) ) , ( ( --sp ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )(unsigned long) envp ) ) , ( ( --sp ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )(unsigned long) envp ) ) , ( ( --sp ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*( --sp )) ) ) {	case 1: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )(unsigned long) argv ) ) , ( ( --sp ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )(unsigned long) argv ) ) , ( ( --sp ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )(unsigned long) argv ) ) , ( ( --sp ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
	}

	({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*( --sp )) ) ) {	case 1: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )argc ) ) , ( ( --sp ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )argc ) ) , ( ( --sp ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*( --sp )))( (unsigned long )argc ) ) , ( ( --sp ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
	current->mm->arg_start = (unsigned long) p;
	while (argc-->0) {
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*( argv++ )) ) ) {	case 1: put_user_data( ( (__typeof__(*( argv++ )))( (char * )(unsigned long)p ) ) , ( ( argv++ ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*( argv++ )))( (char * )(unsigned long)p ) ) , ( ( argv++ ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*( argv++ )))( (char * )(unsigned long)p ) ) , ( ( argv++ ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
		p += strlen_user(p);
	}
	({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  argv )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  argv )))( ((void *) 0)  ) ) , ( (  argv ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  argv )))( ((void *) 0)  ) ) , ( (  argv ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  argv )))( ((void *) 0)  ) ) , ( (  argv ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
	current->mm->arg_end = current->mm->env_start = (unsigned long) p;
	while (envc-->0) {
		({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*( envp++ )) ) ) {	case 1: put_user_data( ( (__typeof__(*( envp++ )))( (char * )(unsigned long)p ) ) , ( ( envp++ ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*( envp++ )))( (char * )(unsigned long)p ) ) , ( ( envp++ ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*( envp++ )))( (char * )(unsigned long)p ) ) , ( ( envp++ ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
		p += strlen_user(p);
	}
	({	long __pu_err;	do {	 __pu_err  = 0;	switch ( ( sizeof(*(  envp )) ) ) {	case 1: put_user_data( ( (__typeof__(*(  envp )))( ((void *) 0)  ) ) , ( (  envp ) ) ,1); break;	case 2: put_user_data( ( (__typeof__(*(  envp )))( ((void *) 0)  ) ) , ( (  envp ) ) ,2); break;	case 4: put_user_data( ( (__typeof__(*(  envp )))( ((void *) 0)  ) ) , ( (  envp ) ) ,4); break;	default: __put_user_bad();	}	} while (0) ;	__pu_err;	})  ;
	current->mm->env_end = (unsigned long) p;
	return sp;
}


 




static unsigned long load_elf_interp(struct elf32_hdr  * interp_elf_ex,
				     struct dentry * interpreter_dentry,
				     unsigned long *interp_load_addr)
{
	struct file * file;
	struct elf32_phdr  *elf_phdata;
	struct elf32_phdr  *eppnt;
	unsigned long load_addr = 0;
	int load_addr_set = 0;
	unsigned long last_bss = 0, elf_bss = 0;
	unsigned long error = ~0UL;
	int elf_exec_fileno;
	int retval, i, size;

	 
	if (interp_elf_ex->e_type != 2  &&
	    interp_elf_ex->e_type != 3 )
		goto out;
	if (! (( interp_elf_ex->e_machine ) == 0xf00f ) )
		goto out;
	if (!interpreter_dentry->d_inode->i_op ||
	    !interpreter_dentry->d_inode->i_op->default_file_ops->mmap)
		goto out;

	 



	if (interp_elf_ex->e_phentsize != sizeof(struct elf32_phdr ))
		goto out;

	 

	size = sizeof(struct elf32_phdr ) * interp_elf_ex->e_phnum;
	if (size > 4096 )
		goto out;
	elf_phdata = (struct elf32_phdr  *) kmalloc(size, (0x04  | 0x01  | 0x10 ) );
	if (!elf_phdata)
		goto out;

	retval = read_exec(interpreter_dentry, interp_elf_ex->e_phoff,
			   (char *) elf_phdata, size, 1);
	error = retval;
	if (retval < 0)
		goto out_free;

	error = ~0UL;
	elf_exec_fileno = open_dentry(interpreter_dentry, 00 );
	if (elf_exec_fileno < 0)
		goto out_free;
	file = fget(elf_exec_fileno);

	eppnt = elf_phdata;
	for (i=0; i<interp_elf_ex->e_phnum; i++, eppnt++) {
	  if (eppnt->p_type == 1 ) {
	    int elf_type = 0x02  | 0x0800 ;
	    int elf_prot = 0;
	    unsigned long vaddr = 0;
	    unsigned long k, map_addr;

	    if (eppnt->p_flags & 0x4 ) elf_prot =  0x1 ;
	    if (eppnt->p_flags & 0x2 ) elf_prot |= 0x2 ;
	    if (eppnt->p_flags & 0x1 ) elf_prot |= 0x4 ;
	    vaddr = eppnt->p_vaddr;
	    if (interp_elf_ex->e_type == 2  || load_addr_set) {
	    	elf_type |= 0x10 ;





	    }

	    map_addr = do_mmap(file,
			    load_addr + (( vaddr ) & ~(unsigned long)(4096 -1)) ,
			    eppnt->p_filesz + (( eppnt->p_vaddr ) & (4096 -1)) ,
			    elf_prot,
			    elf_type,
			    eppnt->p_offset - (( eppnt->p_vaddr ) & (4096 -1)) );
	    if (map_addr > -1024UL)  
		goto out_close;

	    if (!load_addr_set && interp_elf_ex->e_type == 3 ) {
		load_addr = map_addr - (( vaddr ) & ~(unsigned long)(4096 -1)) ;
		load_addr_set = 1;
	    }

	     



	    k = load_addr + eppnt->p_vaddr + eppnt->p_filesz;
	    if (k > elf_bss)
		elf_bss = k;

	     



	    k = load_addr + eppnt->p_memsz + eppnt->p_vaddr;
	    if (k > last_bss)
		last_bss = k;
	  }
	}

	 

	 





	padzero(elf_bss);
	elf_bss = (( elf_bss + 4096  - 1 ) & ~(unsigned long)(4096 -1)) ;  

	 
	if (last_bss > elf_bss)
		do_mmap(((void *) 0) , elf_bss, last_bss - elf_bss,
			0x1 | 0x2 | 0x4 ,
			0x10 | 0x02 , 0);

	*interp_load_addr = load_addr;
	error = ((unsigned long) interp_elf_ex->e_entry) + load_addr;

out_close:
	fput(file);
	sys_close(elf_exec_fileno);
out_free:
	kfree(elf_phdata);
out:
	return error;
}

static unsigned long load_aout_interp(struct exec * interp_ex,
			     struct dentry * interpreter_dentry)
{
	unsigned long text_data, offset, elf_entry = ~0UL;
	char * addr;
	int retval;

	current->mm->end_code = interp_ex->a_text;
	text_data = interp_ex->a_text + interp_ex->a_data;
	current->mm->end_data = text_data;
	current->mm->brk = interp_ex->a_bss + text_data;

	switch ((( *interp_ex ).a_info & 0xffff) ) {
	case 0407 :
		offset = 32;
		addr = (char *) 0;
		break;
	case 0413 :
	case 0314 :
		offset = (((  *interp_ex  ).a_info & 0xffff)  == 0413  ? (1024 - sizeof (struct exec))  + sizeof (struct exec) : (((  *interp_ex  ).a_info & 0xffff)  == 0314  ? 0 : sizeof (struct exec))) ;
		addr = (char *) (((  *interp_ex  ).a_info & 0xffff)  == 0314  ? (1UL << 12 )  : 0) ;
		break;
	default:
		goto out;
	}

	do_mmap(((void *) 0) , 0, text_data,
		0x1 | 0x2 | 0x4 , 0x10 | 0x02 , 0);
	retval = read_exec(interpreter_dentry, offset, addr, text_data, 0);
	if (retval < 0)
		goto out;
	do { } while (0) ;


	do_mmap(((void *) 0) , (( text_data + 4096  - 1 ) & ~(unsigned long)(4096 -1)) ,
		interp_ex->a_bss,
		0x1 | 0x2 | 0x4 , 0x10 | 0x02 , 0);
	elf_entry = interp_ex->a_entry;

out:
	return elf_entry;
}

 









static inline int
do_load_elf_binary(struct linux_binprm * bprm, struct _i370_interrupt_state_s  * regs)
{
	struct file * file;
	struct dentry *interpreter_dentry = ((void *) 0) ;  
 	unsigned long load_addr = 0, load_bias;
	int load_addr_set = 0;
	char * elf_interpreter = ((void *) 0) ;
	unsigned int interpreter_type = 0 ;
	unsigned char ibcs2_interpreter = 0;
	mm_segment_t old_fs;
	unsigned long error;
	struct elf32_phdr  * elf_ppnt, *elf_phdata;
	unsigned long elf_bss, k, elf_brk;
	int elf_exec_fileno;
	int retval, size, i;
	unsigned long elf_entry, interp_load_addr = 0;
	unsigned long start_code, end_code, end_data;
	struct elf32_hdr  elf_ex;
	struct elf32_hdr  interp_elf_ex;
  	struct exec interp_ex;
	char passed_fileno[6];

	 
	elf_ex = *((struct elf32_hdr  *) bprm->buf);
printk("duude elf header at %x\n", bprm->buf);
{
int * bbb = (int *) bprm->buf;
printk ("%08x %08x %08x %08x \n", bbb[0], bbb[1], bbb[2], bbb[3]);
printk ("%08x %08x %08x %08x \n", bbb[4], bbb[5], bbb[6], bbb[7]);
printk ("%08x %08x %08x %08x \n", bbb[8], bbb[9], bbb[10], bbb[11]);
}

	retval = - 8 ;
	 
	if (elf_ex.e_ident[0] != 0x7f ||
	    strncmp(&elf_ex.e_ident[1], "ELF", 3) != 0)
		goto out;

	if (elf_ex.e_type != 2  && elf_ex.e_type != 3 )
		goto out;
	if (! (( elf_ex.e_machine ) == 0xf00f ) )
		goto out;
printk ("duuude gotsa  %d elf sections\n", elf_ex.e_phnum);







	if (!bprm->dentry->d_inode->i_op		   ||
	    !bprm->dentry->d_inode->i_op->default_file_ops ||
	    !bprm->dentry->d_inode->i_op->default_file_ops->mmap)
		goto out;

	 

	retval = - 12 ;
	size = elf_ex.e_phentsize * elf_ex.e_phnum;
	elf_phdata = (struct elf32_phdr  *) kmalloc(size, (0x04  | 0x01  | 0x10 ) );
	if (!elf_phdata)
		goto out;

printk("duude ephoff=%x size=%d\n", elf_ex.e_phoff, size);
	retval = read_exec(bprm->dentry, elf_ex.e_phoff,
				(char *) elf_phdata, size, 1);
{
int * bbb = (int *) elf_phdata;
printk ("%08x %08x %08x %08x \n", bbb[0], bbb[1], bbb[2], bbb[3]);
printk ("%08x %08x %08x %08x \n", bbb[4], bbb[5], bbb[6], bbb[7]);
printk ("%08x %08x %08x %08x \n", bbb[8], bbb[9], bbb[10], bbb[11]);
}
	if (retval < 0)
		goto out_free_ph;

	retval = open_dentry(bprm->dentry, 00 );
	if (retval < 0)
		goto out_free_ph;
	elf_exec_fileno = retval;
	file = fget(elf_exec_fileno);

	elf_ppnt = elf_phdata;
	elf_bss = 0;
	elf_brk = 0;

	start_code = ~0UL;
	end_code = 0;
	end_data = 0;

printk ("duuude will scan %d elf sections\n", elf_ex.e_phnum);
	for (i = 0; i < elf_ex.e_phnum; i++) {
		if (elf_ppnt->p_type == 3 ) {
			retval = - 22 ;
		  	if (elf_interpreter)
				goto out_free_interp;

			 




			retval = - 12 ;
			elf_interpreter = (char *) kmalloc(elf_ppnt->p_filesz,
							   (0x04  | 0x01  | 0x10 ) );
			if (!elf_interpreter)
				goto out_free_file;

			retval = read_exec(bprm->dentry, elf_ppnt->p_offset,
					   elf_interpreter,
					   elf_ppnt->p_filesz, 1);
			if (retval < 0)
				goto out_free_interp;
			 



			if (strcmp(elf_interpreter,"/usr/lib/libc.so.1") == 0 ||
			    strcmp(elf_interpreter,"/usr/lib/ld.so.1") == 0)
				ibcs2_interpreter = 1;



			old_fs = (current->tss.fs) ;  
			(current->tss.fs = ( (((mm_segment_t) { 0 }) )  )) ;
# 534 "fs/binfmt_elf.c"

				interpreter_dentry = open_namei(elf_interpreter,
								0, 0);
			(current->tss.fs = ( old_fs )) ;
			retval = ((long)( interpreter_dentry )) ;
			if (((unsigned long)( interpreter_dentry ) > (unsigned long)(-1000)) )
				goto out_free_interp;
			retval = permission(interpreter_dentry->d_inode, 1 );
			if (retval < 0)
				goto out_free_dentry;
			retval = read_exec(interpreter_dentry, 0, bprm->buf, 128, 1);
			if (retval < 0)
				goto out_free_dentry;

			 
			interp_ex = *((struct exec *) bprm->buf);
			interp_elf_ex = *((struct elf32_hdr  *) bprm->buf);
		}
		elf_ppnt++;
	}

	 
	if (elf_interpreter) {
		interpreter_type = 2  | 1 ;

		 
		if (((( interp_ex ).a_info & 0xffff)  != 0407 ) &&
		    ((( interp_ex ).a_info & 0xffff)  != 0413 ) &&
		    ((( interp_ex ).a_info & 0xffff)  != 0314 ))
			interpreter_type = 2 ;

		if (interp_elf_ex.e_ident[0] != 0x7f ||
		    strncmp(&interp_elf_ex.e_ident[1], "ELF", 3) != 0)
			interpreter_type &= ~2 ;

		retval = - 80 ;
		if (!interpreter_type)
			goto out_free_dentry;

		 
		if ((interpreter_type & 2 ) &&
		     interpreter_type != 2 ) {
			printk("<4>"  "ELF: Ambiguous type, using ELF\n");
			interpreter_type = 2 ;
		}
	}

	 


	if (!bprm->sh_bang) {
		char * passed_p;

		if (interpreter_type == 1 ) {
		  sprintf(passed_fileno, "%d", elf_exec_fileno);
		  passed_p = passed_fileno;

		  if (elf_interpreter) {
		    bprm->p = copy_strings(1,&passed_p,bprm->page,bprm->p,2);
		    bprm->argc++;
		  }
		}
		retval = - 7 ;
		if (!bprm->p)
			goto out_free_dentry;
	}

	 
	retval = flush_old_exec(bprm);
	if (retval)
		goto out_free_dentry;

	 
	current->mm->end_data = 0;
	current->mm->end_code = 0;
	current->mm->mmap = ((void *) 0) ;
	current->flags &= ~0x00000040 ;
	elf_entry = (unsigned long) elf_ex.e_entry;

	 

	current->personality = (  ibcs2_interpreter  ? (0x0001 | 0x4000000 )  : (0x0000) ) ;

	 

	current->mm->rss = 0;
	bprm->p = setup_arg_pages(bprm->p, bprm);
	current->mm->start_stack = bprm->p;

	 



	load_bias = (( elf_ex.e_type== 3  ? (0x08000000)  : 0 ) & ~(unsigned long)(4096 -1)) ;
printk ("duude load_bias=%x type=%x\n",  load_bias, elf_ex.e_type);
load_bias = 0;

	 




	old_fs = (current->tss.fs) ;
	(current->tss.fs = ( (((mm_segment_t) { 0 }) )  )) ;
printk ("duuude will load %d elf sections\n", elf_ex.e_phnum);
	for(i = 0, elf_ppnt = elf_phdata; i < elf_ex.e_phnum; i++, elf_ppnt++) {
		int elf_prot = 0, elf_flags;
		unsigned long vaddr;

printk ("dude sec %d at vma 0x%x len %x fileoff %x flags %x w=%x x=%x\n",
i,elf_ppnt->p_vaddr,elf_ppnt->p_filesz,elf_ppnt->p_offset, elf_ppnt->p_flags,0x2 ,0x1 );
		if (elf_ppnt->p_type != 1 )
			continue;

		if (elf_ppnt->p_flags & 0x4 ) elf_prot |= 0x1 ;
		if (elf_ppnt->p_flags & 0x2 ) elf_prot |= 0x2 ;
		if (elf_ppnt->p_flags & 0x1 ) elf_prot |= 0x4 ;

		elf_flags = 0x02 | 0x0800 | 0x1000 ;

		vaddr = elf_ppnt->p_vaddr;
		if (elf_ex.e_type == 2  || load_addr_set) {
			elf_flags |= 0x10 ;
		}

printk("loader up\n");
		error = do_mmap(file, (( load_bias + vaddr ) & ~(unsigned long)(4096 -1)) ,
		                (elf_ppnt->p_filesz +
		                (( elf_ppnt->p_vaddr ) & (4096 -1)) ),
		                elf_prot, elf_flags, (elf_ppnt->p_offset -
		                (( elf_ppnt->p_vaddr ) & (4096 -1)) ));

		if (!load_addr_set) {
			load_addr_set = 1;
			load_addr = (elf_ppnt->p_vaddr - elf_ppnt->p_offset);
printk ("duuuuuuuuuuuuuude load addr =%x\n",load_addr);
			if (elf_ex.e_type == 3 ) {
				load_bias += error -
				             (( load_bias + vaddr ) & ~(unsigned long)(4096 -1)) ;
				load_addr += error;
			}
		}
		k = elf_ppnt->p_vaddr;
		if (k < start_code) start_code = k;
		k = elf_ppnt->p_vaddr + elf_ppnt->p_filesz;
		if (k > elf_bss)
			elf_bss = k;
		if ((elf_ppnt->p_flags & 0x1 ) && end_code <  k)
			end_code = k;
		if (end_data < k)
			end_data = k;
		k = elf_ppnt->p_vaddr + elf_ppnt->p_memsz;
		if (k > elf_brk)
			elf_brk = k;
printk("startcode=%x endcode=%x endata=%x\n",
 start_code,end_code,end_data);
	}
	(current->tss.fs = ( old_fs )) ;
	fput(file);  

	elf_entry += load_bias;
	elf_bss += load_bias;
	elf_brk += load_bias;
	start_code += load_bias;
	end_code += load_bias;
	end_data += load_bias;

	if (elf_interpreter) {
		if (interpreter_type == 1 )
			elf_entry = load_aout_interp(&interp_ex,
						     interpreter_dentry);
		else
			elf_entry = load_elf_interp(&interp_elf_ex,
						    interpreter_dentry,
						    &interp_load_addr);

		dput(interpreter_dentry);
		kfree(elf_interpreter);

		if (elf_entry == ~0UL) {
			printk("<3>"  "Unable to load interpreter\n");
			kfree(elf_phdata);
			send_sig(11 , current, 0);
			return 0;
		}
	}

	kfree(elf_phdata);

	if (interpreter_type != 1 )
		sys_close(elf_exec_fileno);

	if (current->exec_domain && current->exec_domain->module)
		(atomic_dec(&( current->exec_domain->module )->uc.usecount), ( current->exec_domain->module )->flags |= 8 ) ;
	if (current->binfmt && current->binfmt->module)
		(atomic_dec(&( current->binfmt->module )->uc.usecount), ( current->binfmt->module )->flags |= 8 ) ;
	current->exec_domain = lookup_exec_domain(current->personality);
	current->binfmt = &elf_format;
	if (current->exec_domain && current->exec_domain->module)
		(atomic_inc(&( current->exec_domain->module )->uc.usecount), ( current->exec_domain->module )->flags |= 8 | 16 ) ;
	if (current->binfmt && current->binfmt->module)
		(atomic_inc(&( current->binfmt->module )->uc.usecount), ( current->binfmt->module )->flags |= 8 | 16 ) ;




	compute_creds(bprm);
	current->flags &= ~0x00000040 ;
	bprm->p = (unsigned long)
	  create_elf_tables((char *)bprm->p,
			bprm->argc,
			bprm->envc,
			(interpreter_type == 2  ? &elf_ex : ((void *) 0) ),
			load_addr, load_bias,
			interp_load_addr,
			(interpreter_type == 1  ? 0 : 1));
	 
	if (interpreter_type == 1 )
		current->mm->arg_start += strlen(passed_fileno) + 1;
	current->mm->start_brk = current->mm->brk = elf_brk;
	current->mm->end_code = end_code;
	current->mm->start_code = start_code;
	current->mm->end_data = end_data;
	current->mm->start_stack = bprm->p;

	 


	set_brk(elf_bss, elf_brk);

	padzero(elf_bss);


	printk("(start_brk) %x\n" , current->mm->start_brk);
	printk("(end_code) %x\n" , current->mm->end_code);
	printk("(start_code) %x\n" , current->mm->start_code);
	printk("(end_data) %x\n" , current->mm->end_data);
	printk("(start_stack) %x\n" , current->mm->start_stack);
	printk("(brk) %x\n" , current->mm->brk);


	if ( current->personality == (0x0001 | 0x4000000 )  )
	{
		 



		 
		error = do_mmap(((void *) 0) , 0, 4096, 0x1  | 0x4 ,
				0x10  | 0x02 , 0);
	}

# 794 "fs/binfmt_elf.c"


	i370_start_thread( regs ,  elf_entry ,  bprm->p ) ;
	if (current->flags & 0x00000010 )
		send_sig(5 , current, 0);
	retval = 0;
out:
	return retval;

	 
out_free_dentry:
	dput(interpreter_dentry);
out_free_interp:
	if (elf_interpreter)
		kfree(elf_interpreter);
out_free_file:
	fput(file);
	sys_close(elf_exec_fileno);
out_free_ph:
	kfree(elf_phdata);
	goto out;
}

static int
load_elf_binary(struct linux_binprm * bprm, struct _i370_interrupt_state_s  * regs)
{
	int retval;

	do { } while (0) ;
	retval = do_load_elf_binary(bprm, regs);
	do { } while (0) ;
	return retval;
}

 


static inline int
do_load_elf_library(int fd)
{
	struct file * file;
	struct dentry * dentry;
	struct inode * inode;
	struct elf32_phdr  *elf_phdata;
	unsigned long elf_bss = 0, bss, len, k;
	int retval, error, i, j;
	struct elf32_hdr  elf_ex;
	loff_t offset = 0;

	error = - 13 ;
	file = fget(fd);
	if (!file || !file->f_op)
		goto out;
	dentry = file->f_dentry;
	inode = dentry->d_inode;

	 
	error = - 8 ;

	 
	(current->tss.fs = ( ((mm_segment_t) { 0 })  )) ;
	retval = file->f_op->read(file, (char *) &elf_ex, sizeof(elf_ex), &offset);
	(current->tss.fs = ( ((mm_segment_t) { 1 })  )) ;
	if (retval != sizeof(elf_ex))
		goto out_putf;

	if (elf_ex.e_ident[0] != 0x7f ||
	    strncmp(&elf_ex.e_ident[1], "ELF", 3) != 0)
		goto out_putf;

	 
	if (elf_ex.e_type != 2  || elf_ex.e_phnum > 2 ||
	   ! (( elf_ex.e_machine ) == 0xf00f )  ||
	   (!inode->i_op || !inode->i_op->default_file_ops->mmap))
		goto out_putf;

	 

	j = sizeof(struct elf32_phdr ) * elf_ex.e_phnum;
	if (j > 4096 )
		goto out_putf;

	error = - 12 ;
	elf_phdata = (struct elf32_phdr  *) kmalloc(j, (0x04  | 0x01  | 0x10 ) );
	if (!elf_phdata)
		goto out_putf;

	 
	retval = read_exec(dentry, elf_ex.e_phoff, (char *) elf_phdata,
			   sizeof(struct elf32_phdr ) * elf_ex.e_phnum, 1);

	error = - 8 ;
	for (j = 0, i = 0; i<elf_ex.e_phnum; i++)
		if ((elf_phdata + i)->p_type == 1 ) j++;
	if (j != 1)
		goto out_free_ph;

	while (elf_phdata->p_type != 1 ) elf_phdata++;

	 
	error = do_mmap(file,
			(( elf_phdata->p_vaddr ) & ~(unsigned long)(4096 -1)) ,
			(elf_phdata->p_filesz +
			 (( elf_phdata->p_vaddr ) & (4096 -1)) ),
			0x1  | 0x2  | 0x4 ,
			0x10  | 0x02  | 0x0800 ,
			(elf_phdata->p_offset -
			 (( elf_phdata->p_vaddr ) & (4096 -1)) ));
	if (error != (( elf_phdata->p_vaddr ) & ~(unsigned long)(4096 -1)) )
		goto out_free_ph;

	k = elf_phdata->p_vaddr + elf_phdata->p_filesz;
	if (k > elf_bss)
		elf_bss = k;
	padzero(elf_bss);

	len = (( elf_phdata->p_filesz + elf_phdata->p_vaddr + 
				4096  - 1 ) & ~(unsigned long)(4096 -1)) ;
	bss = elf_phdata->p_memsz + elf_phdata->p_vaddr;
	if (bss > len)
		do_mmap(((void *) 0) , len, bss - len,
			0x1 | 0x2 | 0x4 ,
			0x10 | 0x02 , 0);
	error = 0;

out_free_ph:
	kfree(elf_phdata);
out_putf:
	fput(file);
out:
	return error;
}

static int load_elf_library(int fd)
{
	int retval;

	do { } while (0) ;
	retval = do_load_elf_library(fd);
	do { } while (0) ;
	return retval;
}

 





 





 



static int dump_write(struct file *file, const void *addr, int nr)
{
	return file->f_op->write(file, addr, nr, &file->f_pos) == nr;
}

static int dump_seek(struct file *file, off_t off)
{
	if (file->f_op->llseek) {
		if (file->f_op->llseek(file, off, 0) != off)
			return 0;
	} else
		file->f_pos = off;
	return 1;
}

 






static inline int maydump(struct vm_area_struct *vma)
{
	if (!(vma->vm_flags & (0x0001 | 0x0002 | 0x0004 )))
		return 0;

	 
	if(vma->vm_flags & 0x4000 )
		return 0;

	if (vma->vm_flags & (0x0002 | 0x0200 | 0x0100 ))
		return 1;
	if (vma->vm_flags & (0x0001 | 0x0004 | 0x1000 | 0x0008 ))
		return 0;

	return 1;
}



 
struct memelfnote
{
	const char *name;
	int type;
	unsigned int datasz;
	void *data;
};

static int notesize(struct memelfnote *en)
{
	int sz;

	sz = sizeof(struct elf32_note );
	sz += (((( strlen(en->name) )+((  4 )-1))/(  4 ))*(  4 )) ;
	sz += (((( en->datasz )+((  4 )-1))/(  4 ))*(  4 )) ;

	return sz;
}

 

# 1032 "fs/binfmt_elf.c"







static int writenote(struct memelfnote *men, struct file *file)
{
	struct elf32_note  en;

	en.n_namesz = strlen(men->name);
	en.n_descsz = men->datasz;
	en.n_type = men->type;

	do { if (!dump_write(file, ( &en ), (  sizeof(en) ))) return 0; } while(0) ;
	do { if (!dump_write(file, ( men->name ), (  en.n_namesz ))) return 0; } while(0) ;
	 
	do { if (!dump_seek(file, ( (((( (unsigned long)file->f_pos )+((  4 )-1))/(  4 ))*(  4 ))  ))) return 0; } while(0) ;	 
	do { if (!dump_write(file, ( men->data ), (  men->datasz ))) return 0; } while(0) ;
	do { if (!dump_seek(file, ( (((( (unsigned long)file->f_pos )+((  4 )-1))/(  4 ))*(  4 ))  ))) return 0; } while(0) ;	 

	return 1;
}









 






static int elf_core_dump(long signr, struct _i370_interrupt_state_s  * regs)
{
	int has_dumped = 0;
	struct file file;
	struct dentry *dentry;
	struct inode *inode;
	mm_segment_t fs;
	char corefile[6+sizeof(current->comm)];
	int segs;
	int i;
	size_t size;
	struct vm_area_struct *vma;
	struct elf32_hdr  elf;
	off_t offset = 0, dataoff;
	unsigned long limit = current->rlim[4 ].rlim_cur;
	int numnote = 4;
	struct memelfnote notes[4];
	struct elf_prstatus prstatus;	 
	elf_fpregset_t fpu;		 
	struct elf_prpsinfo psinfo;	 

	if (!current->dumpable ||
	    limit < 4096  ||
	    (( &current->mm->count )->counter)  != 1)
		return 0;
	current->dumpable = 0;





	 
	segs = 0;
	size = 0;
	for(vma = current->mm->mmap; vma != ((void *) 0) ; vma = vma->vm_next) {
		if (maydump(vma))
		{
			unsigned long sz = vma->vm_end-vma->vm_start;

			if (size+sz >= limit)
				break;
			else
				size += sz;
		}

		segs++;
	}




	 
	memcpy(elf.e_ident, "\177ELF" , 4 );
	elf.e_ident[4 ] = 1  ;
	elf.e_ident[5 ] = 2  ;
	elf.e_ident[6 ] = 1 ;
	memset(elf.e_ident+ 7 , 0, 16 - 7 );

	elf.e_type = 4 ;
	elf.e_machine = 0xf00f  ;
	elf.e_version = 1 ;
	elf.e_entry = 0;
	elf.e_phoff = sizeof(elf);
	elf.e_shoff = 0;
	elf.e_flags = 0;
	elf.e_ehsize = sizeof(elf);
	elf.e_phentsize = sizeof(struct elf32_phdr );
	elf.e_phnum = segs+1;		 
	elf.e_shentsize = 0;
	elf.e_shnum = 0;
	elf.e_shstrndx = 0;

	fs = (current->tss.fs) ;
	(current->tss.fs = ( ((mm_segment_t) { 0 })  )) ;
	memcpy(corefile,"core.",5);



	corefile[4] = '\0';

	dentry = open_namei(corefile, 0100  | 2 | 01000  | 0100000 , 0600);
	if (((unsigned long)( dentry ) > (unsigned long)(-1000)) ) {
		dentry = ((void *) 0) ;
		goto end_coredump;
	}
	inode = dentry->d_inode;

	if(inode->i_nlink > 1)
		goto end_coredump;	 

	if (! ((( inode->i_mode ) & 00170000 ) == 0100000 ) )
		goto end_coredump;
	if (!inode->i_op || !inode->i_op->default_file_ops)
		goto end_coredump;
	if (init_private_file(&file, dentry, 3))
		goto end_coredump;
	if (!file.f_op->write)
		goto close_coredump;
	has_dumped = 1;
	current->flags |= 0x00000200 ;

	if (!dump_write(&file, ( &elf ), (  sizeof(elf) ))) goto close_coredump; ;
	offset += sizeof(elf);				 
	offset += (segs+1) * sizeof(struct elf32_phdr );	 

	 



	memset(&psinfo, 0, sizeof(psinfo));
	memset(&prstatus, 0, sizeof(prstatus));

	notes[0].name = "CORE";
	notes[0].type = 1 ;
	notes[0].datasz = sizeof(prstatus);
	notes[0].data = &prstatus;
	prstatus.pr_info.si_signo = prstatus.pr_cursig = signr;
	prstatus.pr_sigpend = current->signal.sig[0];
	prstatus.pr_sighold = current->blocked.sig[0];
	psinfo.pr_pid = prstatus.pr_pid = current->pid;
	psinfo.pr_ppid = prstatus.pr_ppid = current->p_pptr->pid;
	psinfo.pr_pgrp = prstatus.pr_pgrp = current->pgrp;
	psinfo.pr_sid = prstatus.pr_sid = current->session;
	prstatus.pr_utime.tv_sec = (( current->times.tms_utime ) / 100 ) ;
	prstatus.pr_utime.tv_usec = ((( current->times.tms_utime ) % 100 ) * 1000000/ 100 ) ;
	prstatus.pr_stime.tv_sec = (( current->times.tms_stime ) / 100 ) ;
	prstatus.pr_stime.tv_usec = ((( current->times.tms_stime ) % 100 ) * 1000000/ 100 ) ;
	prstatus.pr_cutime.tv_sec = (( current->times.tms_cutime ) / 100 ) ;
	prstatus.pr_cutime.tv_usec = ((( current->times.tms_cutime ) % 100 ) * 1000000/ 100 ) ;
	prstatus.pr_cstime.tv_sec = (( current->times.tms_cstime ) / 100 ) ;
	prstatus.pr_cstime.tv_usec = ((( current->times.tms_cstime ) % 100 ) * 1000000/ 100 ) ;

	 




	memcpy( prstatus.pr_reg ,   regs , sizeof(struct _i370_interrupt_state_s ) < sizeof(elf_gregset_t)? sizeof(struct _i370_interrupt_state_s ): sizeof(elf_gregset_t)); 
# 1218 "fs/binfmt_elf.c"







	notes[1].name = "CORE";
	notes[1].type = 3 ;
	notes[1].datasz = sizeof(psinfo);
	notes[1].data = &psinfo;
	i = current->state ? ffz(~current->state) + 1 : 0;
	psinfo.pr_state = i;
	psinfo.pr_sname = (i < 0 || i > 5) ? '.' : "RSDZTD"[i];
	psinfo.pr_zomb = psinfo.pr_sname == 'Z';
	psinfo.pr_nice = current->priority-15;
	psinfo.pr_flag = current->flags;
	psinfo.pr_uid = current->uid;
	psinfo.pr_gid = current->gid;
	{
		int i, len;

		(current->tss.fs = ( fs )) ;

		len = current->mm->arg_end - current->mm->arg_start;
		if (len >= (80) )
			len = (80) -1;
		copy_from_user(&psinfo.pr_psargs,
			      (const char *)current->mm->arg_start, len);
		for(i = 0; i < len; i++)
			if (psinfo.pr_psargs[i] == 0)
				psinfo.pr_psargs[i] = ' ';
		psinfo.pr_psargs[len] = 0;

		(current->tss.fs = ( ((mm_segment_t) { 0 })  )) ;
	}
	strncpy(psinfo.pr_fname, current->comm, sizeof(psinfo.pr_fname));

	notes[2].name = "CORE";
	notes[2].type = 4 ;
	notes[2].datasz = sizeof(*current);
	notes[2].data = current;

	 
	prstatus.pr_fpvalid = dump_fpu (regs, &fpu);
	if (!prstatus.pr_fpvalid)
	{
		numnote--;
	}
	else
	{
		notes[3].name = "CORE";
		notes[3].type = 2 ;
		notes[3].datasz = sizeof(fpu);
		notes[3].data = &fpu;
	}
	
	 
	{
		struct elf32_phdr  phdr;
		int sz = 0;

		for(i = 0; i < numnote; i++)
			sz += notesize(&notes[i]);

		phdr.p_type = 4 ;
		phdr.p_offset = offset;
		phdr.p_vaddr = 0;
		phdr.p_paddr = 0;
		phdr.p_filesz = sz;
		phdr.p_memsz = 0;
		phdr.p_flags = 0;
		phdr.p_align = 0;

		offset += phdr.p_filesz;
		if (!dump_write(&file, ( &phdr ), (  sizeof(phdr) ))) goto close_coredump; ;
	}

	 
	dataoff = offset = (((( offset )+((  4096  )-1))/(  4096  ))*(  4096  )) ;

	 
	for(vma = current->mm->mmap, i = 0;
		i < segs && vma != ((void *) 0) ; vma = vma->vm_next) {
		struct elf32_phdr  phdr;
		size_t sz;

		i++;

		sz = vma->vm_end - vma->vm_start;

		phdr.p_type = 1 ;
		phdr.p_offset = offset;
		phdr.p_vaddr = vma->vm_start;
		phdr.p_paddr = 0;
		phdr.p_filesz = maydump(vma) ? sz : 0;
		phdr.p_memsz = sz;
		offset += phdr.p_filesz;
		phdr.p_flags = vma->vm_flags & 0x0001  ? 0x4  : 0;
		if (vma->vm_flags & 0x0002 ) phdr.p_flags |= 0x2 ;
		if (vma->vm_flags & 0x0004 ) phdr.p_flags |= 0x1 ;
		phdr.p_align = 4096 ;

		if (!dump_write(&file, ( &phdr ), (  sizeof(phdr) ))) goto close_coredump; ;
	}

	for(i = 0; i < numnote; i++)
		if (!writenote(&notes[i], &file))
			goto close_coredump;

	(current->tss.fs = ( fs )) ;

	if (!dump_seek(&file, ( dataoff ))) goto close_coredump; ;

	for(i = 0, vma = current->mm->mmap;
	    i < segs && vma != ((void *) 0) ;
	    vma = vma->vm_next) {
		unsigned long addr = vma->vm_start;
		unsigned long len = vma->vm_end - vma->vm_start;

		i++;
		if (!maydump(vma))
			continue;



		if (!dump_write(&file, ( (void *)addr ), (  len ))) goto close_coredump; ;
	}

	if ((off_t) file.f_pos != offset) {
		 
		printk("elf_core_dump: file.f_pos (%ld) != offset (%ld)\n",
		       (off_t) file.f_pos, offset);
	}

 close_coredump:
	if (file.f_op->release)
		file.f_op->release(inode,&file);

 end_coredump:
	(current->tss.fs = ( fs )) ;
	dput(dentry);



	return has_dumped;
}


int __attribute__ ((__section__ (".text.init")))  init_elf_binfmt(void)
{
	return register_binfmt(&elf_format);
}

# 1389 "fs/binfmt_elf.c"

